//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Compile.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFCompile1 *FCompile1;

//---------------------------------------------------------------------------
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <dos.h>
#include <string.h>
//---------------------------------------------------------------------------
// CONSTANTES DE LAS ESTRUCTURAS DE DATOS DEL ANALISIS LEXICO SINTACTICO
#define MAX_TIPO  30
#define MAX_ORACION  512
#define MAX_SIMBOLO  20
#define MAX_PALABRA 30
//---------------------------------------------------------------------------
// ELEMENTOS DE LA GRAMATICA
#define ES_TERMINAL  1
#define ES_VARIABLE  2
#define ES_SEMANTICA  3
#define ES_ERROR  4
//---------------------------------------------------------------------------
// CONSTANTES LOGICAS
#define SI  1
#define NO  0
#define NO_HAY  -1
// -----------------------------------------------------------------------
// ESTRUCTURAS PARA EL ANALIZADOR LEXICO/SINTACTICO

typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;                         // PALABRA
    char tipo[MAX_TIPO+1] ;                  // CATEGORIA GRAMATICAL
} TipoLexico ;

typedef struct
{
    char vari[MAX_TIPO+1];                                 // AXIOMA
    char des[25][MAX_TIPO+1];                          // PRODUCCION
} TipoGram;                 // TIPO DE LAS PRODUCCIONES GRAMATICALES

typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;
    char tipo[MAX_TIPO+1];                     // TIPO DE LA PALABRA
} TipoCanonica;              // TIPO DE LA ORACION DIVIDIDA EN SIMBOLOS

typedef struct
{
    int nivel;                            // NIVEL DE INTERPRETACION
    int accion;                              // NUMERO DE ACCION
    int param_1;                                       // PARAMETROS
    int param_2;
    int param_3;
} TipoAccion;

typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;                         // PALABRA
} TipoId ;

typedef struct
{
    char *cadena ;
} TipoCadena ;


typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;                         // PALABRA
} TipoNum ;


// -----------------------------------------------------------------------
extern char NomArch[250] ;
// NOMBRES DE ARCHIVO:
extern char NomArchLex[] ;
extern char NomArchGram[] ;

// LINEA PARA PROCESAR REGISTROS
extern char Linea[MAX_ORACION + 1]
    ,*ALinea ;
extern char Palabra[MAX_PALABRA] ;
extern int IPalabra ,UPalabra ;

// LEXICO:
extern TipoLexico Lexico[50] ;
extern int ULexico ,ILexico ;

// GRAMATICA:
extern TipoGram gram[400] ;
extern int UGram ;

// ORACION:
extern char Oracion[MAX_ORACION + 1] ;
extern int IOracion ,UOracion ;

// ORACION CANONICA
extern int ICanonica, UCanonica ;

// TABLA DE ACCIONES DE INTERPRETACION:
extern TipoAccion Accion[2000] ;
extern int UAccion ,IAccion ;

extern TipoId Id[300] ;
extern int UId ,IId ;

extern char Valor[100][20] ;
extern int IValor, UValor ;
extern char ElArea[200] ;

extern FILE *canonico ,*texto ;

extern TipoCadena Cadena[200] ;
extern int UCadena ,ICadena ;

extern int CuentaWhile ;
extern int Pila[500] ;
extern int Tope ;

extern int CuentaIf ;
extern int PilaIf[500] ;
extern int TopeIf ;

extern TipoNum Numero[500] ;
extern int UNumero ,INumero ;

extern int PilaCond[500] ;
extern int TopeCond ;

extern char opers[6][8] = {{"CMP>"},{"CMP<"},{"CMP=="},{"CMP>="},{"CMP<="},{"CMP!="}};
extern int Lineas ;

//---------------------------------------------------------------------
//    PROTOTIPOS
void sim_CargaLexico( void );
void sim_CargaGramatica( void );
int sim_AnalisisLexico( char *nom_arch );
int ue_Cumple( char *vari, int nivel );
int ue_AnalisisSemantico( void );
int ue_Rutina( char *num_rut, int nivel, int i_canonica );
int sim_BuscaProduccion(char *variable, int i_gram);
void sim_LeeCanonica(int cual ,TipoCanonica *canonica);
int BuscaLexico(char *palabra);
int sim_QueEs( char simbolo_inicial );
int sim_Terminal( char *tipo_simb );
void sim_Restablece( int nivel );




//---------------------------------------------------------------------------
__fastcall TFCompile1::TFCompile1(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------
void ue_CargaGramatica( void )
{
int cuenta, pasar, ides;
FILE *archivo ;

    // ABRE EL archivo DE GRAMATICA
    strcpy(NomArchGram ,"lia-ue.grm");
    if( (archivo = fopen(NomArchGram ,"rt")) == NULL )
    {
        sprintf(ElArea ,"**** Falta el archivo de gramtica %s" ,NomArchGram);
        FCompile1->Box1->Items->Add(ElArea);
    }
    // LEE CADA PRODUCCION DE LA GRAMATICA
    for( UGram=0; fgets(Linea ,MAX_ORACION ,archivo) != NULL; )
    {
        // SI ES COMENTARIO, SALTARLO:
        if( *Linea == ';' )
            continue;
        // QUITA EL  FINAL:
        if( Linea[strlen(Linea) - 1] == '\n' )
            Linea[strlen(Linea) - 1] = '\0';
        // APUNTA AL INICIO DE LA LINEA LEIDA:
        ALinea = Linea;
        // SALTA ESPACIOS:
        for( ; *ALinea == ' '; ALinea++ )
            ;
        // TOMA UN SIMBOLO
        for( cuenta = 0; *(ALinea + cuenta) != ' ' &&
            *(ALinea + cuenta) != '\0'; cuenta++ )
            ;
        pasar = ( cuenta > MAX_TIPO ) ? MAX_TIPO : cuenta;
        strncpy(gram[UGram].vari ,ALinea ,pasar);
        gram[ UGram ].vari[ pasar ] = '\0';
        ALinea += cuenta;
        // SALTA ESPACIOS:
        for( ; *ALinea == ' '; ALinea++ )
            ;
        // SALTA LA FLECHA:
        for(;*ALinea!=' ' && *ALinea != '\0';ALinea++)
            ;
        // SALTA ESPACIOS:
        for( ; *ALinea == ' '; ALinea++ )
            ;
        // TOMA LOS COMPONENTES DE LA PRODUCCION:
        for( ides = 0; *ALinea; )
        {
            // SALTA ESPACIOS:
            for( ; *ALinea == ' '; ALinea++ )
                ;
            // TOMA SIMBOLO:
            for( cuenta = 0; *(ALinea + cuenta) != ' ' &&
             *(ALinea + cuenta) != '\0'; cuenta++ )
                ;
            if( cuenta > 0 )
            {
                pasar = ( cuenta > MAX_TIPO ) ? MAX_TIPO : cuenta;
                strncpy(gram[UGram].des[ides], ALinea, pasar);
                gram[UGram].des[ides][pasar] = '\0';
                ides++;
                ALinea += cuenta;
            }
        }
        // MARCA EL FIN DE LA PRODUCCION CON \0
        gram[UGram].des[ides][0] = '\0';
        UGram++;
    }

    fclose(archivo);
}
//---------------------------------------------------------------------------
int ue_AnalisisSintactico( void )
{

    if( (canonico = fopen("canonico.tmp" ,"rb")) == NULL )
    {
        sprintf(ElArea ,"**** hay alguna falla en el disco");
        FCompile1->Box1->Items->Add(ElArea);
    }
    Tope = 0;
    TopeIf = 0;
    CuentaWhile = 0;
    CuentaIf = 0;

    ICanonica = 0;
    UAccion = 0;
//   if( (sim_Cumple("INICIO", 1) == SI) && (ICanonica == UCanonica) )
   if( ue_Cumple("INICIO", 1) == SI )
   {
       fclose(canonico);
       return SI;
   }
   else
   {
       fclose(canonico);
       return NO;
   }
}

//---------------------------------------------------------------------
 int ue_Cumple( char *vari, int nivel )
{
char *simb_act;                                    // SIMBOLO EN PROCESO
int resul ,fin;                        // INDICADORES DE RESULTADO Y FIN
long i_canonica_ant;    // APUNTADOR A LA ENTRADA CUANDO INICIA EL NIVEL
int i_gram;
double pct ;
double xyz ;

    if( (i_gram = sim_BuscaProduccion(vari ,0)) == NO_HAY )
        return NO;

    i_canonica_ant = ICanonica;
    simb_act = (char *)gram[i_gram].des;
    for( resul = SI, fin = NO; !fin && (*simb_act != ' ') && (*simb_act != '\0'); )
    {
       switch( sim_QueEs(*simb_act) )
        {
        case ES_ERROR:
          //  FCompile1->Label6->Caption = "Error" + AnsiString(simb_act);
            FCompile1->Box1->Items->Add("Error "+ AnsiString(simb_act));
            FCompile1->Box1->Refresh();
           //s FCompile1->Label6->Refresh();
            break;
        case ES_TERMINAL:
            resul = sim_Terminal(simb_act);
            break;
        case ES_VARIABLE:
            resul = ue_Cumple(simb_act ,nivel + 1);
            if( resul == SI )          // ACCION PARA BLOQUEAR RETROCESO
            {
                Accion[UAccion].nivel = nivel;
                Accion[UAccion].accion = 0;
                UAccion++;
            }
            break;
        case ES_SEMANTICA:
            resul = ue_Rutina(simb_act ,nivel ,ICanonica - 1);
            break;
        default:
            fin = SI;
            resul = NO;
            break;    // SIMBOLO ERRONEO
        }
        if( fin == SI )
            break;
        if( resul == NO )
        {
            sim_Restablece(nivel);    // RESTABLECE Y BUSCA ALTERNATIVA
            i_gram = sim_BuscaProduccion(vari, i_gram + 1);
            if( i_gram == NO_HAY )     // SI NO HAY OPCION, TERMINA MAL
            {
                fin = SI;
            }
            else
            {                    // SI HAY, VUELVE A EMPEZAR LA REVISION
                simb_act = (char *)gram[i_gram].des;
                ICanonica = i_canonica_ant;
                resul = SI;
            }
        }
        else
            simb_act += (MAX_TIPO + 1);   // AVANZA AL SIGUIENTE SIMBOLO
    }
    if( resul == NO )
        sim_Restablece(nivel);

    pct = (double)ICanonica / (double)UCanonica * (double)100;
    if( ((int)pct % 10) == 0 )
    {
        //FCompile1->Label6->Caption = (int)pct;
        //FCompile1->Label6->Refresh();
    }
    return resul;
}

//---------------------------------------------------------------------
int ue_AnalisisSemantico( void )
{
FILE *sale ;
char ambito ,tipo ;
int ultimo_while ;
int asignar ,indice ;
char resultado[100] ;
char unidad[50] ,evento[50];
char nombre_cod[200] ;
int ucod ,icod ;


    strcpy(nombre_cod ,NomArch);
    ucod = strlen(nombre_cod);

    // BUSCA EL PUNTO O UNA DIAGONAL O QUE ucod VALE CERO
    for( ; (ucod > 0) && ((nombre_cod[ucod] != '.') && (nombre_cod[ucod] != '\\')) ; ucod-- )
     ;
    if( ucod < 1 )
    {
        strcpy(nombre_cod ,"prog.cod");
    }
    else
        if( nombre_cod[ucod] == '.' )
        {
           nombre_cod[ucod] = '\0';
           strcat(nombre_cod ,".cod");
        }
        else
            strcat(nombre_cod ,".cod");


    sale = fopen(nombre_cod ,"wt");
    // se obtiene evento.cod


    if( sale == NULL )
    {
        return NO;
    }
    for( IAccion = 0; IAccion < UAccion; IAccion++ )
    {
        switch( Accion[IAccion].accion )
        {
        case 1:
            strcpy(unidad ,Lexico[Accion[IAccion].param_1].simbolo);
            if( strncmp(unidad ,"glo" ,3) == 0 )
                ambito = 'G';
            else
            if( strncmp(unidad ,"reg" ,3) == 0 )
                ambito = 'R';
            else
            if( strncmp(unidad ,"intern" ,6) == 0 )
                ambito = 'I';
            else
            if( strncmp(unidad ,"loc" ,3) == 0 )
                ambito = 'L';
            else
            if( strncmp(unidad ,"pur" ,3) == 0 )
                ambito = 'p';
            else
            if( strncmp(unidad ,"per" ,3) == 0 )
                ambito = 'E';
            else
            if( strncmp(unidad ,"age" ,3) == 0 )
                ambito = 'A';
            else
            if( strncmp(unidad ,"act" ,3) == 0 )
                ambito = 'a';
            else
            if( strncmp(unidad ,"ini" ,3) == 0 )
                ambito = 'S';
            else
            if( strncmp(unidad ,"req" ,3) == 0 )
                ambito = 'r';
            else
            if( strncmp(unidad ,"rol" ,3) == 0 )
                ambito = 'P';
            else
            if( strncmp(unidad ,"intera" ,6) == 0 )
                ambito = 'i';
            break;
        case 2:
            strcpy(unidad ,Lexico[Accion[IAccion].param_1].simbolo);
            if( strncmp(unidad ,"int" ,3) == 0 )
                tipo = 'E';
            else
            if( strncmp(unidad ,"cha" ,3) == 0 )
                tipo = 'A';
            else
            if( strncmp(unidad ,"flo" ,3) == 0 )
                tipo = 'F';
            else
            if( strncmp(unidad ,"por" ,3) == 0 )
                tipo = 'P';
            break;
        case 3:
            fprintf(sale ,"%c %c %s %d %d\n" ,ambito ,tipo
              ,Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2
              ,Accion[IAccion].param_3);
            break;
        case 4:
            fprintf(sale ,"%c %c %s %d\n" ,ambito ,tipo
              ,Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2);
            break;
        case 5:
            fprintf(sale ,"%c %c %s\n" ,ambito ,tipo
              ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 6:
            fprintf(sale ,"%c %s\n" ,ambito
              ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 7:
            fprintf(sale ,"m main\n");
            break;
        case 8:
            fprintf(sale ,"INICIO\n");
            break;
        case 9:
            fprintf(sale ,"STOP\n");
            break;
        case 10:
            fprintf(sale ,"c %d\n" , Accion[IAccion].param_1);
            break;
        case 11:
            fprintf(sale ,"Pr $%d\n" ,Accion[IAccion].param_1);

            break;
        case 12:
            fprintf(sale ,"CMP R 0\nJEQ finif%d\n",Accion[IAccion].param_1);
            break;
        case 13:
            fprintf(sale ,":finif%d\n",Accion[IAccion].param_1);
            break;
        case 14:
            fprintf(sale ,":whi%d\n",Accion[IAccion].param_1);
            ultimo_while = Accion[IAccion].param_1;
            break;
        case 15:
            fprintf(sale ,"CLRSTK\n");
            break;
        case 17:
            fprintf(sale ,"POPs R\nCMP R 0\nJEQ finw%d\n", ultimo_while);
            break;
        case 18:
            fprintf(sale ,"JMP whi%d\n:finw%d\n",Accion[IAccion].param_1,Accion[IAccion].param_1);
            break;
        case 19:
            fprintf(sale ,"CREAA %s %s\n" ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 20:
            fprintf(sale ,"CREAI %s %s\n" ,Id[Accion[IAccion].param_1].simbolo ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 21:
            fprintf(sale ,"APROP %s %s\n" ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 23:
            fprintf(sale ,"%s" ,resultado); break;
        case 24:
            fprintf(sale ,"PUSHn %d\n",Accion[IAccion].param_1);
            break;
        case 25:
            fprintf(sale ,"POPs tA\nPOPs tB\nSUMA tA tB\nPUSHs R\n");
            break;
        case 26:
            fprintf(sale ,"POPs tA\nPOPs tB\nRESTA tA tB\nPUSHs R\n");
            break;
        case 27:
            fprintf(sale ,"POPs tA\nPOPs tB\nMULT tA tB\nPUSHs R\n");
            break;
        case 28:
            fprintf(sale ,"POPs tA\nPOPs tB\nDIV tA tB\nPUSHs R\n");
            break;
        case 29:
            fprintf(sale ,"PUSHv %s\n" ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 30:
            fprintf(sale ,"PUSHvi %s %s\n" ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 31:
            fprintf(sale ,"PUSHvij %s %s %s\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo
              ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 32:
            fprintf(sale ,"POPs tA\nPOPs tB\nOR tA tB\nPUSHs R\n");
            break;
        case 33:
            fprintf(sale ,"POPs tA\nPOPs tB\nAND tA tB\nPUSHs R\n");
            break;
        case 34:
            fprintf(sale ,"POPs tB\nPOPs tA\n%s tA tB\nPUSHs R\n" ,
              opers[Accion[IAccion].param_1 - 1]);
            break;
        case 41:
            sprintf(resultado ,"POPvij %s %s %s\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo
              ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 42:
            sprintf(resultado ,"POPvi %s %s\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 43:
            sprintf(resultado ,"POPvI %s %d\n"
              ,Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2);
            break;
        case 44:
            sprintf(resultado ,"POPv %s\n",Id[Accion[IAccion].param_1].simbolo);
            break;
        case 45:
            fprintf(sale ,"WAIT %d\n",Accion[IAccion].param_1);
            break;
        case 46: // append id cadena
            fprintf(sale ,"STRCAT$ %s $%d\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Accion[IAccion].param_2);
            break;
        case 47: // append id id
            fprintf(sale ,"STRCAT %s %s\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 48:
        case 51:
            fprintf(sale ,"MOVSTR %s $%d\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Accion[IAccion].param_2);
            break;
        case 49:
            fprintf(sale ,"PrId %s\n" ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 50:
            ambito = 'O';
            break;
        case 52: // out 1
            fprintf(sale ,"OUT %s %s %s"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo
              ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 53: // out 2
            fprintf(sale ," %s %s\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 54: // accept 1
            fprintf(sale ,"ACCEPT %s %s %s"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo
              ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 55: // accept 2
            fprintf(sale ," %s\n"
              ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 56:
            fprintf(sale ,"EXTRACT %s %s %s\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo
              ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 57:
            fprintf(sale ,"COMPARE %s %s %s\n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo
              ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 58:
            fprintf(sale ,"DELMSG %s %s \n"
              ,Id[Accion[IAccion].param_1].simbolo
              ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 59:
            fprintf(sale ,"PLAN\n");
            break;
        case 60:
            fprintf(sale ,"PARAM %s\n"
              ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 61:
            fprintf(sale ,"GOAL %s\n"
              ,Id[Accion[IAccion].param_1].simbolo);
            break;


       }
    }
    for( ICadena = 0; ICadena < UCadena; ICadena++ )
        fprintf(sale ,"l$ %s\n" ,Cadena[ICadena]);
    fclose(sale);
}
//---------------------------------------------------------------------
int ue_Rutina( char *num_rut, int nivel, int i_canonica )
{
TipoCanonica canonica ;
int cualw ,cualif ;

    Accion[UAccion].nivel = nivel;
    Accion[UAccion].accion = atoi(num_rut);
    switch( atoi(num_rut) )
    {
        case 1: // ambito
        case 2: // tipo
            sim_LeeCanonica(ICanonica - 1 ,&canonica);
            Accion[UAccion].param_1 = BuscaLexico(canonica.simbolo);
            break;
        case 3: // id indice1 indice2
        case 31: // push id[i][j]
        case 41: // resultado id[i][j]
            sim_LeeCanonica(ICanonica - 7 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            sim_LeeCanonica(ICanonica - 5 ,&canonica);
            Accion[UAccion].param_2 = atoi(canonica.simbolo);
            sim_LeeCanonica(ICanonica - 2 ,&canonica);
            Accion[UAccion].param_3 = atoi(canonica.simbolo);
            break;
        case 4: // id indice
        case 19: // addagent
        case 30: // push id[i]
        case 42: // resultado id[i]
        case 43: // resultado id[I] donde I es nmero
        case 48: // id := cadena
            sim_LeeCanonica(ICanonica - 4 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            sim_LeeCanonica(ICanonica - 2 ,&canonica);
            Accion[UAccion].param_2 = atoi(canonica.simbolo);
            break;
        case 5: // id
        case 6: // id
        case 44: // resultado id
            sim_LeeCanonica(ICanonica - 1 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            break;
        case 7: // main
        case 8: // inicio de papel
        case 9: // fin de papel (stop)
        case 15: // while segunda parte
        case 17: // while cuarta parte
        case 23: // fin de expresion aritmetica
        case 25: // suma
        case 26: // resta
        case 27: // multiplicacin
        case 28: // divisin
        case 32: // expresin lgica OR
        case 33: // expresin lgica AND
        case 50: // adicionar un proposito a un agente
        case 59: // fin de la creacion de un agente
            break;
        case 11: // instruccion print cadena
        case 10: // instancias de un papel
        case 49: // print id
            sim_LeeCanonica(ICanonica - 1 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            break;
        case 12: // if then
            PilaIf[TopeIf] = CuentaIf;
            TopeIf++;
            CuentaIf++;
            Accion[UAccion].param_1 = CuentaIf - 1;
            break;
        case 13: // end if then
            TopeIf--;
            cualif = PilaIf[TopeIf];
            Accion[UAccion].param_1 = cualif;
            break;
        case 14: // inicio de while
            Pila[Tope] = CuentaWhile;
            Tope++;
            CuentaWhile++;
            Accion[UAccion].param_1 = CuentaWhile - 1;
            break;
        case 16: // tercera parte while
            TopeCond = 0;
            break;
        case 18: // fin while
            Tope--;
            cualw = Pila[Tope];
            Accion[UAccion].param_1 = cualw;
            break;
        case 20: // addinteraction
        case 21: // addpurpose
        case 22: // delpurpose
              sim_LeeCanonica(ICanonica - 3 ,&canonica);
              Accion[UAccion].param_2 = atoi(canonica.simbolo);
              sim_LeeCanonica(ICanonica - 5 ,&canonica);
              Accion[UAccion].param_1 = atoi(canonica.simbolo);
              break;
        case 24: // push nmero
        case 29: // push variable
        case 55: // accept 2
              sim_LeeCanonica(ICanonica - 1 ,&canonica);
              Accion[UAccion].param_1 = atoi(canonica.simbolo);
              break;
        case 34:
            TopeCond--;
            Accion[UAccion].param_1 = PilaCond[TopeCond];
            break;
        case 35:  PilaCond[TopeCond] = 1; TopeCond++; break;
        case 36:  PilaCond[TopeCond] = 2; TopeCond++; break;
        case 37:  PilaCond[TopeCond] = 3; TopeCond++; break;
        case 38:  PilaCond[TopeCond] = 4; TopeCond++; break;
        case 39:  PilaCond[TopeCond] = 5; TopeCond++; break;
        case 40:  PilaCond[TopeCond] = 6; TopeCond++; break;
        case 45:
            sim_LeeCanonica(ICanonica - 3 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            break;
        case 52: // out 1
        case 54: // accept 1
        case 56: // extract
        case 57: // compare
            sim_LeeCanonica(ICanonica - 5 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            sim_LeeCanonica(ICanonica - 3 ,&canonica);
            Accion[UAccion].param_2 = atoi(canonica.simbolo);
            sim_LeeCanonica(ICanonica - 1 ,&canonica);
            Accion[UAccion].param_3 = atoi(canonica.simbolo);
            break;
        case 46: // append id cadena
        case 47: // append id id
        case 51: // id := cadena
        case 53: // out 2
        case 58: // delmessage
            sim_LeeCanonica(ICanonica - 3 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            sim_LeeCanonica(ICanonica - 1 ,&canonica);
            Accion[UAccion].param_2 = atoi(canonica.simbolo);
            break;
        case 60:
        case 61:
            sim_LeeCanonica(ICanonica - 1 ,&canonica);
            Accion[UAccion].param_1 = atoi(canonica.simbolo);
            break;

/*
    case 1: // ambito
    case 2: // tipo
        sim_LeeCanonica(ICanonica - 1 ,&canonica);
        Accion[UAccion].param_1 = BuscaLexico(canonica.simbolo);
        break;
    case 3: // id indice1 indice2
    case 31: // push id[i][j]
    case 41: // resultado id[i][j]
        sim_LeeCanonica(ICanonica - 7 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 5 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 2 ,&canonica);
        Accion[UAccion].param_3 = atoi(canonica.simbolo);
        break;
    case 4: // id indice
    case 30: // push id[i]
    case 42: // resultado id[i]
    case 43: // resultado id[I] donde I es nmero
        sim_LeeCanonica(ICanonica - 4 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 2 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        break;
    case 5: // id
    case 6: // id
    case 44: // resultado id
        sim_LeeCanonica(ICanonica - 1 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;
    case 7: // main
    case 8: // inicio de papel
    case 9: // fin de papel (stop)
    case 15: // while segunda parte
    case 17: // while cuarta parte
    case 23: // fin de expresion aritmetica
    case 25: // suma
    case 26: // resta
    case 27: // multiplicacin
    case 28: // divisin
    case 32: // expresin lgica OR
    case 33: // expresin lgica AND
        break;
    case 11: // instruccion print cadena
    case 10: // instancias de un papel
        sim_LeeCanonica(ICanonica - 1 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;
    case 12: // if then
        PilaIf[TopeIf] = CuentaIf;
        TopeIf++;
        CuentaIf++;
        Accion[UAccion].param_1 = CuentaIf - 1;
        break;
    case 13: // end if then
        TopeIf--;
        cualif = PilaIf[TopeIf];
        Accion[UAccion].param_1 = cualif;
        break;
    case 14: // inicio de while
        Pila[Tope] = CuentaWhile;
        Tope++;
        CuentaWhile++;
        Accion[UAccion].param_1 = CuentaWhile - 1;
        break;
    case 16: // tercera parte while
        TopeCond = 0;
        break;
    case 18: // fin while
        Tope--;
        cualw = Pila[Tope];
        Accion[UAccion].param_1 = cualw;
        break;
    case 19: // addagent
    case 20: // addinteraction
    case 21: // addpurpose
    case 22: // delpurpose
          sim_LeeCanonica(ICanonica - 3 ,&canonica);
          Accion[UAccion].param_2 = atoi(canonica.simbolo);
          sim_LeeCanonica(ICanonica - 5 ,&canonica);
          Accion[UAccion].param_1 = atoi(canonica.simbolo);
          break;
    case 24: // push nmero
    case 29: // push variable
          sim_LeeCanonica(ICanonica - 1 ,&canonica);
          Accion[UAccion].param_1 = atoi(canonica.simbolo);
          break;
    case 34:
        TopeCond--;
        Accion[UAccion].param_1 = PilaCond[TopeCond];
        break;
    case 35:  PilaCond[TopeCond] = 1; TopeCond++; break;
    case 36:  PilaCond[TopeCond] = 2; TopeCond++; break;
    case 37:  PilaCond[TopeCond] = 3; TopeCond++; break;
    case 38:  PilaCond[TopeCond] = 4; TopeCond++; break;
    case 39:  PilaCond[TopeCond] = 5; TopeCond++; break;
    case 40:  PilaCond[TopeCond] = 6; TopeCond++; break;
    case 45:
        sim_LeeCanonica(ICanonica - 3 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;
*/

    }
    UAccion++;
    return SI;
}
//---------------------------------------------------------------------


void __fastcall TFCompile1::inicio(TObject *Sender)
{
  FCompile1->Refresh();
    Edit1->Text = "";
    UId = 0;
    Box1->Clear();
    Box1->Items->Add("Inicio la traduccin");
    Box1->Refresh();

    sim_CargaLexico();
    Box1->Items->Add("Palabras reservadas... bien");
    Box1->Refresh();

    ue_CargaGramatica();
    Box1->Items->Add("Gramtica... bien");
    Box1->Refresh();
    switch( sim_AnalisisLexico(NomArch) )
    {
    case NO:
         FCompile1->Box1->Items->Add("**** Hay simbolos desconocidos");
         return;
    case NO_HAY:
         FCompile1->Box1->Items->Add("**** No existe el archivo");
         return;
    }
    Box1->Items->Add("Traducido... bien");
    Box1->Refresh();
    // AHORA APLICA EL ANALISIS SINTACTICO
    switch( ue_AnalisisSintactico() )
    {
    case NO:
         FCompile1->Box1->Items->Add("**** Error de sintaxis");
         return;
    }
    Box1->Items->Add("Sintaxis correcta");
    Box1->Refresh();
    ue_AnalisisSemantico();    
}
//---------------------------------------------------------------------------

void __fastcall TFCompile1::ACEPTARClick(TObject *Sender)
{
 FCompile1 -> Close();    
}
//---------------------------------------------------------------------------

