/*

VARIABLES Y FUNCIONES PARA EL MANEJO DE EVENTOS INESPERADOS

MA. DEL CARMEN DOMINGUEZ AYALA

ENERO 2001


*/

#include "ejecuta.h"
#include "mei.h"

#define TABLA_COMPATIBILIDAD  15         //usado en MEI
#define NUM_REACCIONES 25
#define NUM_EVENTO_REAC 32
#define MAX_COMPATIBLE  15
#define ACCION_X_AGENTE  50
#define MAX_SUSPENDIDAS  50
#define MAX_PEDAZOS  15

typedef struct
{
    int id_evento;
    char nombre[40];
    char lugar[50];
    int duracion;
    tm fecha_hora;
    long fecha_tiempo;
    int id_comporta ;
    char comporta[2000];
} TipoMEI;

//-------------------------------------------
// ESTRUCTURAS DE MEI
//-------------------------------------------
// Estructura utilizada para guardar las acciones que son compatibles
// con los eventos
typedef struct {
  char nom_accion[MAX_PALABRA];
  int array_compa[MAX_COMPATIBLE];
}reg_compatible;


// Estructura utilizada para guardar los requesitos que necesitan las
// reacciones de los eventos para que se activen.
typedef struct {
  //char nom_event[MAX_PALABRA];
  //int array_req[MAX_COMPATIBLE];
  char requisito[MAX_PALABRA];
  int num_requisito;
}reg_requisito;

/*// Estructura que guarda la accion y numero de accin que se refieren a los
// papeles iniciales del agente
typedef struct {
  int num_accion;
  char accion[MAX_PALABRA];
}reg_accion;*/


// Estructura utilizada para guardar las reacciones, requisito y evento
// que necesitan los agentes para reaccionar ante los eventos.
typedef struct {
  int num_reaccion;
  char accion[MAX_PALABRA];
  char requisito[MAX_PALABRA];
  long duracion;
}reg_reaccion;


// Estructura utilizada para guardar las reacciones, requisito y evento
// que necesitan los agentes para reaccionar ante los eventos.
typedef struct {
  int num_reaccion;
  char nom_event[MAX_PALABRA];
}reg_eventoReaccion;



// Estructura utilizada para guardar las hebras que estan activas con
// su respectivo nombre de agente y estado de la hebra
 typedef struct
  {
   char papelArray[MAX_PALABRA]; //fila
   int edo_hebra;
  } TipoHebraEstado;

  typedef struct
  {
    char nom_agente[MAX_PALABRA];
    int ejecutar;
    TipoHebraEstado HebraEdo[ACCION_X_AGENTE];
  }TipoArreglo;

  //Estructura utilizada para seleccionar el pedazo de comportamiento
  //referente al evento
  typedef struct
  {
   char nom_evento[MAX_PALABRA]; //fila
   char varInterna[MAX_PALABRA];
   TipoPapel *papel ;
  } TipoCodeComporta;

//---------------------------------------------------------------------------
extern char RelojFormateado[50] ;
extern TipoPapel *PapelNueva ;
extern TipoHebra *HebraNueva ;
extern TipoMain Main ;
extern TipoHebra *ColaInicio ;

// Arreglo de compatibilidad
  reg_compatible tabla_Compat[TABLA_COMPATIBILIDAD];

// Arreglo de requisitos
  //reg_requisito tabla_Requisitos[TABLA_COMPATIBILIDAD];

// Arreglo de reacciones y requisitos
  //reg_accion tabla_Reacciones[TABLA_COMPATIBILIDAD];

// Arreglo de acciones
//  reg_accion Acciones[NUM_ACCIONES];

// Arreglo de requisitos
  reg_requisito Requisitos[TABLA_COMPATIBILIDAD];

// Arreglo de numero de reaccin,reaccion y requisitos
  reg_reaccion Reacciones[NUM_REACCIONES];

// Arreglo de numero de reaccion y eventos
  reg_eventoReaccion EventoReaccion[NUM_EVENTO_REAC];

// Arreglo de hebras suspendidas
  TipoArreglo HebraSuspendidas[MAX_SUSPENDIDAS];

// Arreglo de comportamientos ordenados de acuerdo a sus variables internas
  TipoCodeComporta ComportaOrdenados[MAX_PEDAZOS];

int percibe;

// Estructura utilizada para guardar las acciones  que se pueden
// tomar de acuerdo a los eventos activos
/*char *Acciones[] = {"escucharadio", "cocinar", "comer",
                    "estudiar", "dormir", "exponer", "ver_tv",
                    "caminando", "correr", "gritar", "llorar",
                    "cantar", "reir" };                       */

/*char *Requisitos[] = {"paraguas", "impermeable", "lugar_techado",
                    "lugarseguro", "enfermo", "heridos", "casa",
                    "carro", "vacaciones", "telefono", "asustado",
                    "sueo", "ninguno" };   */


/*char *Reacciones[] = {"abrirParaguas", "usarImpermeable", "correraLugarTechado",
                    "permanecerDondeEsta", "desmayarse", "llamaralaFamilia",
                    "llamaralaAmbulancia","comprarCasa", "comprarCarro",
                    "viajar", "ahorrar","llamarPolicia", "llorar","tomarCafe",
                    "quedarsePasmado" };  */


//---------------------------------------------------------------------------
// VARIABLES PARA EVENTOS INESPERADOS
TipoMain Mei;
extern TipoIdHebra *IdHebraNueva;
char reaccion_nueva[20]; // VARIABLE QUE TIENE LA NUEVA REACCION QUE SE INSERTO
                      // EN LA COLA DE EJECUCION POR EL EVENTO ACTIVO

//---------------------------------------------------------------------------
void fecha_FormateaDMAhms(int d ,int m ,int a ,int ho ,int mi ,int se ,char *RelojFormateado);
void sim_InsertaEjecucion(TipoHebra *hebra);
int BuscarRequisito(int num_requisito, TipoAgente *agente);
//---------------------------------------------------------------------------
void CargaEventosInesperados(void)
{
FILE *amei ;
TipoMEI Evento;
long u_mei ,i_mei ;
int d,m,a,ho,mi,se;

    amei = fopen("Evento.txt","rb");
    if( amei == NULL )
        return;
    fseek(amei ,0 ,SEEK_END);
    u_mei = ftell(amei) / sizeof(TipoMEI);
    Fejecuta->Grid1->RowCount = u_mei + 1;
    Fejecuta->Grid1->Cells[0][0] = "#";
    Fejecuta->Grid1->Cells[1][0] = "Date Time";
    Fejecuta->Grid1->Cells[2][0] = "Event";
    Fejecuta->Grid1->Cells[3][0] = "Duration";
    Fejecuta->Grid1->Refresh();
    for( i_mei = 0L; i_mei < u_mei; i_mei++ )
    {
        fseek(amei ,i_mei * sizeof(TipoMEI) ,SEEK_SET);
        fread((char *)&Evento ,sizeof(TipoMEI) ,1 ,amei);
        Fejecuta->Grid1->Cells[0][i_mei + 1] = i_mei + 1;

        s_a_DMAhms(Evento.fecha_tiempo ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        Fejecuta->Grid1->Cells[1][i_mei + 1] = RelojFormateado;
        Fejecuta->Grid1->Cells[2][i_mei + 1] = Evento.nombre;
        Fejecuta->Grid1->Cells[3][i_mei + 1] = Evento.duracion;
        Fejecuta->Grid1->Refresh();
        // CREA UN PAPEL PARA EL EVENTO INESPERADO
        PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel) + 1);
        strcpy(PapelNueva->nombre ,Evento.nombre);
        PapelNueva->cupo = 0;
        PapelNueva->usados = 0;
        PapelNueva->requisito = NULL;
        PapelNueva->local = NULL;
        // SE ASIGNAN LAS INSTRUCCIONES A EJECUTAR EL PAPEL
        PapelNueva->u_instruccion = 4;
        PapelNueva->instruccion =(TipoInstruccion *)malloc(sizeof(TipoInstruccion) * 4);
        strcpy(PapelNueva->instruccion[0].opcode ,"IMEI");
        strcpy(PapelNueva->instruccion[0].op1 ,"");
        strcpy(PapelNueva->instruccion[0].op2 ,"");
        strcpy(PapelNueva->instruccion[0].op3 ,"");

        strcpy(PapelNueva->instruccion[1].opcode ,"WAIT");
        sprintf(PapelNueva->instruccion[1].op1 ,"%d" ,Evento.duracion);
        strcpy(PapelNueva->instruccion[1].op2 ,"");
        strcpy(PapelNueva->instruccion[1].op3 ,"");

        strcpy(PapelNueva->instruccion[2].opcode ,"FMEI");
        strcpy(PapelNueva->instruccion[2].op1 ,"");
        strcpy(PapelNueva->instruccion[2].op2 ,"");
        strcpy(PapelNueva->instruccion[2].op3 ,"");

        strcpy(PapelNueva->instruccion[3].opcode ,"STOP");
        strcpy(PapelNueva->instruccion[3].op1 ,"");
        strcpy(PapelNueva->instruccion[3].op2 ,"");
        strcpy(PapelNueva->instruccion[3].op3 ,"");
        PapelNueva->sig = NULL;

        if( Mei.papel == NULL )
            Mei.papel = PapelNueva;
        else
        {
            PapelNueva->sig = Mei.papel;
            Mei.papel = PapelNueva;
        }
        // INSERTA UNA HEBRA EN LA COLA DE EJECUCION PARA EL EVENTO INESPERADO
        HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
        HebraNueva->tiempo = Evento.fecha_tiempo;
        HebraNueva->PC = 0;
        HebraNueva->estado = 0;
        HebraNueva->papel = Mei.papel;
        HebraNueva->proposito = NULL;
        HebraNueva->stack = NULL;
        HebraNueva->agente = NULL;
        HebraNueva->sig = NULL;
        HebraNueva->local = NULL;

        if( Mei.hebra == NULL )
            Mei.hebra = HebraNueva;
        else
        {
            HebraNueva->sig = Mei.hebra;
            Mei.hebra = HebraNueva;
        }
        sim_InsertaEjecucion(HebraNueva);
    }
    fclose(amei);
}

//---------------------------------------------------------------------------
// Carga el arbol de eventos con sus comportamientos
//------------------------------------------------
void CargarArbol(void)
{
  /*ifstream   nodeFile;
  TTreeNode* curNode;
  TTreeNode* nxtNode;
  SaveNode   savNode;
  reg_arbol_gral eventStruct;
  reg_arbol_gral* eStr;
  entryValue curLvl;*/

  Fejecuta->TreeView4->LoadFromFile("arbol.ue");
}



//------------------------------------------------------------------------------
// Llenar tabla de reacciones
void LlenarReacciones()
{
Reacciones[0].num_reaccion=0;
strcpy(Reacciones[0].accion,"open_umbrella");
strcpy(Reacciones[0].requisito,"umbrella");
Reacciones[0].duracion=5;

Reacciones[1].num_reaccion=1;
strcpy(Reacciones[1].accion,"wear_raincoat");
strcpy(Reacciones[1].requisito,"raincoat");
Reacciones[1].duracion=10;

Reacciones[2].num_reaccion=2;
strcpy(Reacciones[2].accion,"run_cover_place");
strcpy(Reacciones[2].requisito,"cover_place");
Reacciones[2].duracion=15;

Reacciones[3].num_reaccion=3;
strcpy(Reacciones[3].accion,"stay_there");
strcpy(Reacciones[3].requisito,"safe_place");
Reacciones[3].duracion=1;

Reacciones[4].num_reaccion=4;
strcpy(Reacciones[4].accion,"faint");
strcpy(Reacciones[4].requisito,"sick");
Reacciones[4].duracion=22;

Reacciones[5].num_reaccion=5;
strcpy(Reacciones[5].accion,"call_ambulance");
strcpy(Reacciones[5].requisito,"wounded_person");
Reacciones[5].duracion=30;

Reacciones[6].num_reaccion=6;
strcpy(Reacciones[6].accion,"buy_house");
strcpy(Reacciones[6].requisito,"money");
Reacciones[6].duracion=300;

Reacciones[7].num_reaccion=7;
strcpy(Reacciones[7].accion,"buy_car");
strcpy(Reacciones[7].requisito,"money");
Reacciones[7].duracion=300;

Reacciones[8].num_reaccion=8;
strcpy(Reacciones[8].accion,"travel");
strcpy(Reacciones[8].requisito,"vacation");
Reacciones[8].duracion=86400;

Reacciones[9].num_reaccion=9;
strcpy(Reacciones[9].accion,"save_money");
strcpy(Reacciones[9].requisito,"money");
Reacciones[9].duracion=300;

Reacciones[10].num_reaccion=10;
strcpy(Reacciones[10].accion,"call_police");
strcpy(Reacciones[10].requisito,"telephone");
Reacciones[10].duracion=30;

Reacciones[11].num_reaccion=11;
strcpy(Reacciones[11].accion,"llorar");
strcpy(Reacciones[11].requisito,"scared");
Reacciones[11].duracion=300;

Reacciones[12].num_reaccion=12;
strcpy(Reacciones[12].accion,"stay_there");
strcpy(Reacciones[12].requisito,"any");
Reacciones[12].duracion=15;

Reacciones[13].num_reaccion=13;
strcpy(Reacciones[13].accion,"walk");
strcpy(Reacciones[13].requisito,"any");
Reacciones[13].duracion=86400;

}



//------------------------------------------------------------------------------
// Llenar tabla de EventoReaccion
void LlenarEventoReaccion()
{
/*  Otra forma de llenar la tabla de EventoReaccion
// ver notas del programa
strcpy(tabla_Compat[0].nom_event,"lluvia");
tabla_Compat[0].array_compa[0]=0;
tabla_Compat[0].array_compa[1]=1;
tabla_Compat[0].array_compa[2]=2;
tabla_Compat[0].array_compa[3]=3;

strcpy(tabla_Compat[1].nom_event,"temblor");
tabla_Compat[1].array_compa[0]=3;
tabla_Compat[1].array_compa[1]=4;
tabla_Compat[1].array_compa[2]=5;
tabla_Compat[1].array_compa[3]=12;

strcpy(tabla_Compat[2].nom_event,"rayo");
tabla_Compat[2].array_compa[0]=3;
tabla_Compat[2].array_compa[1]=12;

strcpy(tabla_Compat[3].nom_event,"granizo");
tabla_Compat[3].array_compa[0]=2;
tabla_Compat[3].array_compa[1]=3;
tabla_Compat[3].array_compa[2]=12;

strcpy(tabla_Compat[4].nom_event,"accidente");
tabla_Compat[4].array_compa[0]=4;
tabla_Compat[4].array_compa[1]=5;
tabla_Compat[4].array_compa[2]=10;
tabla_Compat[4].array_compa[3]=11;
tabla_Compat[4].array_compa[4]=12;

strcpy(tabla_Compat[5].nom_event,"asalto");
tabla_Compat[5].array_compa[0]=10;
tabla_Compat[5].array_compa[1]=11;
tabla_Compat[5].array_compa[2]=12;

strcpy(tabla_Compat[6].nom_event,"encontrar_amigo");
tabla_Compat[6].array_compa[0]=3;
tabla_Compat[6].array_compa[1]=12;

strcpy(tabla_Compat[7].nom_event,"ganar_loteria");
tabla_Compat[7].array_compa[0]=6;
tabla_Compat[7].array_compa[1]=7;
tabla_Compat[7].array_compa[2]=8;
tabla_Compat[7].array_compa[3]=9;

strcpy(tabla_Compat[8].nom_event,"carencia_dinero");
tabla_Compat[8].array_compa[0]=11;
tabla_Compat[8].array_compa[1]=3;
tabla_Compat[8].array_compa[2]=12;

strcpy(tabla_Compat[9].nom_event,"eventos_inesperados");
tabla_Compat[9].array_compa[0]=12;

strcpy(tabla_Compat[10].nom_event,"naturaleza");
tabla_Compat[10].array_compa[0]=3;
*/

EventoReaccion[0].num_reaccion=0;
strcpy(EventoReaccion[0].nom_event,"lluvia");

EventoReaccion[1].num_reaccion=1;
strcpy(EventoReaccion[1].nom_event,"lluvia");

EventoReaccion[2].num_reaccion=2;
strcpy(EventoReaccion[2].nom_event,"lluvia");

EventoReaccion[3].num_reaccion=3;
strcpy(EventoReaccion[3].nom_event,"lluvia");

EventoReaccion[4].num_reaccion=3;
strcpy(EventoReaccion[4].nom_event,"temblor");

EventoReaccion[5].num_reaccion=4;
strcpy(EventoReaccion[5].nom_event,"temblor");

EventoReaccion[6].num_reaccion=5;
strcpy(EventoReaccion[6].nom_event,"temblor");

EventoReaccion[7].num_reaccion=12;
strcpy(EventoReaccion[7].nom_event,"temblor");

EventoReaccion[8].num_reaccion=3;
strcpy(EventoReaccion[8].nom_event,"rayo");

EventoReaccion[9].num_reaccion=12;
strcpy(EventoReaccion[9].nom_event,"rayo");

EventoReaccion[10].num_reaccion=2;
strcpy(EventoReaccion[10].nom_event,"granizo");

EventoReaccion[11].num_reaccion=3;
strcpy(EventoReaccion[11].nom_event,"granizo");

EventoReaccion[12].num_reaccion=12;
strcpy(EventoReaccion[12].nom_event,"granizo");

EventoReaccion[13].num_reaccion=5;
strcpy(EventoReaccion[13].nom_event,"accidente");

EventoReaccion[14].num_reaccion=10;
strcpy(EventoReaccion[14].nom_event,"accidente");

EventoReaccion[15].num_reaccion=11;
strcpy(EventoReaccion[15].nom_event,"accidente");

EventoReaccion[16].num_reaccion=12;
strcpy(EventoReaccion[16].nom_event,"accidente");

EventoReaccion[17].num_reaccion=10;
strcpy(EventoReaccion[17].nom_event,"asalto");

EventoReaccion[18].num_reaccion=11;
strcpy(EventoReaccion[18].nom_event,"asalto");

EventoReaccion[19].num_reaccion=12;
strcpy(EventoReaccion[19].nom_event,"asalto");

EventoReaccion[20].num_reaccion=3;
strcpy(EventoReaccion[20].nom_event,"encontrar_amigo");

EventoReaccion[21].num_reaccion=12;
strcpy(EventoReaccion[21].nom_event,"encontrar_amigo");

EventoReaccion[22].num_reaccion=6;
strcpy(EventoReaccion[22].nom_event,"ganar_loteria");

EventoReaccion[23].num_reaccion=7;
strcpy(EventoReaccion[23].nom_event,"ganar_loteria");

EventoReaccion[24].num_reaccion=8;
strcpy(EventoReaccion[24].nom_event,"ganar_loteria");

EventoReaccion[25].num_reaccion=9;
strcpy(EventoReaccion[25].nom_event,"ganar_loteria");

EventoReaccion[26].num_reaccion=12;
strcpy(EventoReaccion[26].nom_event,"ganar_loteria");

EventoReaccion[27].num_reaccion=3;
strcpy(EventoReaccion[27].nom_event,"carencia_dinero");

EventoReaccion[28].num_reaccion=11;
strcpy(EventoReaccion[28].nom_event,"carencia_dinero");

EventoReaccion[29].num_reaccion=12;
strcpy(EventoReaccion[29].nom_event,"carencia_dinero");

EventoReaccion[30].num_reaccion=12;
strcpy(EventoReaccion[30].nom_event,"eventos_inesperados");

EventoReaccion[31].num_reaccion=3;
strcpy(EventoReaccion[31].nom_event,"naturaleza");
}


//------------------------------------------------------------------------------
// Llenar tabla de requisitos
void LlenarRequisitos()
{
strcpy(Requisitos[0].requisito,"paraguas");
Requisitos[0].num_requisito=0;

strcpy(Requisitos[1].requisito,"impermeable");
Requisitos[1].num_requisito=1;

strcpy(Requisitos[2].requisito,"lugar_techado");
Requisitos[2].num_requisito=2;

strcpy(Requisitos[3].requisito,"lugar_seguro");
Requisitos[3].num_requisito=3;

strcpy(Requisitos[4].requisito,"enfermo");
Requisitos[4].num_requisito=4;

strcpy(Requisitos[5].requisito,"heridos");
Requisitos[5].num_requisito=5;

strcpy(Requisitos[6].requisito,"dinero");
Requisitos[6].num_requisito=6;

strcpy(Requisitos[7].requisito,"comprar");
Requisitos[7].num_requisito=7;

strcpy(Requisitos[8].requisito,"vacaciones");
Requisitos[8].num_requisito=8;

strcpy(Requisitos[9].requisito,"telefono");
Requisitos[9].num_requisito=9;

strcpy(Requisitos[10].requisito,"asustado");
Requisitos[10].num_requisito=10;

strcpy(Requisitos[11].requisito,"sueo");
Requisitos[11].num_requisito=11;

strcpy(Requisitos[12].requisito,"ninguno");
Requisitos[12].num_requisito=12;
}


//------------------------------------------------------------------------------
//Llenar tabla de compatibilidad
void LlenarCompatibilidad()
{
strcpy(tabla_Compat[0].nom_accion,"abrirParaguas");
tabla_Compat[0].array_compa[0]=3;
tabla_Compat[0].array_compa[1]=5;
tabla_Compat[0].array_compa[2]=6;
tabla_Compat[0].array_compa[3]=7;
tabla_Compat[0].array_compa[4]=8;
tabla_Compat[0].array_compa[5]=9;
tabla_Compat[0].array_compa[6]=10;
tabla_Compat[0].array_compa[7]=11;
tabla_Compat[0].array_compa[8]=12;
tabla_Compat[0].array_compa[9]=13;

strcpy(tabla_Compat[1].nom_accion,"usarImpermeable");
tabla_Compat[1].array_compa[0]=3;
tabla_Compat[1].array_compa[1]=5;
tabla_Compat[1].array_compa[2]=6;
tabla_Compat[1].array_compa[3]=7;
tabla_Compat[1].array_compa[4]=8;
tabla_Compat[1].array_compa[5]=9;
tabla_Compat[1].array_compa[6]=10;
tabla_Compat[1].array_compa[7]=11;
tabla_Compat[1].array_compa[8]=12;
tabla_Compat[1].array_compa[9]=13;

strcpy(tabla_Compat[2].nom_accion,"correrLugarTechado");
tabla_Compat[2].array_compa[0]=11;
tabla_Compat[2].array_compa[1]=12;

strcpy(tabla_Compat[3].nom_accion,"permanecerDondeEsta");
tabla_Compat[3].array_compa[0]=0;
tabla_Compat[3].array_compa[1]=1;
tabla_Compat[3].array_compa[2]=4;
tabla_Compat[3].array_compa[3]=5;
tabla_Compat[3].array_compa[4]=9;
tabla_Compat[3].array_compa[5]=10;
tabla_Compat[3].array_compa[6]=11;
tabla_Compat[3].array_compa[7]=12;

strcpy(tabla_Compat[4].nom_accion,"desmayar");
tabla_Compat[4].array_compa[0]=3;
tabla_Compat[4].array_compa[1]=12;

strcpy(tabla_Compat[5].nom_accion,"llamarAmbulancia");
tabla_Compat[5].array_compa[0]=0;
tabla_Compat[5].array_compa[1]=1;
tabla_Compat[5].array_compa[2]=3;
tabla_Compat[5].array_compa[3]=10;
tabla_Compat[5].array_compa[4]=11;
tabla_Compat[5].array_compa[5]=12;
tabla_Compat[5].array_compa[6]=13;

strcpy(tabla_Compat[6].nom_accion,"comprarCasa");
tabla_Compat[6].array_compa[0]=0;
tabla_Compat[6].array_compa[1]=1;
tabla_Compat[6].array_compa[2]=8;
tabla_Compat[6].array_compa[3]=12;

strcpy(tabla_Compat[7].nom_accion,"comprarCarro");
tabla_Compat[7].array_compa[0]=0;
tabla_Compat[7].array_compa[1]=1;
tabla_Compat[7].array_compa[2]=12;

strcpy(tabla_Compat[8].nom_accion,"viajar");
tabla_Compat[8].array_compa[0]=0;
tabla_Compat[8].array_compa[1]=1;
tabla_Compat[8].array_compa[2]=2;
tabla_Compat[8].array_compa[3]=3;
tabla_Compat[8].array_compa[4]=4;
tabla_Compat[8].array_compa[5]=5;
tabla_Compat[8].array_compa[6]=7;
tabla_Compat[8].array_compa[7]=8;
tabla_Compat[8].array_compa[8]=10;
tabla_Compat[8].array_compa[9]=11;
tabla_Compat[8].array_compa[10]=12;
tabla_Compat[8].array_compa[11]=13;

strcpy(tabla_Compat[9].nom_accion,"ahorrar");
tabla_Compat[9].array_compa[0]=0;
tabla_Compat[9].array_compa[1]=1;
tabla_Compat[9].array_compa[2]=3;
tabla_Compat[9].array_compa[3]=12;
tabla_Compat[9].array_compa[4]=13;

strcpy(tabla_Compat[10].nom_accion,"llamarPolicia");
tabla_Compat[10].array_compa[0]=0;
tabla_Compat[10].array_compa[1]=1;
tabla_Compat[10].array_compa[2]=3;
tabla_Compat[10].array_compa[3]=5;
tabla_Compat[10].array_compa[4]=8;
tabla_Compat[10].array_compa[5]=11;
tabla_Compat[10].array_compa[6]=12;
tabla_Compat[10].array_compa[7]=13;

strcpy(tabla_Compat[11].nom_accion,"llorar");
tabla_Compat[11].array_compa[0]=0;
tabla_Compat[11].array_compa[1]=1;
tabla_Compat[11].array_compa[2]=2;
tabla_Compat[11].array_compa[3]=3;
tabla_Compat[11].array_compa[4]=5;
tabla_Compat[11].array_compa[5]=8;
tabla_Compat[11].array_compa[6]=10;
tabla_Compat[11].array_compa[7]=12;
tabla_Compat[11].array_compa[8]=13;

strcpy(tabla_Compat[12].nom_accion,"quedarsePasmado");
tabla_Compat[12].array_compa[0]=0;
tabla_Compat[12].array_compa[1]=1;
tabla_Compat[12].array_compa[2]=2;
tabla_Compat[12].array_compa[3]=3;
tabla_Compat[12].array_compa[4]=4;
tabla_Compat[12].array_compa[5]=5;
tabla_Compat[12].array_compa[6]=6;
tabla_Compat[12].array_compa[7]=7;
tabla_Compat[12].array_compa[8]=8;
tabla_Compat[12].array_compa[9]=9;
tabla_Compat[12].array_compa[10]=10;
tabla_Compat[12].array_compa[11]=11;
tabla_Compat[12].array_compa[12]=13;

strcpy(tabla_Compat[13].nom_accion,"caminar");
tabla_Compat[13].array_compa[0]=0;
tabla_Compat[13].array_compa[1]=1;
tabla_Compat[13].array_compa[2]=5;
tabla_Compat[13].array_compa[3]=8;
tabla_Compat[13].array_compa[4]=9;
tabla_Compat[13].array_compa[5]=10;
tabla_Compat[13].array_compa[6]=11;
tabla_Compat[13].array_compa[7]=12;
}







//------------------------------------------------------------------------------
//Cuando el agente tiene la reaccion que corresponde al evento activo, se inserta
//dicha reaccion como una hebra mas del agente.
int InsertaHebraReaccion(char *evento, TipoAgente *agente, char *reaccion,long duracion,long tiempo)
{
TipoPapel *reac_ap;
int inserta=NO, encontro=NO,i;
char accion[MAX_PALABRA];
long aux_duracion;


strcpy(reaccion_nueva," ");

//Se Busca la duracin de la reaccion y se guarda en aux_duracion
/*for (i=0; i<NUM_REACCIONES; i++)
  {
  strcpy(accion,Reacciones[i].accion);
  if (strcmp(accion,reaccion)==0)
     {
     aux_duracion=Reacciones[i].duracion;
     break;
     }
  } */


//Se busca la reaccion en Main
//reac_ap=Main.hebra->papel;
reac_ap=Main.papel;

while (reac_ap != NULL)
   {
   if (strcmp(reac_ap->nombre,reaccion)==0)
     {
     encontro=SI;
     strcpy(reaccion_nueva,reaccion); // Nueva reaccion creada por el evento
     break;
     }
   reac_ap=reac_ap->sig;
   }

if (encontro==SI)
  {
  //Se Crea la hebra y se inserta en la cola de ejecucion por cada agente que
  //percibe el evento
  HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
  HebraNueva->tiempo = tiempo + 1;
  HebraNueva->PC = 0;
  HebraNueva->estado = 2;       // La nueva hebra del comportamiento tiene un
                                // estado = suspendido
  HebraNueva->papel = reac_ap;  // Es un apuntador a la reaccion que esta en MAIN

  HebraNueva->proposito = NULL;
  HebraNueva->stack = NULL;
  HebraNueva->local = NULL;
  HebraNueva->agente=agente;
  HebraNueva->sig = NULL;

  // SE ASIGNAN LAS INSTRUCCIONES A EJECUTAR EL PAPEL
  reac_ap->u_instruccion = 4;
  strcpy(reac_ap->instruccion[1].opcode ,"WAIT");
  sprintf(reac_ap->instruccion[1].op1 ,"%d" ,duracion);
  strcpy(reac_ap->instruccion[1].op2 ,"");
  strcpy(reac_ap->instruccion[1].op3 ,"");

  strcpy(reac_ap->instruccion[2].opcode ,"FMEI");
  strcpy(reac_ap->instruccion[2].op1 ,"");
  strcpy(reac_ap->instruccion[2].op2 ,"");
  strcpy(reac_ap->instruccion[2].op3 ,"");

  strcpy(reac_ap->instruccion[3].opcode ,"STOP");
  strcpy(reac_ap->instruccion[3].op1 ,"");
  strcpy(reac_ap->instruccion[3].op2 ,"");
  strcpy(reac_ap->instruccion[3].op3 ,"");

  // SE LE AGREGA UN REFERENCIA A LA HEBRA
  IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
  IdHebraNueva->hebra = HebraNueva;
  IdHebraNueva->sig = agente->hebra;
  agente->hebra = IdHebraNueva;

  // Inserta la hebra nueva en la cola de ejecucion
  sim_InsertaEjecucion(HebraNueva);
  inserta=SI;
  }
  return inserta;
}


//------------------------------------------------------------------------------
// Revisa si el agente tiene algun accion que corresponde a la
// reaccion de evento. Si tiene alguna se inserta la reaccin en el agente
/*int RevisarReacciones(char *evento, TipoAgente *agente ,long tiempo)
{
TipoAccion *accion_ap;
TipoInterna *interna_ap;
char reaccion[MAX_PALABRA],nom_requi[MAX_PALABRA];
int i,j,k,n_reaccion=0,requisito,inserto=NO;


//Buscar en la tabla EventoReaccion la reaccion del evento activo
//si tiene alguna de ellas, se busca si cumple el requisito, si lo
//anterior es cirto se inserta la hebra de dicha reaccion
for (i=0; i<NUM_EVENTO_REAC; i++)
  {
    if (strcmp(evento,EventoReaccion[i].nom_event)==0)
      {
         n_reaccion=EventoReaccion[i].num_reaccion;
         for (j=0; j<NUM_REACCIONES; j++)
           {
              if (Reacciones[j].num_reaccion == n_reaccion)
                {
                   strcpy(reaccion,Reacciones[j].accion);
                   requisito=Reacciones[j].requisito;
                   for (k=0; k<NUM_REACCIONES; k++)
                     {
                       if (Requisitos[k].num_requisito == requisito)
                         {
                         strcpy(nom_requi,Requisitos[k].requisito);
                         break;
                         }
                     }
                   accion_ap=agente->accion;
                   while( accion_ap != NULL)
                     {
                       if (strcmp(accion_ap->accion,reaccion)==0)
                         {
                           interna_ap=agente->interna;
                           while(interna_ap != NULL)
                              {
                                if (strcmp(interna_ap->nombre,nom_requi)==0)
                                   {
                                   // Se inserta la reaccion como una hebra del agente
                                   inserto=InsertaHebraReaccion(evento,agente,reaccion,tiempo);
                                   if (inserto==SI) break;
                                   }
                                interna_ap=interna_ap->sig;
                              }
                           if (inserto==SI)
                              break;
                         }
                       accion_ap=accion_ap->sig;
                     }
                   if (inserto==SI)
                     break;
                }
              //if (inserto==SI)
              //  break;
           }
         if (inserto==SI)
           {
           i=33;
           break;
           }
      }
    if (inserto==SI)
      break;
  }
return inserto;
} */

//------------------------------------------------------------------------------
//Busca el nodo padre del nodo actual
TTreeNode* BuscaPapa(TTreeNode* NodoActual)
{
  TTreeNode* SuPapaEs;

  if (NodoActual->Parent == NULL)
       SuPapaEs=NodoActual;
  else
       SuPapaEs=NodoActual->Parent;
  return  SuPapaEs;
}


//------------------------------------------------------------------------------
// 1.- Encontrar el comportamiento ms especfico
// 2.- Insertar en la Cola el comportamiento apropiado
int  BuscaEventoArbol(char *evento, TipoAgente *agente, TTreeView* TreeView1,long tiempo)
{
  ifstream   nodeFile;
  TTreeNode* curNode;

  char eventoArbol[100] ;
  int ie ,ue ;

  char resto[100] ;
  int ir ,ur ;

  char comportamiento[100][100] ;
  int icomp ,ucomp ,kcomp ;

  char todo[250] ;
  int it ,ut,ini ;

  int sumar ;

  TipoAccion *accion_ap;
  TipoInterna *interna_ap;

  char nom_requi[MAX_PALABRA];
  int j,i,duracion;
  int inserto=NO;

  TTreeNode* SuPapaEs,*nodoActual;


 //Se busca el evento en el rbol de eventos inesperados
  for(int i=0;i<TreeView1->Items->Count;i++)
    {
    nodoActual=Fejecuta->TreeView1->Items->Item[i];
    strcpy(todo ,Fejecuta->TreeView1->Items->Item[i]->Text.c_str());

    //FRAGMENTA EL EVENTO EN SUS COMPORTAMIENTOS
    for( it = 0 ,ie = 0; todo[it] != ':'; ie++ ,it++ )
        eventoArbol[ie] = todo[it];
    for( ini=ie; ini<100; ini++)
        eventoArbol[ini] = '\0';
    it++;
    for( ur = 0; todo[it] != '.'; it++, ur++ )
        resto[ur] = todo[it];
    resto[ur] = '\0';

    ucomp = 0;
    for( ir = 0; resto[ir] != '\0'; )
    {
        // TOMA UN COMPORTAMIENTO
        icomp = 0;
        sumar = 0;
        for( ; (resto[ir] != ',') && (resto[ir] != '\0'); ir++, icomp++ )
        {
            comportamiento[ucomp][icomp] = resto[ir];
            sumar = 1;
        }
        comportamiento[ucomp][icomp] = '\0';
        if( sumar == 1 )
            ucomp++;
        if( resto[ir] == ',' )
            ir++;
    }

    // SI EL EVENTO ES IGUAL AL DEL ARBOL
    if( strcmp(eventoArbol ,evento) == 0 )
    {

      // TOMAR LOS COMPORTAMIENTOS DEL AGENTE QUE PUEDE REALIZAR
      // PARA CADA UNO DE ELLOS VER SI EXISTE EN EL NODO
      for (ini=0; ini < ucomp; ini++)
      {
          accion_ap = agente->accion;
          while( accion_ap != NULL)
          {
            // COINCIDE EL COMPORTAMIENTO DEL ARBOL CON
            // EL COMPORTAMIENTO QUE POSEE EL AGENTE
           if (strcmp(accion_ap->accion,comportamiento[ini])==0)
             {
               // BUSCAR EL COMPORTAMIENTO EN LA TABLA REACCIONES
               // PARA SABER CUAL ES SU REQUISITO Y DURACION DEL MISMO

               for (j=0; j<NUM_REACCIONES; j++)
               {
                  if (strcmp(Reacciones[j].accion,accion_ap->accion)==0)
                  {
                     strcpy(nom_requi,Reacciones[j].requisito);
                     duracion=Reacciones[j].duracion;
                     break;
                  }
               }

               interna_ap=agente->interna;
               while(interna_ap != NULL)
               {
                    if (strcmp(interna_ap->nombre,nom_requi)==0)
                    {
                       // SI TIENE EL COMPORTAMIENTO TERMINA LA BUSQUEDA
                       // BUSCAR SU CODIGO EN EL DISCO DURO


                       // SI EXISTE ENTONCES ADICIONAR UNA HEBRA PARA EL AGENTE
                       // Se inserta la reaccion como una hebra del agente
                       inserto=InsertaHebraReaccion(evento,agente,accion_ap->accion,duracion,tiempo);
                    }
                    interna_ap=interna_ap->sig;
               }

             } // if del comportamiento
             accion_ap=accion_ap->sig;
          }
      }// ciclo de lo comportamientos
    } // coincide evento del arbol con el evento activo

    if (strcmp(eventoArbol,"unexpected_event")==0)
             i=TreeView1->Items->Count;
    else
       {
        // si el agente no tiene la reaccion del evento o si el evento
        // activo no es el de eventos_inesperados (que es el nodo raiz)
        // Se busca el papa de ese evento
        SuPapaEs=BuscaPapa(curNode);
        inserto=BuscaEventoArbol(SuPapaEs->Text.c_str(),agente,TreeView1,tiempo);
       }
    }
  return inserto;
}



// Revisa si las hebras del agente son compatibles
void RevisarCompatibilidad(TipoAgente *agente, char *evento)
{
TipoPapel *papel_ap;
TipoIdHebra *idhebra_ap;
int i,j,k,aux,compatible=NO;
char reaccion[MAX_PALABRA];

// Se llena la tabla de compatibilidad
//LlenarCompatibilidad();


//Fejecuta->Box2->Items->Add("Agente: " + AnsiString(agente->nombre));
//Fejecuta->Box2->Items->Add("Papel: " + AnsiString(idhebra_ap->hebra->papel->nombre));

for (i=0; i< TABLA_COMPATIBILIDAD; i++)  //Buscar evento en tabla Compatibilidad
  {
    if (strcmp(reaccion_nueva,tabla_Compat[i].nom_accion)==0)
      {
      for (j=0; j<TABLA_COMPATIBILIDAD; j++)
        {
         aux = tabla_Compat[i].array_compa[j];
         //for ( k=0; k<=aux; k++)
         //  {
           if (Reacciones[aux].num_reaccion == aux)
             {
               compatible=NO;
               strcpy(reaccion, Reacciones[aux].accion);
               idhebra_ap = agente->hebra;
               while( idhebra_ap != NULL)
                 {
                 if (strcmp(idhebra_ap->hebra->papel->nombre,reaccion)==0)
                    {
                    compatible=SI;
                    idhebra_ap->hebra->estado=6;  //Significa que si es compatible
                    break;
                    }
                 /*if (compatible==SI)
                    idhebra_ap->hebra->estado=2;     // no se suspende esa hebra es compatible
                 else
                    idhebra_ap->hebra->estado=3; */    // se suspende, la hebra no es compatible

                 idhebra_ap=idhebra_ap->sig;
                 }
               if (compatible==SI)
                 break;
             }
           //}
        }
      if (compatible==SI)
         break;
      }
  }
}



//---------------------------------------------------------------------------
void MicroPlanificador(char *evento,long tiempo)
{
  //FILE *archivo;
  //TipoPapel *papel_ap;
  //char hebra[40],nomAgente[MAX_PALABRA], *nodo, cadena[MAX_PALABRA];
  //int k=0,l=0,i=0,m=0;
 int i ;

  TipoHebra  *cola_ap ;
  TipoEvento *evento_ap;
  TipoIdHebra *id_hebra_ap ;
  int inserto=NO;

  Fejecuta->Box2->Items->Add("INICIA MICROPLANIFICADOR");
  cola_ap = ColaInicio;
  if (cola_ap == NULL)
  {
      Fejecuta->Box2->Items->Add("LA COLA DE EJECUCION ESTA VACIA, ENTONCES NO HACE MICROPLANIFICACION");
      return;
  }
  // PARA CADA HEBRA DE LA COLA
  while( cola_ap != NULL )
    {
       // SI LA HEBRA YA SE REVISO ANTES, DESCARTARLA, SOLO REVISA estado == 1
       if( cola_ap->estado != 1 )
         {
             cola_ap = cola_ap->sig;
             continue;
         }
       // SI LA HEBRA NO TIENE UN AGENTE PROPIETARIO, DESCARTARLA
       if( cola_ap->agente == NULL )
         {
             cola_ap = cola_ap->sig;
             continue;
         }
       // REVISAR SI EL AGENTE PERCIBE EL EVENTO
//       Fejecuta->Box2->Items->Add(AnsiString(cola_ap->agente->nombre) + " percibe el evento inesperado " + AnsiString(evento) + " ????" );
       percibe = NO;  // SUPONEMOS QUE NO
       evento_ap = cola_ap->agente->evento;
       while( (evento_ap != NULL) && (percibe == NO) )
         {
             if (strcmp(evento_ap->evento ,evento) == 0)
                 percibe = SI;
              evento_ap = evento_ap->sig;
         }
       // SI NO LO PERCIBE QUE SIGA CON LA SIGUIENTE HEBRA
       if (percibe == NO )
         {
             //Fejecuta->Box2->Items->Add(AnsiString(cola_ap->agente->nombre) + " no lo percibe");
             cola_ap = cola_ap->sig;
             continue;
         }

       //Fejecuta->Box2->Items->Add(AnsiString(cola_ap->agente->nombre) + " SI percibe " + AnsiString(evento));
       // MARCAR LAS HEBRAS DEL MISMO AGENTE
       id_hebra_ap = cola_ap->agente->hebra;
       while( id_hebra_ap != NULL )
         {
             id_hebra_ap->hebra->estado = 2;     //ESTADO SUSPENDIDO
             id_hebra_ap = id_hebra_ap->sig;
         }
       // BUSCA EL COMPORTAMIENTO MAS ESPECIFICO
       inserto=BuscaEventoArbol(evento,cola_ap->agente,Fejecuta->TreeView4, tiempo);

       /*char eventoArbol[100] ;
int ie ,ue ;

char resto[100] ;
int ir ,ur ;

char comportamiento[100][100] ;
int icomp ,ucomp ,kcomp ;

char todo[250] ;
int it ,ut,ini ;

int sumar ;

TipoAccion *accion_ap;
TipoInterna *interna_ap;

char nom_requi[MAX_PALABRA];
int j,i,duracion;
//char *nodoActual;
int inserto=NO;

TTreeNode* SuPapaEs,*nodoActual;




       for( i = 0; i < Fejecuta->TreeView4->Items->Count ; i++ )
       {

              if (inserto==NO)
                 {
                  nodoActual= BuscaPapa(nodoActual);
                  strcpy(todo,nodoActual->Text.c_str());
                 }
               else
                 {
                 strcpy(todo ,Fejecuta->TreeView4->Items->Item[i]->Text.c_str());
                 nodoActual=Fejecuta->TreeView4->Items->Item[i];
                 }

               /*if (inserto==NO)
                 {
                  nodoActual= BuscaPapa(nodoActual);
                  strcpy(todo,nodoActual->Text.c_str());
                 }*/
             //  }
            //FRAGMENTA EL CONCEPTO EN SUS PARTES
            /*for( it = 0 ,ie = 0; todo[it] != ':'; ie++ ,it++ )
                eventoArbol[ie] = todo[it];
            for( ini=ie; ini<100; ini++)
                eventoArbol[ini] = '\0';
            it++;
            for( ur = 0; todo[it] != '.'; it++, ur++ )
                resto[ur] = todo[it];
            resto[ur] = '\0';

            ucomp = 0;
            for( ir = 0; resto[ir] != '\0'; )
            {
                // TOMA UN COMPORTAMIENTO
                icomp = 0;
                sumar = 0;
                for( ; (resto[ir] != ',') && (resto[ir] != '\0'); ir++, icomp++ )
                {
                    comportamiento[ucomp][icomp] = resto[ir];
                    sumar = 1;
                }
                comportamiento[ucomp][icomp] = '\0';
                if( sumar == 1 )
                    ucomp++;
                if( resto[ir] == ',' )
                    ir++;
            }

            // SI EL EVENTO ES IGUAL AL DEL ARBOL
            if( strcmp(eventoArbol ,evento) == 0 )
            {
                // TOMAR LOS COMPORTAMIENTOS DEL AGENTE QUE PUEDE REALIZAR
                // PARA CADA UNO DE ELLOS VER SI EXISTE EN EL NODO

                for (ini=0; ini < ucomp; )
                {
                    ini++;
                    accion_ap = cola_ap->agente->accion;
                    while( accion_ap != NULL)
                    {
                      // COINCIDE EL COMPORTAMIENTO DEL ARBOL CON
                      // EL COMPORTAMIENTO QUE POSEE EL AGENTE
                     if (strcmp(accion_ap->accion,comportamiento[ini])==0)
                       {
                         // BUSCAR EL COMPORTAMIENTO EN LA TABLA REACCIONES
                         // PARA SABER CUAL ES SU REQUISITO Y DURACION DEL MISMO

                         for (j=0; j<NUM_REACCIONES; j++)
                         {
                            if (strcmp(Reacciones[j].accion,accion_ap->accion)==0)
                            {
                               strcpy(nom_requi,Reacciones[j].requisito);
                               duracion=Reacciones[j].duracion;
                               break;
                            }
                         }

                         interna_ap=cola_ap->agente->interna;
                         while(interna_ap != NULL)
                         {
                              if (strcmp(interna_ap->nombre,nom_requi)==0)
                              {
                                 // SI TIENE EL COMPORTAMIENTO TERMINA LA BUSQUEDA
                                 // BUSCAR SU CODIGO EN EL DISCO DURO


                                 // SI EXISTE ENTONCES ADICIONAR UNA HEBRA PARA EL AGENTE
                                 // Se inserta la reaccion como una hebra del agente
                                 inserto=InsertaHebraReaccion(evento,cola_ap->agente,accion_ap->accion,duracion,tiempo);
                              }
                              interna_ap=interna_ap->sig;
                         }

                       }
                       accion_ap=accion_ap->sig;
                    }
                }
            }
        }*/

        if (inserto==SI)
          {
          // Revisar que tiene la cola de ejecucion antes de cambiar los
          // estados por compatibilidad
          /*cola_ap = ColaInicio;
          while( cola_ap != NULL )
          {
              if( cola_ap->estado == 2 );
              cola_ap = cola_ap->sig;
          }     */

          // SI UNA HEBRA DEL EVENTO FUE INSERTADA, ESTA TIENE EL ESTADO 2
          // REVISAR LA COMPATIBILIDAD DE HEBRAS
             RevisarCompatibilidad(cola_ap->agente,evento);
             // Se modifican las hebras que si son compatibles para que
             // se puedan ejecutar ( de estado 6 a 1)
             cola_ap = ColaInicio;
             while( cola_ap != NULL )
                {
                  //este estado indica que las hebras fueron revisadas y son compatibles
                  if( cola_ap->estado == 6 || cola_ap->estado == 2)
                     cola_ap->estado = 1;
                  cola_ap = cola_ap->sig;
                }
             break;
          }
       cola_ap = cola_ap->sig;
    }
  // SALIR DEL MICROPLANIFICADOR
  // PARA CADA HEBRA DE LA COLA

  // Si no se inserto ninguna hebra de reaccion entonces todas las hebras
  // que fueron suspendidas por el evento se activan nuevamente.
  // se cambian de estado 2 a 1
  if (inserto==NO)
    {
      cola_ap = ColaInicio;
      while( cola_ap != NULL )
        {
          //este estado indica que las hebras fueron revisadas y son compatibles
          if( cola_ap->estado == 2 )
             cola_ap->estado = 1;
          cola_ap = cola_ap->sig;
        }
    }
}



