#include <time.h>

// EVENTOS INESPERADOS
typedef struct
{
    char nombre[40];
    int duracion;
    int d ,m ,a ;
    int ho ,mi ,se ;
} TipoMEI;

TipoMEI Eventos[200] ;
int UEventos ,IEventos ;


//---------------------------------------------------------------------------
char RelofFmt[50] ;
extern TipoPapel *PapelNueva ;
extern TipoHebra *HebraNueva ;
extern TipoMain Main ;
extern TipoIdHebra *IdHebraNueva ;
extern TipoHebra *ColaInicio ;
extern TipoHebra *ColaAp;
extern long Reloj ;

//---------------------------------------------------------------------------
// VARIABLES PARA EVENTOS INESPERADOS
TipoMain Mei;
//---------------------------------------------------------------------------
void fecha_FormateaDMAhms(int d ,int m ,int a ,int ho ,int mi ,int se ,char *RelofFmt);
void sim_InsertaEjecucion(TipoHebra *hebra);
void separaComando(char *linea ,TipoArgumentos *arg);
void haz_Instruccion(char *op ,char *op1 ,char *op2 ,char *op3 ,char *op4 ,char *op5);
TipoPapel *cargaEnMain(char *papel_deseado);

//---------------------------------------------------------------------------
int compatible(char *papel1 ,char *papel2 )
{
FILE *archivo ;
char linea[101] ,*a_linea ;
char pap1[60] ,pap2[60] ;
int son_compatibles ;

    // ABRE EL archivo DE COMPATIBILIDADES
    if( ( archivo = fopen("compatible.dat", "rt" ) ) == NULL )
    {
        return NO;
    }
    // LEE CADA PAR DE PAPELES
    for( son_compatibles = NO; (fgets(linea, 100, archivo) != NULL) && (son_compatibles == NO); )
    {
        if( linea[strlen(linea) - 1] == '\n' )
            linea[strlen(linea) - 1] = '\0';

        // TOMA LA PALABRA
        strncpy(pap1, linea, 50);
        strcpy(pap2, linea + 50);

        a_linea = pap1 + 50;
        // QUITA ESPACIOS FINALES:
        for( ; *a_linea == ' ' || *a_linea == '\0'; a_linea-- )
            *a_linea = '\0';

        // REVISA LA COMPATIBILIDAD
        if( (strcmp(pap1 ,papel1) == 0) && (strcmp(pap2 ,papel2) == 0) )
            son_compatibles = SI;
    }
    fclose( archivo );
    return son_compatibles;
}

//---------------------------------------------------------------------------
void CargaEventosInesperados(char *nom_arch)
{
FILE *amei ;
char FmtReloj[50] ;

    Mei.papel = NULL;
    amei = fopen(nom_arch,"rb");
    if( amei == NULL )
        return;

    fseek(amei ,0 ,SEEK_END);
    UEventos = ftell(amei) / sizeof(TipoMEI);
    for( IEventos = 0; IEventos < UEventos; IEventos++ )
    {
        fseek(amei ,(long)IEventos * sizeof(TipoMEI) ,SEEK_SET);
        fread((char *)&Eventos[IEventos] ,sizeof(TipoMEI) ,1 ,amei);
    }
    fclose(amei);

    // DESPLEGA LOS EVENTOS
    Fprimero->Grid1->RowCount = 2;
    Fprimero->Grid1->Cells[0][0] = "#";
    Fprimero->Grid1->Cells[1][0] = "Date Time";
    Fprimero->Grid1->Cells[2][0] = "Event";
    Fprimero->Grid1->Cells[3][0] = "Duration";

    Fprimero->Grid1->Cells[0][1] = "";
    Fprimero->Grid1->Cells[1][1] = "";
    Fprimero->Grid1->Cells[2][1] = "";
    Fprimero->Grid1->Cells[3][1] = "";

    if( UEventos == 0 )
        return;

    Fprimero->Grid1->RowCount = UEventos + 1;
    for( IEventos = 0; IEventos < UEventos; IEventos++ )
    {
        Fprimero->Grid1->Cells[0][ IEventos + 1 ] = IEventos + 1;
        fecha_FormateaDMAhms(Eventos[ IEventos ].d ,Eventos[ IEventos ].m
          ,Eventos[ IEventos ].a ,Eventos[ IEventos ].ho ,Eventos[ IEventos ].mi
          ,Eventos[ IEventos ].se ,FmtReloj);
        Fprimero->Grid1->Cells[1][ IEventos + 1 ] = FmtReloj;
        Fprimero->Grid1->Cells[2][ IEventos + 1 ] = Eventos[ IEventos ].nombre;
        Fprimero->Grid1->Cells[3][ IEventos + 1 ] = Eventos[ IEventos ].duracion;

        // CREA UN PAPEL PARA EL EVENTO INESPERADO
        PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel));
        strcpy(PapelNueva->nombre ,Eventos[ IEventos ].nombre);
        PapelNueva->cupo = 0;
        PapelNueva->usados = 0;
        PapelNueva->requisito = NULL;
        PapelNueva->u_local = 0;

        // SE ASIGNAN LAS INSTRUCCIONES A EJECUTAR EL PAPEL
        PapelNueva->u_instruccion = 4;
        PapelNueva->instruccion =(TipoInstruccion *)malloc(sizeof(TipoInstruccion) * 4);
        strcpy(PapelNueva->instruccion[0].opcode ,"IMEI");
        strcpy(PapelNueva->instruccion[0].op1 ,"");
        strcpy(PapelNueva->instruccion[0].op2 ,"");
        strcpy(PapelNueva->instruccion[0].op3 ,"");
        strcpy(PapelNueva->instruccion[0].op4 ,"");
        strcpy(PapelNueva->instruccion[0].op5 ,"");


        strcpy(PapelNueva->instruccion[1].opcode ,"WAIT");
        sprintf(PapelNueva->instruccion[1].op1 ,"%d" ,Eventos[ IEventos ].duracion);
        strcpy(PapelNueva->instruccion[1].op2 ,"");
        strcpy(PapelNueva->instruccion[1].op3 ,"");
        strcpy(PapelNueva->instruccion[1].op4 ,"");
        strcpy(PapelNueva->instruccion[1].op5 ,"");

        strcpy(PapelNueva->instruccion[2].opcode ,"FMEI");
        strcpy(PapelNueva->instruccion[2].op1 ,"");
        strcpy(PapelNueva->instruccion[2].op2 ,"");
        strcpy(PapelNueva->instruccion[2].op3 ,"");
        strcpy(PapelNueva->instruccion[2].op4 ,"");
        strcpy(PapelNueva->instruccion[2].op5 ,"");

        strcpy(PapelNueva->instruccion[3].opcode ,"STOP");
        strcpy(PapelNueva->instruccion[3].op1 ,"");
        strcpy(PapelNueva->instruccion[3].op2 ,"");
        strcpy(PapelNueva->instruccion[3].op3 ,"");
        strcpy(PapelNueva->instruccion[3].op4 ,"");
        strcpy(PapelNueva->instruccion[3].op5 ,"");

        PapelNueva->sig = NULL;

        if( Mei.papel == NULL )
            Mei.papel = PapelNueva;
        else
        {
            PapelNueva->sig = Mei.papel;
            Mei.papel = PapelNueva;
        }
        // INSERTA UNA HEBRA EN LA COLA DE EJECUCION PARA EL EVENTO INESPERADO
        HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
        HebraNueva->tiempo = DMAhms_a_s(Eventos[ IEventos ].d ,Eventos[ IEventos ].m ,Eventos[ IEventos ].a
          ,Eventos[ IEventos ].ho ,Eventos[ IEventos ].mi ,Eventos[ IEventos ].se);
        HebraNueva->PC = 0;
        HebraNueva->estado = 0;
        HebraNueva->papel = Mei.papel;
        HebraNueva->proposito = NULL;
        HebraNueva->stack = NULL;
        HebraNueva->agente = NULL;
        HebraNueva->sig = NULL;
        HebraNueva->u_local = NULL;
        HebraNueva->plan = NULL;

        if( Mei.hebra == NULL )
            Mei.hebra = HebraNueva;
        else
        {
            HebraNueva->sig = Mei.hebra;
            Mei.hebra = HebraNueva;
        }
        sim_InsertaEjecucion(HebraNueva);
    }
    fclose(amei);
}

//---------------------------------------------------------------------------
void MicroPlanificador(char *nombre_evento ,long tiempo)
{
TipoHebra  *cola_ap ;
TipoEvento *evento_ap;
TipoIdHebra *id_hebra_ap ;
int inserto ;

// VARIABLES PARA BUSCAR EL COMPORTAMIENTO MAS ESPECIFICO
char evento[100] ;
int ie ,ue ;
int i_evento ;

char resto[100] ;
int ir ,ur ;

char comportamiento[100][100] ;
int icomp ,ucomp ,kcomp ,increm ;

char nodo[250] ;
int in ,un ;

int sumar ;
int esta_evento ;

TipoAccion *accion_ap;
TipoInterna *interna_ap;
int i ;
int hay_comportamiento ,cumple_requisitos ;
int percibe ;

char nom_arch_ei[100] ;
FILE *arch_ei ;
char linea[200] ;
int longitud ;
int fin ;
int esta_var ;
int i_interna ;
TipoArgumentos argumento ;
TipoPapel *papel ,*papel_emergencia ;
int i_local ;

//    Fprimero->Box1->Items->Add("INICIA MICROPLANIFICADOR");
    cola_ap = ColaInicio;
    if (cola_ap == NULL)
    {
        Fprimero->Box1->Items->Add("LA COLA DE EJECUCION ESTA VACIA, ENTONCES NO HACE MICROPLANIFICACION");
        return;
    }
    // PARA CADA HEBRA DE LA COLA
    while( cola_ap != NULL )
    {
        // SI LA HEBRA YA SE REVISO ANTES, DESCARTARLA, SOLO REVISA estado == 0 (ACTIVA)
        if( cola_ap->estado > 9  )
        {
             cola_ap = cola_ap->sig;
             continue;
        }
        // SI ES HEBRA DE EMERGENCIA, DESCARTARLA
        if( cola_ap->estado == 8 )
        {
             cola_ap = cola_ap->sig;
             continue;
        }

        // SI LA HEBRA NO TIENE UN AGENTE PROPIETARIO, DESCARTARLA
        if( cola_ap->agente == NULL )
        {
            cola_ap = cola_ap->sig;
            continue;
        }

        // REVISAR SI EL AGENTE PERCIBE EL EVENTO
        Fprimero->Box1->Items->Add(AnsiString(cola_ap->agente->nombre) + " percibe " + AnsiString(nombre_evento) + " ????" );
        percibe = NO;  // SUPONEMOS QUE NO
        evento_ap = cola_ap->agente->evento;
        while( (evento_ap != NULL) && (percibe == NO) )
        {
            if (strcmp(evento_ap->evento ,nombre_evento) == 0)
                percibe = SI;
            evento_ap = evento_ap->sig;
        }
        // SI NO LO PERCIBE QUE SIGA CON LA SIGUIENTE HEBRA
        if (percibe == NO )
        {
            Fprimero->Box1->Items->Add(AnsiString(cola_ap->agente->nombre) + " no lo percibe");
            cola_ap = cola_ap->sig;
            continue;
        }

        // BUSCA EL EVENTO INESPERADO EN EL ARBOL
        esta_evento = NO; // SUPONE QUE NO
        i_evento = NO_HAY;
        for( i = 0; (i < Fprimero->Tree1->Items->Count) && (esta_evento == NO); i++ )
        {
            // FRAGMENTA EL EVENTO EN SUS PARTES
            strcpy(nodo ,Fprimero->Tree1->Items->Item[i]->Text.c_str());
            for( in = 0 ,ie = 0; nodo[in] != ':'; ie++ ,in++ )
                evento[ie] = nodo[in];
            evento[ie] = '\0';
            if( strcmp(nombre_evento ,evento) == 0 )
            {
                i_evento = i;
                esta_evento = SI;
            }
        }

        // SI NO ESTA EL EVENTO REVISAR OTRA HEBRA
        if( esta_evento == NO )
        {
            cola_ap = cola_ap->sig;
            continue;
        }

        // SI LO PERCIBE Y EXISTE REACCION ALTERAR LAS HEBRAS DEL AGENTE
        Fprimero->Box1->Items->Add(AnsiString(cola_ap->agente->nombre) + " SI PERCIBE");

        // CARGA EL CODIGO DEL EVENTO INESPERADO QUE AFECTA A UN AGENTE
        papel_emergencia = cargaEnMain(nombre_evento);

        // ADICIONA LA HEBRA DEL PAPEL INICIAL
        if( papel_emergencia != NULL )
        {
        TipoHebra *colaemergencia ;

            // EL PAPEL TIENE PRIORIDAD POR SOBRE TODAS LAS HEBRAS EN EJECUCION
            HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra));
            HebraNueva->tiempo = Reloj + 5;
            HebraNueva->PC = 0;
            HebraNueva->estado = 8;
            HebraNueva->papel = papel_emergencia;
            HebraNueva->proposito = NULL;
            HebraNueva->stack = NULL;
            HebraNueva->plan = NULL;
            HebraNueva->u_local = papel_emergencia->u_local;
            HebraNueva->agente = cola_ap->agente;
            HebraNueva->sig = NULL;
            // SE LE CARGAN SUS VARIABLES LOCALES A LA HEBRA
            for( i_local = 0; i_local < papel_emergencia->u_local; i_local++ )
            {
                strcpy(HebraNueva->local[i_local].nombre ,papel_emergencia->local[i_local].nombre);
                HebraNueva->local[i_local].tipo = papel_emergencia->local[i_local].tipo;
                HebraNueva->local[i_local].dim1 = papel_emergencia->local[i_local].dim1;
                HebraNueva->local[i_local].dim2 = papel_emergencia->local[i_local].dim2;
            }

             // SE LE AGREGA UN REFERENCIA A LA HEBRA
            //IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
            //IdHebraNueva->hebra = HebraNueva;
            //IdHebraNueva->sig = cola_ap->agente->hebra;
            //cola_ap->agente->hebra = IdHebraNueva;
/////// EJECUTA LA HEBRA DE EMERGENCIA

            colaemergencia = ColaAp;
            ColaAp = HebraNueva;
            while( strcmp(ColaAp->papel->instruccion[ColaAp->PC].opcode, "STOP") != 0 )
            {
                haz_Instruccion(ColaAp->papel->instruccion[ColaAp->PC].opcode
                  ,ColaAp->papel->instruccion[ColaAp->PC].op1
                  ,ColaAp->papel->instruccion[ColaAp->PC].op2
                  ,ColaAp->papel->instruccion[ColaAp->PC].op3
                  ,ColaAp->papel->instruccion[ColaAp->PC].op4
                  ,ColaAp->papel->instruccion[ColaAp->PC].op5);
                ColaAp->PC++;
            }

            ColaAp = colaemergencia;
            // INSERTA LA HEBRA EN LA COLA DE EJECUCION
            //sim_InsertaEjecucion(HebraNueva);
        }

        // MARCAR LAS HEBRAS DEL MISMO AGENTE
        id_hebra_ap = cola_ap->agente->hebra;
        while( id_hebra_ap != NULL )
        {
            //if( id_hebra_ap->hebra->estado == 0 ) // SOLO MARCA ACTIVAS
            //    id_hebra_ap->hebra->estado = 1; // ESTADO SUSP. POR EVENTO INESPERADO
//            if( id_hebra_ap->hebra->estado != 8 )
                id_hebra_ap->hebra->estado += 10;
            id_hebra_ap = id_hebra_ap->sig;
        }

        // BUSCAR UN COMPORTAMIENTO PARA EJECUTARLO
        for(  hay_comportamiento = NO; hay_comportamiento == NO; )
        {
            Fprimero->Tree1->Items->Item[i_evento]->Selected = true;
            strcpy(nodo ,Fprimero->Tree1->Selected->Text.c_str());
            for( in = 0 ,ie = 0; nodo[in] != ':'; ie++ ,in++ )
                evento[ie] = nodo[in];
            in++;
            for( ur = 0; nodo[in] != '.'; in++, ur++ )
                resto[ur] = nodo[in];
            resto[ur] = '\0';

            // LLENA LA TABLA DE COMPORTAMIENTOS
            ucomp = 0;
            for( ir = 0; resto[ir] != '\0'; )
            {
                // TOMA UN COMPORTAMIENTO
                icomp = 0;
                sumar = 0;
                for( ; (resto[ir] != ',') && (resto[ir] != '\0'); ir++, icomp++ )
                {
                    comportamiento[ucomp][icomp] = resto[ir];
                    sumar = 1;
                }
                comportamiento[ucomp][icomp] = '\0';
                if( sumar == 1 )
                    ucomp++;
                if( resto[ir] == ',' )
                    ir++;
            }

            // BUSCAR SI EL AGENTE PUEDE REALIZAR ALGUN COMPORTAMIENTO
            for( icomp = 0; (icomp < ucomp) && (hay_comportamiento == NO); icomp++ )
            {
                for( increm = 0; isdigit(comportamiento[icomp][increm]); increm++ )
                    ;
                accion_ap = cola_ap->agente->accion;
                while( accion_ap != NULL)
                {
                    // EL AGENTE PUEDE HACER EL COMPORTAMIENTO
                    if( strcmp(accion_ap->accion ,comportamiento[icomp] + increm) == 0 )
                    {
                        // REVISAR SI EL AGENTE CUMPLE CON LOS REQUISITOS
                        cumple_requisitos = NO;
                        strcpy(nom_arch_ei ,accion_ap->accion);
                        strcat(nom_arch_ei ,".cod");
                        arch_ei = fopen(nom_arch_ei ,"rt");
                        if( arch_ei == NULL )
                        {
                            accion_ap = accion_ap->sig;
                            continue;
                        }

                        cumple_requisitos = SI;
                        fin = NO;
                        while( fin == NO )
                        {
                            if( fgets(linea, 200, arch_ei) == NULL )
                            {
                                fin = SI;
                                continue;
                            }
                            longitud = strlen(linea);
                            if( linea[longitud - 1] == '\n' )
                                linea[longitud - 1] = '\0';
                            separaComando(linea ,&argumento);
                            if( strcmp(argumento.comando ,"r") == 0 )
                            {
                                if( strcmp(argumento.param[0] ,"ninguno") != 0 )
                                {
                                    // REVISA SI EL AGENTE TIENE EL RECURSO INDICADO
                                    esta_var = NO;
                                    for( i_interna = 0; (i_interna < cola_ap->agente->u_interna) && (esta_var == NO); i_interna++ )
                                    {
                                        if( strcmp(cola_ap->agente->interna[i_interna].nombre ,argumento.param[0]) == 0 )
                                            esta_var = SI;
                                    }
                                    if( esta_var == NO )
                                        cumple_requisitos = NO;
                                }
                            }
                        }
                        fclose(arch_ei);

                        if( cumple_requisitos == SI )
                        {
                            // CARGA EL CODIGO DEL PAPEL A INSERTAR
                            papel = cargaEnMain(accion_ap->accion);

                            // ADICIONA LA HEBRA DEL PAPEL INICIAL
                            if( papel != NULL )
                            {
                                // CAMBIA EL ESTADO DE ACUERDO A LA COMPATIBILIDAD
                                id_hebra_ap = cola_ap->agente->hebra;
                                while( id_hebra_ap != NULL )
                                {
                                    //if( id_hebra_ap->hebra->estado == 1 ) // SUSP. POR Ev In
                                    //{
                                    if( compatible(accion_ap->accion ,id_hebra_ap->hebra->papel->nombre) == NO )
                                        switch( id_hebra_ap->hebra->estado )
                                        {
                                        case 10:
                                            id_hebra_ap->hebra->estado = 11;
                                            break;
                                        case 12:
                                            id_hebra_ap->hebra->estado = 13;
                                            break;
                                        case 14:
                                            id_hebra_ap->hebra->estado = 15;
                                            break;
                                        }
                                    //}
                                    id_hebra_ap = id_hebra_ap->sig;
                                }

                                //SE AGREGAN EL PAPEL EN LA COLA DE EJECUCION
                                HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra));
                                HebraNueva->tiempo = Reloj + 5;
                                HebraNueva->PC = 0;
                                HebraNueva->estado = 14;
                                HebraNueva->papel = papel;
                                HebraNueva->proposito = NULL;
                                HebraNueva->stack = NULL;
                                HebraNueva->plan = NULL;
                                HebraNueva->u_local = papel->u_local;
                                HebraNueva->agente = cola_ap->agente;
                                HebraNueva->sig = NULL;
                                // SE LE CARGAN SUS VARIABLES LOCALES A LA HEBRA
                                for( i_local = 0; i_local < papel->u_local; i_local++ )
                                {
                                    strcpy(HebraNueva->local[i_local].nombre ,papel->local[i_local].nombre);
                                    HebraNueva->local[i_local].tipo = papel->local[i_local].tipo;
                                    HebraNueva->local[i_local].dim1 = papel->local[i_local].dim1;
                                    HebraNueva->local[i_local].dim2 = papel->local[i_local].dim2;
                                }

                                 // SE LE AGREGA UN REFERENCIA A LA HEBRA
                                IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
                                IdHebraNueva->hebra = HebraNueva;
                                IdHebraNueva->sig = cola_ap->agente->hebra;
                                cola_ap->agente->hebra = IdHebraNueva;

                                // INSERTA LA HEBRA EN LA COLA DE EJECUCION
                                sim_InsertaEjecucion(HebraNueva);

                                hay_comportamiento = SI;
                            }
                        }
                    }
                    accion_ap = accion_ap->sig;
                }
            }
            if( hay_comportamiento == NO )
            {
                // SUBE AL NODO PADRE
                if( i_evento == 0 )
                {
                    hay_comportamiento = SI;
                    // REACTIVA LAS HEBRAS DEL AGENTE POR NO HABER COMPORTAMIENTO
                    /*
                    id_hebra_ap = cola_ap->agente->hebra;
                    while( id_hebra_ap != NULL )
                    {
                        if( id_hebra_ap->hebra->estado == 1 ) // SUSP. POR Ev In
                            id_hebra_ap->hebra->estado = 0;
                        id_hebra_ap = id_hebra_ap->sig;
                    }
                    */
                }
                else
                {
                   Fprimero->Tree1->Selected->Parent->Selected = true;
                   i_evento = Fprimero->Tree1->Selected->AbsoluteIndex;
                }
            }
        }
        // PASA AL SIGUIENTE NODO DE LA COLA
        cola_ap = cola_ap->sig;
    }

    // RESTABLECE LOS ESTADOS DE LAS HEBRAS
    cola_ap = ColaInicio;
    while(cola_ap != NULL)
    {
        if( cola_ap->estado > 9  )
            cola_ap->estado -= 10;
        cola_ap = cola_ap->sig;
    }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void FinEvento(char *nombre_evento ,long tiempo)
{
TipoHebra  *cola_ap ;
TipoEvento *evento_ap;


    Fprimero->Box1->Items->Add("Restaurando Hebras por Fin de Evento Inesperado"); 
    cola_ap = ColaInicio;
    if (cola_ap == NULL)
    {
        Fprimero->Box1->Items->Add("LA COLA DE EJECUCION ESTA VACIA, ENTONCES NO HACE FIN EVENTO INESPERADO");
        return;
    }
    // PARA CADA HEBRA DE LA COLA
    while( cola_ap != NULL )
    {
        // SI LA HEBRA YA SE REVISO ANTES, DESCARTARLA, SOLO REVISA estado == 0 (ACTIVA)
        switch( cola_ap->estado )
        {
        case 5:
            cola_ap->estado = 4;
            break;
        case 3:
            cola_ap->estado = 2;
            break;
        case 1:
            cola_ap->estado = 0;
            break;
        }
        cola_ap = cola_ap->sig;
    }
}
//---------------------------------------------------------------------------
