//---------------------------------------------------------------------------
// Jess M. Olivares Ceja
// Ejecucion de LIA
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ejecuta.h"
#include "grafico.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFejecuta *Fejecuta;
//---------------------------------------------------------------------------
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <math.h>
//---------------------------------------------------------------------------
#include "ambiente.h"
#include "LIAtiempo.h"
//MEI #include "EvInespera.h"
//---------------------------------------------------------------------------


typedef struct
{
    char *cadena ;
} TipoCadena ;

typedef struct
{
    char instruccion[15];
    int duracion ;
} TipoDuracion ;

//---------------------------------------------------------------------------
// VARIABLES DEL AMBIENTE DE INTERACCION
//---------------------------------------------------------------------------
extern TipoGlobal *GlobalInicio ,*GlobalNueva ,*GlobalAp ;
extern TipoRegional *RegionalInicio ,*RegionalNueva ,*RegionalAp ;
extern TipoAgente *AgenteInicio ,*AgenteNueva ,*AgenteAp ;
extern TipoPapel *PapelNueva ;
extern TipoMain Main ;
extern TipoInteraccion *InteraccionInicio ,*InteraccionNueva ,*InteraccionAp ;
extern TipoHebra *ColaInicio ,*ColaAp ,*ColaAnt ;
extern TipoHebra *HebraNueva ;
extern TipoCadena Cadena[200] ;
extern int UCadena ,ICadena ;
TipoStack *StackLimpia ,*StackActual ;
TipoIdHebra *IdHebraNueva ;
char Buffer[256] ;
TipoDuracion Duracion[100] =
  {
  {"WAIT",0} ,{"JMP",4} ,{"Pr",3} ,{"CLRSTK",1} ,{"PUSHv",3}
  ,{"CREAA",7} ,{"CREAI",7} ,{"MOVviS",5} ,{"",0} ,{"",0}
  };
int IDuracion ,UDuracion = 10;
// VARIABLES PARA MANEJO DEL RELOJ
long Reloj ;
long Tiempo[1000] ;
int uTiempo ,iTiempo ;
char RelojFormateado[50] ;
long NumeroAgente ;
int Detener ;

int ximg ,yimg ;

// VARIABLES DEL PLANIFICADOR
TipoNodoPlan *Planes ,*PlanesAp ;


//---------------------------------------------------------------------------
//    PROTOTIPOS
void sim_Destruye(void);
void meiNavega(void) {};
int sim_InsertaAgenteInterna(TipoAgente *agente ,char *interna ,char tipo
  ,int dim1 ,int dim2);
int sim_InsertaAgenteProposito(TipoAgente *agente ,char *proposito );
int sim_InsertaAgenteEvento(TipoAgente *agente ,char *evento );
int sim_InsertaAgenteAccion(TipoAgente *agente ,char *accion );
int sim_InsertaAgenteInicial(TipoAgente *agente ,char *inicial );
int sim_InsertaAgenteRegional(TipoAgente *agente ,char *regional ,char tipo
  ,int dim1 ,int dim2);
void sim_InsertaEjecucion(TipoHebra *hebra);
void sim_Planifica(void);


//---------------------------------------------------------------------------
__fastcall TFejecuta::TFejecuta(TComponent* Owner)
    : TForm(Owner)
{
}
//===========================================================================
// MANEJO DEL RELOJ
//===========================================================================
void fecha_FormateaDMAhms(int d ,int m ,int a ,int ho ,int mi ,int se ,char *RelojFormateado)
{
char t_linea[10] ;

    sprintf(RelojFormateado ,"%d/" ,d);
    if( m < 10 )
        sprintf(t_linea ,"0%d/" ,m);
    else
        sprintf(t_linea ,"%d/" ,m);
    strcat(RelojFormateado ,t_linea);
    sprintf(t_linea ,"%d " ,a);
    strcat(RelojFormateado ,t_linea);
    sprintf(t_linea ,"%d:" ,ho);
    strcat(RelojFormateado ,t_linea);
    if( mi < 10 )
        sprintf(t_linea ,"0%d:" ,mi);
    else
        sprintf(t_linea ,"%d:" ,mi);
    strcat(RelojFormateado ,t_linea);
    if( se < 10 )
        sprintf(t_linea ,"0%d" ,se);
    else
        sprintf(t_linea ,"%d" ,se);
    strcat(RelojFormateado ,t_linea);
}
//---------------------------------------------------------------------------
void sim_SeleccionaReloj(void)
{
/*
long menor ;
int d,m,a,ho,mi,se;

    // ELIGE EL MENOR DE LOS TIEMPOS DETECTADOS EN LA ULTIMA VUELTA DE EJECUCION
    menor = Tiempo[0];
    for( iTiempo = 0; iTiempo < uTiempo; iTiempo++ )
        if( Tiempo[iTiempo] < menor )
            menor = Tiempo[iTiempo];
    Reloj = menor;
    uTiempo = 0;
    // DESPLEGA LA NUEVA HORA
    s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
    fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
    Fejecuta->Label1->Caption = RelojFormateado;
*/
}
//---------------------------------------------------------------------------
int sim_Duracion(char *instruccion)
{
    for( IDuracion = 0; IDuracion < UDuracion; IDuracion++ )
        if( strcmp(Duracion[IDuracion].instruccion ,instruccion) == 0 )
            return Duracion[IDuracion].duracion;
    return 0;
}
//===========================================================================
// INICIALIZACION DE LA EJECUCION
//===========================================================================
void __fastcall TFejecuta::inicio(TObject *Sender)
{
//VARIABLES DEL PLANIFICADOR
FILE *arch_plan ;
char linea[256] ;
int ilinea ,ulinea ;

char nom_papel[100] ;
int inom ,unom ;

char elemento[100] ;
int ielem ,uelem ;

char resto_linea[100] ;
int iresto ,uresto ;

TipoNodoPlan *nodo_plan_nuevo ;
TipoRequisito *requisito_ap ;
TipoProposito *prop_ap ;


// VARIABLES PARA DESPLEGAR EL AMBIENTE DE EJECUCION
TipoGlobal *global_ap ;
TipoRegional *regional_ap ;

    // BOTONES DE CONTROL
    DETENER->Show();
    UNPASO->Hide();
    SALIR->Hide();
    CONTINUAR->Hide();
    Detener = NO;

    // CARGA LOS PLANES DEL PLANIFICADOR
    Planes = NULL;
    arch_plan = fopen("Planes.dat" ,"rt");
    if( arch_plan == NULL )
    {
         return; // NO HAY PAPELES PARA PLANEAR
    }
    for( ; fgets(linea, 255, arch_plan) != NULL;)
    {
        if( linea[strlen(linea) - 1] == '\n' )
            linea[strlen(linea) - 1] = '\0';
        if( strlen(linea) < 4 )
            continue;
        // TOMA EL PAPEL
        for( inom = 0 ,ilinea = 0; linea[ilinea] != ':'; ilinea++ ,inom++ )
            nom_papel[inom] = linea[ilinea];
        nom_papel[inom] =  '\0';

        // CREA EL NODO DEL PAPEL EN LA LISTA DE PLANES
        nodo_plan_nuevo = (TipoNodoPlan *) malloc(sizeof(TipoNodoPlan) + 1);
        strcpy(nodo_plan_nuevo->papel ,nom_papel);
        nodo_plan_nuevo->requisito = NULL;  // INICIALIZA LOS REQUISITOS
        nodo_plan_nuevo->proposito = NULL;  // INICIALIZA LOS PROPOSITOS

        // AGREGA EL NUEVO NODO EN LA LISTA DE PLANES
        nodo_plan_nuevo->sig = Planes;
        Planes = nodo_plan_nuevo;

        //TOMA LA LINEA DE REQUISITOS
        resto_linea[0] = '\0';
        ilinea++;
        for( uresto = 0; linea[ilinea] != ';'; uresto++, ilinea++ )
            resto_linea[uresto] = linea[ilinea];
        resto_linea[uresto] =  '\0';

        // SEPARAR LOS REQUISITOS
        for( iresto = 0; resto_linea[iresto] != '\0'; )
        {
            // TOMA UN ELEMENTO
            for( uelem = 0; (resto_linea[iresto] != ',') && (resto_linea[iresto] != '\0'); iresto++, uelem++ )
                elemento[uelem] = resto_linea[iresto];
            elemento[uelem] = '\0';
            // AGREGA EL ELEMENTO A LA LISTA DE REQUISITOS
            requisito_ap = (TipoRequisito *) malloc(sizeof(TipoRequisito) + 1);
            strcpy(requisito_ap->requisito ,elemento);
            // AGREGA A LA LISTA DE REQUISITOS DEL PAPEL ACTUAL
            requisito_ap->sig = nodo_plan_nuevo->requisito;
            nodo_plan_nuevo->requisito = requisito_ap;
            if( resto_linea[iresto] == ',' )
                iresto++;
        }

        //TOMA LA LINEA DE PROPOSITOS ALCANZABLES
        resto_linea[0] = '\0';
        ilinea++;
        for( uresto = 0; linea[ilinea] != '.'; uresto++, ilinea++ )
            resto_linea[uresto] = linea[ilinea];
        resto_linea[uresto] =  '\0';

        // SEPARAR LOS PROPOSITOS
        for( iresto = 0; resto_linea[iresto] != '\0'; )
        {
            // TOMA UN ELEMENTO
            for( uelem = 0; (resto_linea[iresto] != ',') && (resto_linea[iresto] != '\0'); iresto++, uelem++ )
                elemento[uelem] = resto_linea[iresto];
            elemento[uelem] = '\0';
            // AGREGA EL ELEMENTO A LA LISTA DE PROPOSITOS
            prop_ap = (TipoProposito *) malloc(sizeof(TipoProposito) + 1);
            strcpy(prop_ap->proposito ,elemento);
            prop_ap->estado = 0;
            prop_ap->sig = nodo_plan_nuevo->proposito;
            nodo_plan_nuevo->proposito = prop_ap;
            if( resto_linea[iresto] == ',' )
                iresto++;
        }

   }
   fclose( arch_plan );
    // TERMINA LA CARGA DE PLANES DEL PLANIFICADOR


    //FGrafico->Show();
    Fejecuta->Refresh();

    // INICIALIZA LA COLA DE EJECUCION (esto lo debe dejar el constructor)
    ColaInicio = NULL ;
    Box2->Clear();

    // INICIALIZA LOS EVENTOS INESPERADOS
    //MEI: Mei.papel = NULL;
    Main.hebra = NULL;

    //MEI: CargarArbol();
    //MEI: CargaEventosInesperados();

    // CREA EL AMBIENTE DE EJECUCION

    // LIMPIA LOS NODOS DEL ARBOL
    if( TreeA->Items->Count > 0 )
        TreeA->Items->Delete(TreeA->Items->Item[0]);

    if( TreeI->Items->Count > 0 )
        TreeI->Items->Delete(TreeI->Items->Item[0]);

    // RECORRE LAS VARIABLES GLOBALES
int n ;
char unnodo[100] ;

    for( n = 0; n < Fejecuta->TreeGR->Items->Count ; n++ )
    {
          //FRAGMENTA EL CONCEPTO EN SUS PARTES
          strcpy(unnodo ,TreeGR->Items->Item[n]->Text.c_str());
          if( strcmp(unnodo ,"GLOBAL") == 0 )
          {
              TreeGR->Items->Item[n]->Selected = true;
              break;
          }
    }


    global_ap = GlobalInicio;
    while( global_ap != NULL )
    {
        Fejecuta->TreeGR->Items->AddChild(Fejecuta->TreeGR->Selected ,global_ap->nombre);
        if( global_ap->tipo == 'P' )
            global_ap->valor.puerto = NULL;
        global_ap = global_ap->sig;
    }

    // RECORRE LAS VARIABLES REGIONALES
    for( n = 0; n < Fejecuta->TreeGR->Items->Count ; n++ )
    {
          //FRAGMENTA EL CONCEPTO EN SUS PARTES
          strcpy(unnodo ,TreeGR->Items->Item[n]->Text.c_str());
          if( strcmp(unnodo ,"REGIONAL") == 0 )
          {
              TreeGR->Items->Item[n]->Selected = true;
              break;
          }
    }
    regional_ap = RegionalInicio;
    while( regional_ap != NULL )
    {
        Fejecuta->TreeGR->Items->AddChild(Fejecuta->TreeGR->Selected ,regional_ap->nombre);
        regional_ap = regional_ap->sig;
    }



    NumeroAgente = 1;
    // GENERA UNA HEBRA PARA EL PROGRAMA main
    HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
    HebraNueva->tiempo = DMAhms_a_s(1 ,1 ,2000 ,6 ,0 ,0);
    HebraNueva->PC = 0;
    HebraNueva->estado = 0;
    HebraNueva->papel = Main.papel;
    HebraNueva->proposito = NULL;
    HebraNueva->stack = NULL;
    HebraNueva->local = NULL;
    HebraNueva->sig = NULL;
    HebraNueva->agente = NULL;
    Main.hebra = HebraNueva;
    sim_InsertaEjecucion(HebraNueva);

    // INICIALIZA EL INICIO DE LA SIMULACIN EN EL RELOJ GLOBAL
    ColaAnt = NULL;
    ColaAp = ColaInicio;
    Reloj = DMAhms_a_s(1 ,1 ,2000 ,6 ,0 ,0);
    uTiempo = 0;

    // ACTIVA LA SIMULACION
    ximg = 10;
    Timer1->Enabled = true;
}
//===========================================================================
// CREACION DE AGENTES
//===========================================================================
int sim_InstanciaAgente(char *agente ,char *instancia)
{
TipoAgente *buscado ;
TipoProposito *prop_ap ;
TipoEvento *evento_ap ;
TipoAccion *accion_ap ;
TipoInicial *inicial_ap ;
TipoInterna *interna_ap ;
TipoVRegion *regional_ap ;
TipoVRegion *regional_nueva ;
TipoPapel *solicitado ;
int esta ,hay ;

    AgenteAp = AgenteInicio;
    esta = NO;
    while( (AgenteAp != NULL) && (esta == NO) )
    {
        if( strcmp(agente ,AgenteAp->nombre) == 0 )
        {
            esta = SI;
            buscado = AgenteAp;
        }
        else
            AgenteAp = AgenteAp->sig;
    }
    if( esta == SI )
    {
        AgenteNueva = (TipoAgente *) malloc(sizeof(TipoAgente) + 1);
        strcpy(AgenteNueva->nombre ,instancia);
        AgenteNueva->id = NumeroAgente;
        NumeroAgente++;
        // SE COPIAN LOS PROPOSITOS DEL AGENTE BASE
        AgenteNueva->proposito = NULL;
        prop_ap = buscado->proposito;
        while( prop_ap != NULL )
        {
            sim_InsertaAgenteProposito(AgenteNueva ,prop_ap->proposito);
            prop_ap = prop_ap->sig;
        }
        // SE COPIAN LOS EVENTOS INESPERADOS QUE PERCIBE
        AgenteNueva->evento = NULL;
        evento_ap = buscado->evento;
        while( evento_ap != NULL )
        {
            sim_InsertaAgenteEvento(AgenteNueva ,evento_ap->evento);
            evento_ap = evento_ap->sig;
        }

        // SE COPIAN LAS ACCIONES PARA LOS EVENTOS INESPERADOS
        AgenteNueva->accion = NULL;
        accion_ap = buscado->accion;
        while( accion_ap != NULL )
        {
            sim_InsertaAgenteAccion(AgenteNueva ,accion_ap->accion);
            accion_ap = accion_ap->sig;
        }

        // SE COPIAN LOS PAPELES INICIALES
        AgenteNueva->inicial = NULL;
        inicial_ap = buscado->inicial;
        while( inicial_ap != NULL )
        {
            sim_InsertaAgenteInicial(AgenteNueva ,inicial_ap->inicial);
            inicial_ap = inicial_ap->sig;
        }

        AgenteNueva->hebra = NULL; // NO TIENE PAPELES ACTIVOS
        inicial_ap = AgenteNueva->inicial;
        while( inicial_ap != NULL )
        {
            // UBICAR DE LA LISTA DE PAPELES AUXILIARES EL SOLICITADO
            solicitado = Main.papel;
            hay = NO;
            while( (solicitado != NULL) && (hay == NO) )
            {
                if( strcmp(inicial_ap->inicial ,solicitado->nombre) == 0 )
                    hay = SI;
                else
                    solicitado = solicitado->sig;
            }
            if( solicitado == NULL )
            {
                inicial_ap = inicial_ap->sig;
                continue;
            }

            //SE AGREGAN LOS PAPELES INICIALES EN LA COLA DE EJECUCION
            HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
            HebraNueva->tiempo = Reloj + 1;
            HebraNueva->PC = 0;
            HebraNueva->estado = 1;
            HebraNueva->papel = solicitado;
            HebraNueva->proposito = NULL;
            HebraNueva->stack = NULL;
            HebraNueva->local = NULL;
            HebraNueva->agente = AgenteNueva;
            HebraNueva->sig = NULL;
            // SE LE CARGAN SUS VARIABLES LOCALES A LA HEBRA


             // SE LE AGREGA UN REFERENCIA A LA HEBRA
            IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
            IdHebraNueva->hebra = HebraNueva;
            IdHebraNueva->sig = AgenteNueva->hebra;
            AgenteNueva->hebra = IdHebraNueva;

            // INSERTA LA HEBRA EN LA COLA DE EJECUCION
            sim_InsertaEjecucion(HebraNueva);

            // TOMA EL SIGUIENTE PAPEL
            inicial_ap = inicial_ap->sig;
        }

        AgenteNueva->interna = NULL; // copiar internas del agente buscado
        interna_ap = buscado->interna;
        while( interna_ap != NULL )
        {
            sim_InsertaAgenteInterna(AgenteNueva ,interna_ap->nombre
                ,interna_ap->tipo ,interna_ap->dimension1
                ,interna_ap->dimension2);
            interna_ap = interna_ap->sig;
        }
        // ASIGNA MEMORIA A LAS VARIABLES INTERNAS
        interna_ap = AgenteNueva->interna;
        while( interna_ap != NULL )
        {
            switch( interna_ap->tipo )
            {
            case 'A':
                if( (interna_ap->dimension1 > 0) || (interna_ap->dimension2 > 0) )
                    interna_ap->valor.cadena = (char *)malloc(sizeof(char) * (interna_ap->dimension1 * interna_ap->dimension2 + 1));
                break;
            case 'E':
                if( (interna_ap->dimension1 > 0) || (interna_ap->dimension2 > 0) )
                    interna_ap->valor.enteros = (long *)malloc(sizeof(long) * (interna_ap->dimension1 * interna_ap->dimension2 + 1));
                break;
            case 'F':
                if( (interna_ap->dimension1 > 0) || (interna_ap->dimension2 > 0) )
                    interna_ap->valor.flotantes = (double *)malloc(sizeof(double) * (interna_ap->dimension1 * interna_ap->dimension2 + 1));
                break;
            }
            interna_ap = interna_ap->sig;
        }
        // COPIA LAS VARIABLES REGIONALES AL AGENTE NUEVO
        AgenteNueva->regional = NULL;
        regional_ap = buscado->regional;
        while( regional_ap != NULL )
        {
           regional_nueva = (TipoVRegion *)malloc(sizeof(TipoVRegion) + 1);
           strcpy(regional_nueva->nombre ,regional_ap->nombre);
           regional_nueva->sig = AgenteNueva->regional;
           AgenteNueva->regional = regional_nueva;
           regional_ap = regional_ap->sig;
        }
        AgenteNueva->instancia = NULL;

        AgenteNueva->agente = buscado; // PADRE DEL AGENTE ACTUAL
        // ANEXAR LA INSTANCIA NUEVA AL AGENTE PATRON
        AgenteNueva->sig = buscado->instancia;
        buscado->instancia = AgenteNueva;
        return SI;
    }
    return NO;
}
//===========================================================================
// CREACION DE ESPACIOS DE INTERACCION
//===========================================================================
int sim_InstanciaInteraccion(char *interaccion ,char *instancia)
{
TipoInteraccion *buscado ;
int esta ;

    InteraccionAp = InteraccionInicio;
    esta = NO;
    while( (InteraccionAp != NULL) && (esta == NO) )
    {
        if( strcmp(interaccion ,InteraccionAp->nombre) == 0 )
        {
            esta = SI;
            buscado = InteraccionAp;
        }
        else
            InteraccionAp = InteraccionAp->sig;
    }
    if( esta == SI )
    {
        InteraccionNueva = (TipoInteraccion *) malloc(sizeof(TipoInteraccion) + 1);
        strcpy(InteraccionNueva->nombre ,instancia);
        InteraccionNueva->papel = NULL;
        InteraccionNueva->origen = buscado;
        //COPIAR LOS PAPELES cupo nombre usados
        //. . . .
        InteraccionNueva->instancia = NULL;
        // ANEXAR LA INSTANCIA NUEVA A LA INTERACCION PROPIETARIA
        InteraccionNueva->sig = buscado->instancia;
        buscado->instancia = InteraccionNueva;
        return SI;
    }
    return NO;
}
//===========================================================================
// EJECUCION DE INSTRUCCIONES
//===========================================================================
int LeeVar(TipoHebra *hebra ,char *nombre ,char ambito)
{
TipoGlobal *global_ap ;
TipoLocal *local_ap ;
TipoInterna *interna_ap ;
TipoRegional *regional_ap ;
TipoVRegion *esta_regional ;
int esta ,la_percibe ;

    // BUSCA EN LOCALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'L') )
    {
        local_ap = hebra->local;
        esta = NO;
        while( (esta == NO) && (local_ap != NULL ) )
        {
            if( strcmp(local_ap->nombre ,nombre) == 0 )
            {
                 esta = SI;
                 switch( local_ap->tipo )
                 {
                 case 'A':
                     break;
                 case 'E':
                     sprintf(Buffer ,"%ld ",local_ap->valor.entero);
                     //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                     break;
                 case 'F':
                     break;
                 }
            }
            local_ap = local_ap->sig;
        }
    }
    if( esta == SI )
        return esta;

    // BUSCA EN INTERNAS
    esta = NO;
    if( ((ambito == '*') || (ambito == 'I')) && (hebra->agente != NULL) )
    {
        interna_ap = hebra->agente->interna;
        esta = NO;
        while( (esta == NO) && (interna_ap != NULL ) )
        {
            if( strcmp(interna_ap->nombre ,nombre) == 0 )
            {
                 esta = SI;
                 switch( interna_ap->tipo )
                 {
                 case 'A':
                     break;
                 case 'E':
                     sprintf(Buffer ,"%ld ",interna_ap->valor.entero);
                     //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                     break;
                 case 'F':
                     break;
                 }
            }
            interna_ap = interna_ap->sig;
        }
    }

    if( esta == SI )
        return esta;

    // BUSCA EN REGIONALES
    esta = NO;
    if( ((ambito == '*') || (ambito == 'R')) && (hebra->agente != NULL) )
    {
        // REVISAR SI EL AGENTE ACTUAL PERCIBE LA VARIABLE
        esta_regional = hebra->agente->regional;
        la_percibe = NO;
        while( (la_percibe == NO) && (esta_regional != NULL ) )
        {
            if( strcmp(esta_regional->nombre ,nombre) == 0 )
                la_percibe = SI;
            else
                esta_regional = esta_regional->sig;
        }
        if( la_percibe == SI )
        {
            // SI LA PERCIBE ENTONCES PROCESAR LA VARIABLE
            esta = NO;
            while( (esta == NO) && (regional_ap != NULL ) )
            {
                if( strcmp(regional_ap->nombre ,nombre) == 0 )
                {
                     esta = SI;
                     switch( regional_ap->tipo )
                     {
                     case 'A':
                         break;
                     case 'E':
                         sprintf(Buffer ,"%ld ",regional_ap->valor.entero);
                         //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                         break;
                     case 'F':
                         break;
                     }
                }
                regional_ap = regional_ap->sig;
            }
        }
    }

    // BUSCA EN GLOBALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'G') )
    {
        // BUSCAR EN LAS GLOBALES
        global_ap = GlobalInicio;
        esta = NO;
        while( (esta == NO) && (global_ap != NULL ) )
        {
            if( strcmp(global_ap->nombre ,nombre) == 0 )
            {
                 esta = SI;
                 switch( global_ap->tipo )
                 {
                 case 'A':
                     break;
                 case 'E':
                     sprintf(Buffer ,"%ld ",global_ap->valor.entero);
                     //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                     break;
                 case 'F':
                     break;
                 }
            }
            global_ap = global_ap->sig;
        }
    }
    return esta;
}
//---------------------------------------------------------------------------
int EscribeVar(TipoHebra *hebra ,char *nombre ,char ambito)
{
TipoGlobal *global_ap ;
TipoLocal *local_ap ;
TipoInterna *interna_ap ;
TipoRegional *regional_ap ;
TipoVRegion *esta_regional ;
int esta ,la_percibe ;

    // BUSCA EN LOCALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'L') )
    {
        local_ap = hebra->local;
        esta = NO;
        while( (esta == NO) && (local_ap != NULL ) )
        {
            if( strcmp(local_ap->nombre ,nombre) == 0 )
            {
                 esta = SI;
                 switch( local_ap->tipo )
                 {
                 case 'A':
                     break;
                 case 'E':
                     local_ap->valor.entero = atol(Buffer);
                     //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                     break;
                 case 'F':
                     break;
                 }
            }
            local_ap = local_ap->sig;
        }
    }
    if( esta == SI )
        return esta;

    // BUSCA EN INTERNAS
    esta = NO;
    if( ((ambito == '*') || (ambito == 'I')) && (hebra->agente != NULL) )
    {
        interna_ap = hebra->agente->interna;
        esta = NO;
        while( (esta == NO) && (interna_ap != NULL ) )
        {
            if( strcmp(interna_ap->nombre ,nombre) == 0 )
            {
                 esta = SI;
                 switch( interna_ap->tipo )
                 {
                 case 'A':
                     break;
                 case 'E':
                     interna_ap->valor.entero = atol(Buffer);
                     //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                     break;
                 case 'F':
                     break;
                 }
            }
            interna_ap = interna_ap->sig;
        }
    }

    if( esta == SI )
        return esta;

    // BUSCA EN REGIONALES
    esta = NO;
    if( ((ambito == '*') || (ambito == 'R')) && (hebra->agente != NULL) )
    {
        // REVISAR SI EL AGENTE ACTUAL PERCIBE LA VARIABLE
        esta_regional = hebra->agente->regional;
        la_percibe = NO;
        while( (la_percibe == NO) && (esta_regional != NULL ) )
        {
            if( strcmp(esta_regional->nombre ,nombre) == 0 )
                la_percibe = SI;
            else
                esta_regional = esta_regional->sig;
        }
        if( la_percibe == SI )
        {
            // SI LA PERCIBE ENTONCES PROCESAR LA VARIABLE
            esta = NO;
            while( (esta == NO) && (regional_ap != NULL ) )
            {
                if( strcmp(regional_ap->nombre ,nombre) == 0 )
                {
                     esta = SI;
                     switch( regional_ap->tipo )
                     {
                     case 'A':
                         break;
                     case 'E':
                         regional_ap->valor.entero = atol(Buffer);
                         //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                         break;
                     case 'F':
                         break;
                     }
                }
                regional_ap = regional_ap->sig;
            }
        }
    }

    // BUSCA EN GLOBALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'G') )
    {
        // BUSCAR EN LAS GLOBALES
        global_ap = GlobalInicio;
        esta = NO;
        while( (esta == NO) && (global_ap != NULL ) )
        {
            if( strcmp(global_ap->nombre ,nombre) == 0 )
            {
                 esta = SI;
                 switch( global_ap->tipo )
                 {
                 case 'A':
                     break;
                 case 'E':
                     global_ap->valor.entero = atol(Buffer);
                     //Fejecuta->ESTADO->Caption = "Buffer <- " + AnsiString(Buffer) + " de " + AnsiString(nombre);
                     break;
                 case 'F':
                     break;
                 }
            }
            global_ap = global_ap->sig;
        }
    }
    return esta;
}
//===========================================================================
// CONTROL DE LA EJECUCION
//===========================================================================
//---------------------------------------------------------------------------
// DETIENE LA EJECUCION
//---------------------------------------------------------------------------
void __fastcall TFejecuta::DETENERClick(TObject *Sender)
{
    Detener = SI;
}
//---------------------------------------------------------------------------
// SALIR DE LA EJECUCION
//---------------------------------------------------------------------------
void __fastcall TFejecuta::SALIRClick(TObject *Sender)
{
   Fejecuta->Close();
}
//---------------------------------------------------------------------------
// CONTINUA LA EJECUCION
//---------------------------------------------------------------------------
void __fastcall TFejecuta::CONTINUARClick(TObject *Sender)
{
    SALIR->Hide();
    UNPASO->Hide();
    DETENER->Show();
    Detener = NO;
    CONTINUAR->Hide();
    Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void sim_InsertaEjecucion(TipoHebra *hebra)
{
TipoHebra *cola_ap ,*cola_ant ;

    if( ColaInicio == NULL )
       ColaInicio = hebra;
    else
    {
        cola_ap = ColaInicio;
        cola_ant = NULL;
        // COLOCA A LA HEBRA EN SU LUGAR SEGUN RELOJ
        while( (cola_ap != NULL) &&
               (hebra->tiempo > cola_ap->tiempo) )
        {
            cola_ant = cola_ap;
            cola_ap = cola_ap->sig;
        }
        // INSERTAR LA COLA EN EL LUGAR QUE LE TOCO
        if( cola_ap == ColaInicio )
        {
            hebra->sig = ColaInicio;
            ColaInicio = hebra;
        }
        else
        {
            cola_ant->sig = hebra;
            hebra->sig = cola_ap;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TFejecuta::Timer1Timer(TObject *Sender)
{
int PC ;
TipoCola *ejecucion_ap ;
int cual ;
int d,m,a,ho,mi,se;
TipoInstruccion instr;
TipoAgente *agente_ap ,*instancia_ap ;
TipoProposito *proposito_ap ;
int tot_propositos ,alcanzados ;

    // TERMINA LA EJECUCION
    if( ColaInicio == NULL )
    {
         // REVISA EL NMERO DE PROPSITOS INTENTADOS A ALCANZAR Y
         // LOS ALCANZADOS
         /*
         tot_propositos = 0;
         alcanzados = 0;
         agente_ap = AgenteInicio;
         while( agente_ap != NULL )
         {
             instancia_ap = agente_ap->instancia;
             while( instancia_ap != NULL )
             {
                 proposito_ap = instancia_ap->proposito;
                 while( proposito_ap != NULL )
                 {
                     tot_propositos++;
                     if( proposito_ap->estado == 1 )
                         alcanzados++;
                     proposito_ap = proposito_ap->sig;
                 }
                 instancia_ap = instancia_ap->sig;
             }
             agente_ap = agente_ap->sig;
         }
         if( tot_propositos < 1 )
             Label2->Caption = "medicin de propositos";
         else
             Label2->Caption = AnsiString(tot_propositos)
                 + " propsitos "
                 + AnsiString(alcanzados / tot_propositos)
                 + "% alcanzados";
         */
         SALIR->Show();
         DETENER->Hide();
         UNPASO->Hide();
         Timer1->Enabled = false; // DETIENE LA EJECUCION DE HEBRAS
         return;
    }
    ColaAp = ColaInicio;
    if( ColaAp == NULL )
    {
        Box2->Items->Add("No hay hebras para ejecutarse ");
        return;
    }
    // DESPLEGA EL TIEMPO ACTUAL
    if( ColaAp->estado == 2 )
        ColaAp = ColaAp->sig;
    Reloj = ColaAp->tiempo;
    s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
    fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
    Fejecuta->Label1->Caption = RelojFormateado;

    /*
    Tiempo[uTiempo] = ColaAp->hebra->tiempo;
    uTiempo++;
    if( Reloj < ColaAp->hebra->tiempo )
    {
        // AVANZA A LA SIGUIENTE HEBRA ACTIVA
        ColaAnt = ColaAp;
        ColaAp = ColaAp->sig;
        // LLEGO AL FINAL DE LA LISTA?
        if( ColaAp == NULL )
        {
            ColaAp = ColaInicio;
            ColaAnt = NULL;
            sim_SeleccionaReloj();
        }
        return;
    }
    */
    PC = ColaAp->PC;
    // TOMA LA INSTRUCCION A EJECUTAR DE LA HEBRA ACTUAL
    strcpy(instr.opcode ,ColaAp->papel->instruccion[ColaAp->PC].opcode);
    strcpy(instr.op1 ,ColaAp->papel->instruccion[ColaAp->PC].op1);
    strcpy(instr.op2 ,ColaAp->papel->instruccion[ColaAp->PC].op2);
    strcpy(instr.op3 ,ColaAp->papel->instruccion[ColaAp->PC].op3);

    // DESPLEGA LA INSTRUCCION EN EJECUCION
    Fejecuta->ESTADO2->Caption = " " + AnsiString(instr.opcode)
      + " " + AnsiString(instr.op1) + " " + AnsiString(instr.op2) + " " + AnsiString(instr.op3);
    Fejecuta->ESTADO->Caption = "";
    if( strcmp(instr.opcode ,"STOP") == 0 )
    {
        // debe detener la ejecucion de la hebra y la desplanifica
    }
    if( strcmp(instr.opcode ,"CREAA") == 0 )
    {
        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        // CREA EL AGENTE
        if( sim_InstanciaAgente(instr.op1 ,instr.op2) == SI )
        {
            Box2->Items->Add(AnsiString(RelojFormateado)+ " Creating Agent "
                + AnsiString(instr.op2) + " from " + instr.op1);
            Box2->Items->Add(
            //AnsiString(RelojFormateado)+
             "Plan for "  + AnsiString(instr.op2));
            sim_Planifica();
        }
        else
            Box2->Items->Add(AnsiString(RelojFormateado)+
               " Creating Agent FAIL " + AnsiString(instr.op2));
    }
    if( strcmp(instr.opcode ,"CREAI") == 0 )
    {
        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        // CREA UNA INTERACCION
        if( sim_InstanciaInteraccion(instr.op1 ,instr.op2) == SI )
        {
            Box2->Items->Add(AnsiString(RelojFormateado)+ " Building an Interaccin Space "
                + AnsiString(instr.op2) + " from " + instr.op1);

            // REVISA A LAS INSTANCIAS DE AGENTES Y SUS PAPELES PARA DETERMINAR SI SE ASIGNAN PAPELES PARA ELLOS
        }
        else
            Box2->Items->Add(AnsiString(RelojFormateado)+
               " Building an Interaccin Space FAIL " + AnsiString(instr.op2));

    }
    if( strcmp(instr.opcode ,"APROP") == 0 )
    {
        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        Box2->Items->Add(AnsiString(RelojFormateado)+
           " ADDING PURPOSE " + AnsiString(instr.op2));
        Box2->Items->Add("    FOR AGENT " + AnsiString(instr.op1));
        // INVOCA AL MICROPLANIFICADOR
        //MEI: MicroPlanificador(ColaAp->papel->nombre ,Reloj);
    }
    if( strcmp(instr.opcode ,"OUT") == 0 )
    {
    TipoGlobal *global_ap ,*cual_puerto ;
    TipoMensaje *mensaje_nuevo ,*mensaje_ap ,*atras ,*borrar ;
    int esta_mensaje ;

        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        Box2->Items->Add(AnsiString(RelojFormateado)+
           " SEND VAR " + AnsiString(instr.op1));
        Box2->Items->Add(" WITH CONTENT " + AnsiString(instr.op2) + " " + AnsiString(instr.op3)  );

        // BUSCA EN LAS VARIABLES GLOBALES EL APUNTADOR AL CONTENIDO DEL MENSAJE
        global_ap = GlobalInicio;
        cual_puerto = NULL;
        while( (cual_puerto == NULL) && (global_ap != NULL ) )
        {
            if( strcmp(global_ap->nombre ,instr.op1) == 0 )
            {
                 cual_puerto = global_ap;
            }
            global_ap = global_ap->sig;
        }
        if( cual_puerto != NULL )
        {
            /*
            // SI HAY ALGUNA VARIABLE ESPERANDO EL VALOR YA NO LA GUARDES SINO UTILIZALA
            atras = NULL;
            borrar = NULL;
            esta_mensaje = NO;
            mensaje_ap = cual_puerto->valor.puerto;
            while( (mensaje_ap != NULL) && (esta_mensaje == NO) )
            {
                if( strcmp(mensaje_ap->variable ,Cadena[atoi(instr.op2 + 1)].cadena) == 0 )
                {
                    if( mensaje_ap->tipo == 2 )
                    {
                        sprintf(Buffer ,"%s" ,Cadena[atoi(instr.op2 + 1)].cadena);
                        EscribeVar(mensaje_ap->quien ,mensaje_ap->variable ,'*');
                        mensaje_ap->quien->estado = 1;
                        mensaje_ap->quien->tiempo = Reloj + 10;
                        esta_mensaje = SI;
                        borrar = mensaje_ap;
                        if( atras == NULL )
                        {
                            cual_puerto->valor.puerto = mensaje_ap->sig;
                            free(borrar);
                        }
                        else
                        {
                            atras->sig = mensaje_ap->sig;
                            free(borrar);
                        }
                    }
                    if( esta_mensaje == NO )
                    {
                       atras = mensaje_ap;
                       mensaje_ap = mensaje_ap->sig;
                    }
                }
            }
            */
            // INSERTAR LA VARIABLE EN EL PUERTO
            mensaje_nuevo = (TipoMensaje *) malloc(sizeof(TipoMensaje) + 1);
            strcpy(mensaje_nuevo->variable ,Cadena[atoi(instr.op2 + 1)].cadena);
            strcpy(mensaje_nuevo->contenido ,Cadena[atoi(instr.op3 + 1)].cadena);
            mensaje_nuevo->tipo = 1;
            mensaje_nuevo->sig = cual_puerto->valor.puerto;
            cual_puerto->valor.puerto = mensaje_nuevo;


        }
        // AGREGA AL FINAL DE LA COLA DEL PUERTO EL MENSAJE QUE ACABA DE LLEGAR
        // AL MOMENTO DE COLOCAR UN MENSAJE REVISA SI HAY ALGUN MENSAJE ESPERANDO EN LA COLA
        // DE ESA VARIABLE, HABILITA A LA HEBRA EN ESPERA PARA QUE PUEDA CONTINUAR SU EJECUCION



    }
    if( strcmp(instr.opcode ,"ACCEPT") == 0 )
    {
    TipoGlobal *global_ap ,*cual_puerto ;
    TipoMensaje *mensaje_nuevo ,*mensaje_ap ,*atras ,*borrar ;
    int esta_mensaje ;

        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        Box2->Items->Add(AnsiString(RelojFormateado)+
           " ACCEPT VAR " + AnsiString(instr.op1));
        Box2->Items->Add(" CONTENT " + AnsiString(instr.op2) + " " + AnsiString(instr.op3));

        // BUSCA EN GLOBALES EL PUERTO DESEADO
        global_ap = GlobalInicio;
        cual_puerto = NULL;
        while( (cual_puerto == NULL) && (global_ap != NULL ) )
        {
            if( strcmp(global_ap->nombre ,instr.op1) == 0 )
            {
                 cual_puerto = global_ap;
            }
            global_ap = global_ap->sig;
        }
        /*
        if( cual_puerto != NULL )
        {
            // BUSCA LA VARIABLE DE INTERES
            atras = NULL;
            borrar = NULL;
            esta_mensaje = NO;
            mensaje_ap = cual_puerto->valor.puerto;
            while( (mensaje_ap != NULL) && (esta_mensaje == NO) )
            {
                if( strcmp(mensaje_ap->variable ,Cadena[atoi(instr.op2 + 1)].cadena) == 0 )
                {
                    sprintf(Buffer ,"%s" ,Cadena[atoi(instr.op2 + 1)].cadena);
                    EscribeVar(ColaAp ,mensaje_ap->variable ,'*');
                    esta_mensaje = SI;
                    borrar = mensaje_ap;
                    if( atras == NULL )
                    {
                        cual_puerto->valor.puerto = mensaje_ap->sig;
                        free(borrar);
                    }
                    else
                    {
                        atras->sig = mensaje_ap->sig;
                        free(borrar);
                    }
                }
                if( esta_mensaje == NO )
                {
                    atras = mensaje_ap;
                    mensaje_ap = mensaje_ap->sig;
                }
            }
            if( esta_mensaje == NO )
            {
                // INSERTAR UN REQUERIMIENTO EN EL PUERTO Y SUSPENDE LA HEBRA
                mensaje_nuevo = (TipoMensaje *) malloc(sizeof(TipoMensaje) + 1);
                strcpy(mensaje_nuevo->variable ,Cadena[atoi(instr.op2 + 1)].cadena);
                mensaje_nuevo->tipo = 2;
                mensaje_nuevo->quien = ColaAp;
                ColaAp->estado = 2;
                mensaje_nuevo->sig = cual_puerto->valor.puerto;
                cual_puerto->valor.puerto = mensaje_nuevo;
            }
        }
        */
    }

    if( strcmp(instr.opcode ,"IMEI") == 0 )
    {
        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        Box2->Items->Add(AnsiString(RelojFormateado)+
           " Inicia " + AnsiString(ColaAp->papel->nombre) + " (EI)");
        // INVOCA AL MICROPLANIFICADOR
        //MEI: MicroPlanificador(ColaAp->papel->nombre ,Reloj);
    }
    if( strcmp(instr.opcode ,"FMEI") == 0 )
    {
        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        Box2->Items->Add(AnsiString(RelojFormateado)+
            " Termina " + AnsiString(ColaAp->papel->nombre) + " (EI)" );
        // rutina en C que termina el evento inesperado
    }
    if( strcmp(instr.opcode ,"Pr") == 0 )
    {
/*
TGraphic *imagen = new Graphics::TBitmap;
    imagen->LoadFromFile("nubes.bmp");
    FGrafico->Image1->Canvas->Brush->Color = (TColor)0xffffff;
    FGrafico->Image1->Canvas->Rectangle(ximg,0,ximg + 20 ,20);
    FGrafico->Image1->Canvas->Draw(ximg + 20 ,50 ,imagen);
*/
    /*  COPIA UN PEDAZO DE IMAGEN PARA COLOCAR OTRA COSA Y LUEGO LA
    VUELVE A PONERs

    Graphics::TBitmap *Bitmap;

TRect   MyRect, MyOther;

MyRect = Rect(10,10,100,100);

MyOther = Rect(10,111,100, 201);
Bitmap = new Graphics::TBitmap;
Bitmap->LoadFromFile("c:\windows\tartan.bmp");
Form1->Canvas->BrushCopy(MyRect, Bitmap, MyRect, clBlack);
Form1->Canvas->CopyRect(MyOther, Bitmap->Canvas, MyRect);
delete Bitmap;
    */
  /*
    FGrafico->Image1->Refresh();

    ximg += 10;

    FGrafico->Image1->Canvas->Brush->Color = (TColor)0xff0000;
    FGrafico->Image1->Canvas->Rectangle(ximg,0,ximg + 20 ,20);
    FGrafico->Image1->Refresh();
  */
        cual = atoi(instr.op1 + 1);
        s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
        fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,RelojFormateado);
        if( ColaAp->agente == NULL )
        {
            Box2->Items->Add(AnsiString(RelojFormateado)
            + " "
            + AnsiString(Cadena[cual].cadena));
            Edit1->Text = AnsiString(RelojFormateado) + " "
                + AnsiString(Cadena[cual].cadena);
        }
        else
        {
            Box2->Items->Add(AnsiString(RelojFormateado)
                + " "
                + AnsiString(ColaAp->agente->nombre)
                + ": "
                + AnsiString(Cadena[cual].cadena));
            Edit1->Text = AnsiString(RelojFormateado) + " "
                + AnsiString(ColaAp->agente->nombre) + ": "
                + AnsiString(Cadena[cual].cadena);
        }
        Box2->Refresh();
        Edit1->Refresh();
    }
    if( strcmp(instr.opcode ,"WAIT") == 0 )
    {
        ColaAp->tiempo += atoi(instr.op1);
    }
    if( strcmp(instr.opcode ,"JEQ") == 0 )
    {
        if( ColaAp->condicion == 1 )
            ColaAp->PC = atoi(instr.op1);

    }
    if( strcmp(instr.opcode ,"JMP") == 0 )
    {
        ColaAp->PC = atoi(instr.op1);

    }
    if( strcmp(instr.opcode ,"SUMA") == 0 )
    {
        ColaAp->R = ColaAp->tA + ColaAp->tB;
        Fejecuta->ESTADO->Caption = AnsiString(ColaAp->R) + " = " + AnsiString(ColaAp->tA) + " + " + AnsiString(ColaAp->tB);

    }
    if( strcmp(instr.opcode ,"AND") == 0 )
    {
        Fejecuta->ESTADO->Caption = AnsiString(ColaAp->tA) + " && " + AnsiString(ColaAp->tB) + "???";
        if( (ColaAp->tA > 0) &&
          (ColaAp->tB > 0) )
            ColaAp->R = 1;
        else
            ColaAp->R = 0;
    }
    if( strcmp(instr.opcode ,"CMP") == 0 )
    {
        if( strcmp(instr.op1 ,"R") == 0 )
        {
            if( ColaAp->R == atof(instr.op2) )
                ColaAp->condicion = 1;
            else
                ColaAp->condicion = 0;
        }
    }
    if( strncmp(instr.opcode ,"CMP" ,3) == 0 )
    {
        //Box2->Items->Add("---> CMP");
        if( instr.opcode[3] == '<')
        {
            Fejecuta->ESTADO->Caption = AnsiString(ColaAp->tA) + " < " + AnsiString(ColaAp->tB) + "???";
            if( ColaAp->tA < ColaAp->tB )
                ColaAp->R = 1;
            else
                ColaAp->R = 0;
        }
        if( instr.opcode[3] == '=')
        {
            Fejecuta->ESTADO->Caption = AnsiString(ColaAp->tA) + " == " + AnsiString(ColaAp->tB) + "???";
            if( ColaAp->tA == ColaAp->tB )
                ColaAp->R = 1;
            else
                ColaAp->R = 0;
        }

    }
    if( strcmp(instr.opcode ,"MOVviS") == 0 )
    {
        //ColaAp->
    // MUEVE LA CADENA A LA VARIABLE INDICADA DE ACUERDO AL INDICE NUMERICO EXISTENTE
        // ResuelveAlfa(Variable);
        // GUARDA LA CADENA EN LA VARIABLE DE ACUERDO A i

    }
    if( strcmp(instr.opcode ,"CLRSTK") == 0 )
    {
        //Box2->Items->Add("---> CLRSTK");
        StackLimpia = ColaAp->stack;
        while( StackLimpia != NULL )
        {
           StackActual = StackLimpia;
           StackLimpia = StackActual->sig;
           free(StackActual);
        }
        ColaAp->stack = NULL;

    }
    if( strncmp(instr.opcode ,"PUSH" ,4) == 0 )
    {
        //Box2->Items->Add("---> PUSH");
        if( instr.opcode[4] == 'n')
        {
            StackActual = (TipoStack *) malloc(sizeof(TipoStack) + 1);
            StackActual->valor = atof(instr.op1);

            Fejecuta->ESTADO->Caption = "stack <-- " + AnsiString(instr.op1);

            StackActual->sig = ColaAp->stack;
            ColaAp->stack = StackActual;
        }
        if( instr.opcode[4] == 'v')
        {

            StackActual = (TipoStack *) malloc(sizeof(TipoStack) + 1);
            LeeVar(ColaAp ,instr.op1,'*');
            StackActual->valor = atof(Buffer);
            Fejecuta->ESTADO->Caption = "stack <-- " + AnsiString(instr.op1) + " = " + AnsiString(Buffer);
            StackActual->sig = ColaAp->stack;
            ColaAp->stack = StackActual;
        }
        if( instr.opcode[4] == 's')
        {
            StackActual = (TipoStack *) malloc(sizeof(TipoStack) + 1);
            if( strcmp(instr.op1 ,"tA") == 0 )
            {
                StackActual->valor = ColaAp->tA;
            }
            if( strcmp(instr.op1 ,"tB") == 0 )
            {
                StackActual->valor = ColaAp->tB;
            }
            if( strcmp(instr.op1 ,"R") == 0 )
            {
                StackActual->valor = ColaAp->R;
            }
            Fejecuta->ESTADO->Caption = "stack <-- " + AnsiString(instr.op1) + " = " + AnsiString(StackActual->valor);
            StackActual->sig = ColaAp->stack;
            ColaAp->stack = StackActual;
        }
    }
    if( strncmp(instr.opcode ,"POP" ,3) == 0 )
    {
        //Box2->Items->Add("---> POP");
        if( instr.opcode[3] == 'v')
        {
            if( ColaAp->stack != NULL )
            {
                sprintf(Buffer ,"%f" ,ColaAp->stack->valor);
                EscribeVar(ColaAp ,instr.op1,'*');
                Fejecuta->ESTADO->Caption = "stack --> " + AnsiString(instr.op1) + " = " + AnsiString(Buffer);
                // QUITA EL OPERADOR DEL STACK
                StackActual = ColaAp->stack;
                ColaAp->stack = ColaAp->stack->sig;
                free(StackActual);
            }
        }
        if( instr.opcode[3] == 's')
        {
            if( ColaAp->stack != NULL )
            {
                sprintf(Buffer ,"%f " ,ColaAp->stack->valor);
                Fejecuta->ESTADO->Caption = "stack -> " + AnsiString(instr.op1) + " = " +AnsiString(Buffer);
                if( strcmp(instr.op1 ,"tA") == 0 )
                {
                    ColaAp->tA = atof(Buffer);
                }
                if( strcmp(instr.op1 ,"tB") == 0 )
                {
                    ColaAp->tB = atof(Buffer);
                }
                if( strcmp(instr.op1 ,"R") == 0 )
                {
                    ColaAp->R = atof(Buffer);
                }
                // QUITA EL OPERADOR DEL STACK
                StackActual = ColaAp->stack;
                ColaAp->stack = ColaAp->stack->sig;
                free(StackActual);
            }
        }

    }
    // PASA A LA SIGUIENTE INSTRUCCION
    ColaAp->PC++;
    ColaAp->tiempo += sim_Duracion(instr.opcode);
    ColaInicio = ColaAp->sig;
    // TERMINO LA HEBRA ACTUAL?
    if( PC < (ColaAp->papel->u_instruccion  - 1) )
    {

        // ES HEBRA UNICA
        if( ColaInicio == NULL )
            ColaInicio = ColaAp;
        else
        {
            // SI PUEDE CONTINUA EJECUTANDO LA MISMA HEBRA
            if( ColaAp->tiempo < ColaInicio->tiempo )
            {
                ColaAp->sig = ColaInicio;
                ColaInicio = ColaAp;
            }
            else
                sim_InsertaEjecucion(ColaAp);
        }
    }
    else
    {
        // LIBERA LAS VARIABLES LOCALES DE LA HEBRA

        free(ColaAp);
    }
    if( Detener == SI )
    {
         Timer1->Enabled = false;
         UNPASO->Show();
         DETENER->Hide();
         CONTINUAR->Show();
         SALIR->Show();
    }
}
//===========================================================================
// DESTRUCCION DEL AMBIENTE DE EJECUCION
//===========================================================================
void __fastcall TFejecuta::saliendo(TObject *Sender, TCloseAction &Action)
{
    Box2->Items->Add("Destruyendo Ambiente");
    sim_Destruye();
}
//---------------------------------------------------------------------------
void sim_Destruye(void)
{
TipoGlobal *global ;
TipoRegional *regional ,*regional_ap ;
TipoAgente *agente ;
TipoProposito *proposito_ap ,*proposito ;
TipoInterna *interna_ap ,*interna ;
TipoVRegion *region ,*region_ap ;
TipoPapel *papel_ap ,*papel ;
TipoLocal *local_ap ,*local ;


    // LIBERA LAS VARIABLES GLOBALES
    GlobalAp = GlobalInicio;
    while( GlobalAp != NULL )
    {
        global = GlobalAp;
        GlobalAp = GlobalAp->sig;
        free(global);
    }

    // LIBERA LAS VARIABLES REGIONALES
    RegionalAp = RegionalInicio;
    while( RegionalAp != NULL )
    {
        regional = RegionalAp;
        RegionalAp = RegionalAp->sig;
        free(regional);
    }

    // LIBERA LOS AGENTES
    AgenteAp = AgenteInicio;
    while( AgenteAp != NULL )
    {
        agente = AgenteAp;
        AgenteAp = AgenteAp->sig;
        // LIBERA LAS INSTANCIAS DEL AGENTE

        // LIBERA LOS PROPOSITOS DEL AGENTE
        proposito_ap = agente->proposito;
        while( proposito_ap != NULL )
        {
            proposito = proposito_ap;
            proposito_ap = proposito_ap->sig;
            free(proposito);
        }

        // LIBERA LAS VARIABLES INTERNAS DEL AGENTE
        interna_ap = agente->interna;
        while( interna_ap != NULL )
        {
            interna = interna_ap;
            interna_ap = interna_ap->sig;
            free(interna);
        }

        // LIBERA LAS VARIABLES REGIONALES DEL AGENTE
        region_ap = agente->regional;
        while( region_ap != NULL )
        {
            region = region_ap;
            region_ap = region_ap->sig;
            free(region);
        }

        // LIBERA LOS METODOS DEL AGENTE
        /*
        papel_ap = agente->inicial;
        while( papel_ap != NULL )
        {
            papel = papel_ap;
            papel_ap = papel_ap->sig;

            // LIBERA LAS VARIABLES LOCALES DEL PAPEL
            local_ap = papel->local;
            while( local_ap != NULL )
            {
                local = local_ap;
                local_ap = local_ap->sig;
                free(local);
            }
            // LIBERA LAS INSTRUCCIONES DEL PAPEL DEL AGENTE
            free(papel->instruccion);
            free(papel);
        }
        */
        free(agente);
    }
}
//===========================================================================
// PLANIFICADOR
//===========================================================================
void sim_Planifica(void)
{
TipoPapel *papel_ap ;
int faltan ;
int d,m,a,ho,mi,se;
int cual ;
TipoMultiPlan *eleccion ,*plan_agente ,*eleccion_ap ,*borrar ;

char papeles[100][30] ;
int upapel ,ipapel ;

int matriz[100][100] ;
int xm ,ym ;

TipoElemento *ag_recurso ,*ag_proposito ,*elem_nueva ,*ag_prop_ap ,*ag_recurso_ap;
TipoProposito *prop_ap ;
TipoInterna *interna_ap ;
int alcanza_proposito ;
TipoInteraccion *instancia_ap ;
TipoPapel *papel_int_ap ;
int encontre_papel ,nunca_encontre_papel ;

    if( AgenteNueva == NULL )
        return; // NO HAY AGENTE

    // COPIA LOS PROPOSITOS QUE QUIERE ALCANZAR EL AGENTE
    ag_proposito = NULL;
    prop_ap = AgenteNueva->proposito;
    while( prop_ap != NULL)
    {
        elem_nueva = (TipoElemento *) malloc(sizeof(TipoElemento) + 1);
        strcpy(elem_nueva->nombre ,prop_ap->proposito);
        elem_nueva->sig = ag_proposito;
        ag_proposito = elem_nueva;
        prop_ap = prop_ap->sig;
    }

    // COPIA LOS RECURSOS DEL AGENTE
    ag_recurso = NULL;
    interna_ap = AgenteNueva->interna;
    while( interna_ap != NULL)
    {
        elem_nueva = (TipoElemento *) malloc(sizeof(TipoElemento) + 1);
        strcpy(elem_nueva->nombre ,interna_ap->nombre);
        elem_nueva->sig = ag_recurso;
        ag_recurso = elem_nueva;
        interna_ap = interna_ap->sig;
    }

    // PARA CADA PROPSITO ACTUAL
    ag_prop_ap = ag_proposito;
    while( ag_prop_ap != NULL )
    {
/*
        Fejecuta->Box2->Items->Add(
        "Busco el proposito " + AnsiString(ag_prop_ap->nombre));
        Fejecuta->Box2->Refresh();
*/
        // BUSCA LOS PAPELES QUE PUEDEN ALCANZAR EL PROPSITO ACTUAL

        plan_agente = NULL;
        PlanesAp = Planes;
        while( PlanesAp != NULL )
        {
            prop_ap = PlanesAp->proposito;
            alcanza_proposito = NO;
            while( (prop_ap != NULL) && (alcanza_proposito == NO) )
            {
                if( strcmp(prop_ap->proposito ,ag_prop_ap->nombre) == 0)
                    alcanza_proposito = SI;
                prop_ap = prop_ap->sig;
            }
            if( alcanza_proposito == SI )
            {

/*
                 Fejecuta->Box2->Items->Add
                   ("El papel sirve " + AnsiString(PlanesAp->papel));
                 Fejecuta->Box2->Refresh();
*/
                 // AGREGA EL PAPEL EN LA LISTA DE PAPELES DEL AGENTE
                 eleccion = (TipoMultiPlan *) malloc(sizeof(TipoMultiPlan) + 1);
                 eleccion->posible = PlanesAp;
                 eleccion->beneficios = 0; // CUENTA CUANTOS PROPOSITOS DEL MISMO AGENTE ALCANZA ESTE PLAN
                 eleccion->necesita = 0; // CUENTA CUANTOS RECURSOS ADICIONALES LE FALTAN AL AGENTE
                 eleccion->sig = plan_agente;
                 plan_agente = eleccion;
            }
            PlanesAp = PlanesAp->sig;
        }
        // DETERMINA CUAL ES EL MEJOR PAPEL
        //Fejecuta->Box2->Items->Add("Busco el mejor");
        // ADICIONA EL MEJOR PAPEL EN EL PLAN DEL AGENTE
        //Fejecuta->Box2->Items->Add("ADICIONO EL MEJOR");

        ag_prop_ap = ag_prop_ap->sig;
    }
    // ORGANIZA LA LISTA DE PLANES DE ACUERDO A SU CAUSALIDAD

    // REVISA LA COMPATIBILIDAD ENTRE PAPELES

    // RECORRE EL PLAN DEL AGENTE
    nunca_encontre_papel = NO;
    eleccion_ap = plan_agente;
    while( eleccion_ap != NULL )
    {
        encontre_papel = NO;
        // BUSCA EN LOS ESPACIOS DE INTERACCIN EL PAPEL DEL PLAN DEL AGENTE
        InteraccionAp = InteraccionInicio;
        while( (InteraccionAp != NULL) && (encontre_papel == NO) )
        {
            // BUSCA EN LAS INSTANCIAS DE LA INTERACCION
            instancia_ap = InteraccionAp->instancia;
            while( (instancia_ap != NULL) && (encontre_papel == NO) )
            {
                // BUSCA EN LOS PAPELES DE LA INTERACCION
                papel_int_ap = InteraccionAp->papel;
                while( (papel_int_ap != NULL) && (encontre_papel == NO) )
                {
                    if( strcmp(eleccion_ap->posible->papel ,
                        papel_int_ap->nombre) == 0 )
                    {
                        // REVISA SI HAY CUPO PARA OCUPARLO

                        encontre_papel = SI;
                        nunca_encontre_papel = SI;

                        Fejecuta->Box2->Items->Add("    " + AnsiString(eleccion_ap->posible->papel));

                        // CREAR UNA HEBRA PARA EL PAPEL ACTUAL
                        HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
                        HebraNueva->tiempo = Reloj + sim_Duracion("CREAA");
                        HebraNueva->PC = 0;
                        HebraNueva->estado = 0;
                        HebraNueva->papel = papel_int_ap;
                        HebraNueva->proposito = NULL;
                        HebraNueva->stack = NULL;
                        HebraNueva->agente = AgenteNueva;

                        // IDENTIFICADOR DE LA HEBRA PARA EL AGENTE
                        IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
                        IdHebraNueva->hebra = HebraNueva;
                        IdHebraNueva->sig = AgenteNueva->hebra;
                        AgenteNueva->hebra = IdHebraNueva;

                        // INSERTAR EN LA COLA DE EJECUCION EL ACTIVO CREADO
                        sim_InsertaEjecucion(HebraNueva);

                        // INDICA QUE SE OCUPO EL PAPEL
                    }
                    papel_int_ap = papel_int_ap->sig;
                }
            }
            InteraccionAp = InteraccionAp->sig;
        }

        // SI LO ENCUENTRA GENERA UNA HEBRA

            // INSERTA LA HEBRA EN LA COLA DE EJECUCION


        // BORRA EL PAPEL DEL PLAN
        borrar = eleccion_ap;
        eleccion_ap = eleccion_ap->sig;
        free(borrar);
    }
    if( nunca_encontre_papel == NO )
        Fejecuta->Box2->Items->Add("    No plan found");
}
//---------------------------------------------------------------------------
void __fastcall TFejecuta::UNPASOClick(TObject *Sender)
{
Timer1->Enabled = true;
}
//---------------------------------------------------------------------------


