//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "primero.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFprimero *Fprimero;
//---------------------------------------------------------------------------
#include <stdlib.h>

#include "ambiente2.h"
#include "LIAtiempo.h"
#include "LIAtiempo.c"
#include "EvInespera2.h"  // MEI:

#define MAXIMOS 100

//---------------------------------------------------------------------------
// VARIABLES DEL AMBIENTE DE EJECUCION
TipoGlobal Global[30] ; int UGlobal ,IGlobal ;
TipoRegional Regional[20] ; int URegional ,IRegional ;
TipoAgente Agente[20] ; int UAgente ,IAgente ;
TipoAgente *AgenteNueva ;
TipoInteraccion Interaccion[25] ; int UInteraccion ,IInteraccion ;
TipoInteraccion *InteraccionNueva ;
TipoPapel *PapelNueva ,*PapelAp ;
TipoMain Main ;
TipoPapel *FinMain ;
TipoIdHebra *IdHebraNueva ;

// ETIQUETAS
TipoEtiqueta Etiqueta[200] ;
int UEtiqueta ,IEtiqueta ;

// CADENAS
TipoCadena Cadena[200] ;
int UCadena ,ICadena ;

// COLA DE EJECUCION
TipoHebra *ColaInicio ,*ColaAp ,*ColaAnt ,*ColaAnte ,*ColaApt ,*ColaAux ,*ColaAntAux ;
TipoDuracion Duracion[100] =
  {
  {"WAIT",0} ,{"JMP",4} ,{"Pr",3} ,{"CLRSTK",1} ,{"PUSHv",3}
  ,{"CREAA",7} ,{"CREAI",7} ,{"MOVviS",5} ,{"",0} ,{"",0}
  };
// modif: Colocar la tabla en un archivo

// VARIABLES DE EJECUCION
long Reloj ;
TipoHebra *HebraNueva ;
int Dormir ;
char Buffer[250] ;
TipoStack *StackLimpia ,*StackActual ;

// VARIABLES PARA PLANEACION
 TipoNodoPlan *Planes ,*PlanesAp ;


char ElTiempo[30] ;

// VARIABLES PARA EL PLANIFICADOR
typedef struct EstructuraPapeles
{
    TipoPapel *apPapel ;
    int interaccion ;
    char papel[100];
    char requisito[200] ;
    char positivo[200] ;
    char negativo[200] ;
} TipoPapeles ;

TipoPapeles Papeles[50] ;
int UPapeles ,IPapeles ,JPapeles ;
int Primero ;


typedef struct EstructuraSituacion
{
    char predicado[25];
    char valor[100] ;
} TipoSituacion ;

TipoSituacion Situacion[200] ;
int USituacion ,ISituacion ,USituacionK ;

typedef struct EstructuraVariableValor
{
    int ultimo;
    char variable[MAXIMOS][25] ;
    char valor[MAXIMOS][50] ;
} TipoVarVal ;

TipoVarVal vReq ,vPos ,vNeg ;


int Valor[MAXIMOS] ;
int UValor ,IValor ;

typedef struct EstructuraArbol
{
    char accion[25];
    TipoPapel *papel ;
    int interaccion ;
    int requisito[MAXIMOS] ;
    int u_requisito ;
    int positivo[MAXIMOS] ;
    int u_positivo ;
    int negativo[MAXIMOS] ;
    int u_negativo ;
} TipoArbol ;

TipoArbol Arbol[300] ;
int UArbol ,IArbol ;


typedef struct EstructuraNivel
{
    int situacion_ini ;
    int situacion_fin ;
    int arbol_ini ;
    int arbol_fin ;

} TipoNivel ;

TipoNivel Nivel[MAXIMOS] ;
int UNivel ,INivel ;

typedef struct EstructuraExcPapel
{
    int A ;
    int B ;
} TipoExcPapel ;

typedef struct EstructuraExcPredicado
{
    int uno ;
    int dos ;
} TipoExcPredicado ;

typedef struct EstructuraExclusion
{
    TipoExcPapel papel[MAXIMOS];
    int u_papel ;
    TipoExcPredicado predicado[MAXIMOS] ;
    int u_predicado ;
} TipoExclusion ;

TipoExclusion Exclusion[MAXIMOS] ;
int UExclusion ,IExclusion ;


typedef struct EstructuraRequi
{
    int ultimo ;
    int req[MAXIMOS] ;
} TipoRequi ;

typedef struct EstructuraElPlan
{
    int ultimo ;
    int papel[MAXIMOS] ;
} TipoElPlan ;


typedef struct EstructuraDes
{
    int nivel ;
    int upapel ;
    int papel[30] ;
    int liga_and ;
} TipoDes;

TipoDes Des[200] ;
int uDes, IDes ;


typedef struct EstructuraSol
{
    int nivel ;
    int upapel ;
    int apunta ;
    int liga_or ;
    int papel[30] ;
} TipoSol;

TipoSol Sol[200] ;
int uSol, ISol ;


typedef struct EstructuraVector
{
    int u_valor ;
    int valor[MAXIMOS] ;
} TipoVector ;

TipoVector Vector[30] ,Entrada[30] ;
int UVector ,IVector ;
int UEntrada ,IEntrada ;

// VARIABLE PARA SABER CUAL ES LA ULTIMA MARCA DEL MENSAJE
int UltimaMarca ;

FILE *Resultados ;

//---------------------------------------------------------------------------
void Construye(void);
void fecha_FormateaDMAhms(int d ,int m ,int a ,int ho ,int mi ,int se ,char *RelojFormateado);
void sim_InsertaEjecucion(TipoHebra *hebra);
void haz_Instruccion(char *op ,char *op1 ,char *op2 ,char *op3 ,char *op4 ,char *op5);
int sim_InstanciaAgente(char *agente ,char *instancia);
TipoPapel *cargaEnMain(char *papel_deseado);
int sim_InstanciaInteraccion(char *interaccion ,char *instancia);
int LeeVar(TipoHebra *hebra ,char *nombre ,char ambito);
int EscribeVar(TipoHebra *hebra ,char *nombre ,char ambito);
void sim_Planifica(TipoAgente *agente);
void GeneraArbol(int iDes);
int HayPlan(int nivel);
// MEI: void meiNavega(void) {};

//---------------------------------------------------------------------------
class TMiThread : public TThread
{
public:
  __fastcall TMiThread(void);

private:
  void __fastcall Execute(void);
};

//---------------------------------------------------------------------------
bool continuo ;
long numero ;
TMiThread *UnaThread = new TMiThread;

//---------------------------------------------------------------------------
__fastcall TFprimero::TFprimero(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFprimero::crear(TObject *Sender)
{
FILE *acadenas ;
char caden[105] ;

    numero = 0;
    arranca->Enabled = false;
    detente->Enabled = true;
    unpaso->Enabled = false;
    continuo = true;

    // CREA EL AMBIENTE DE EJECUCION
    Construye();

    // CARGA LAS CADENAS
    acadenas = fopen("cadenas.dat","rt");
    if( acadenas != NULL )
    {
        UCadena = 0;
        while( fgets(caden, 99, acadenas) != NULL )
        {
            // QUITA EL  FINAL:
            if( caden[strlen(caden) - 1] == '\n' )
                caden[strlen(caden) - 1] = '\0';
            Cadena[UCadena].cadena = (char *)malloc(strlen(caden) + 1);
            strcpy(Cadena[UCadena].cadena ,caden);
            UCadena++;
        }
    }
    fclose(acadenas);

    // modif: cargar aqui la duracin de las directivas

    UltimaMarca = 1;

    ColaInicio = NULL;

    //NumeroAgente = 1;
    // INICIALIZA LA COLA DE EJECUCION CON main

    // FECHA Y HORA INICIALES PROPUESTAS
    MFecha->Text = "01/01/2000";
    MHora->Text = "09:00:00";

    // tomar la hora y la fecha de las variables iniciales

    //Reloj = DMAhms_a_s(1 ,1 ,2000 ,9 ,0 ,0);


    // INICIALIZA EL INICIO DE LA SIMULACIN EN EL RELOJ GLOBAL
    Box1->Clear();

    Resultados = fopen("resultados.lst" ,"wt");
    if( Resultados == NULL )
    {
        fclose(Resultados);
        Resultados = NULL;
    }

    // CARGA LOS EVENTOS INESPERADOS
    //CargarArbol(); // MEI:
    //CargaEventosInesperados(); // MEI:

}
//---------------------------------------------------------------------------
__fastcall TMiThread::TMiThread(void) : TThread(TRUE)
{
  // LIBERA LA THREAD ANTES DE INICIAR, SI ESTABA ACTIVA
  FreeOnTerminate = TRUE;

  //Resume();   // SIN COMENTARIO ASUME LA THREAD ACTIVA DESDE EL INICIO
}
//---------------------------------------------------------------------------
void estadisticas(void)
{
TipoAgente *agte ;
TipoProposito *prop ;
int cuenta ,total ,ttotal ,tcuenta ;

    fprintf(Resultados ,"\n\n             GRADO DE SATISFACCIN DE LOS AGENTES CREADOS\n             --------------------------------------------\n\n");
    fprintf(Resultados ,"AGENTE    INSTANCIA            PROPSITOS  ALCANZADOS  %% SATISFACCIN\n");
    ttotal = 0;
    tcuenta = 0;
    for( IAgente = 0; IAgente < UAgente; IAgente++ )
    {
        // RECORRE LOS AGENTES
        agte = Agente[IAgente].instancia;
        fprintf(Resultados ,"\n%s\n" ,Agente[IAgente].nombre);
        while( agte != NULL )
        {
            total = 0;
            cuenta = 0;
            prop = agte->proposito;
            // RECORRE LAS INSTANCIAS DE ESTE AGENTE
            while( prop != NULL  )
            {
                total++;
                if( prop->estado == 1 )
                    cuenta++;
                prop = prop->sig;
            }
            fprintf(Resultados ,"          %-20s %10d  %10d  %8.2f\n"
                ,agte->nombre ,total ,cuenta ,total > 0 ? (float)cuenta / (float)total * 100.0 : 0);
            ttotal += total;
            tcuenta += cuenta;
            agte = agte->sig;
        }

    }
    fprintf(Resultados ,"\n\nESTADISTICA DEL SISTEMA        %10d  %10d  %8.2f\n"
            ,ttotal ,tcuenta ,ttotal > 0 ? (float)tcuenta / (float)ttotal * 100.0 : 0);

}
//---------------------------------------------------------------------------
void __fastcall TMiThread::Execute(void)
{
int d ,m ,a ,ho ,mi ,se ;
char tiempo_desplegado[100] ;

    d = atoi(Fprimero->MFecha->Text.c_str());
    m = atoi(Fprimero->MFecha->Text.c_str() + 3);
    a = atoi(Fprimero->MFecha->Text.c_str() + 6);

    ho = atoi(Fprimero->MHora->Text.c_str());
    mi = atoi(Fprimero->MHora->Text.c_str() + 3);
    se = atoi(Fprimero->MHora->Text.c_str() + 6);

    Reloj = DMAhms_a_s(d ,m ,a ,ho ,mi ,se);

    Fprimero->MFecha->Visible = false;
    Fprimero->MHora->Visible = false;
    Fprimero->Label6->Visible = false;

    HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra));
    HebraNueva->tiempo = Reloj;
    HebraNueva->PC = 0;
    HebraNueva->estado = 0;
    HebraNueva->papel = Main.papel;
    HebraNueva->plan = NULL;
    HebraNueva->proposito = NULL;
    HebraNueva->stack = NULL;
    HebraNueva->u_local = 0;
    HebraNueva->sig = NULL;
    HebraNueva->agente = NULL;
    HebraNueva->agente_nuevo = NO;
    Main.hebra = HebraNueva;
    sim_InsertaEjecucion(HebraNueva);

//    Fprimero->Box1->Items->Add("Insertando EVENTOS INESPERADOS");

    while (!Terminated)
    {
        //MessageBeep(0xFFFFFFFF);
        MessageBeep(0xFF);
        // TOMA UNA INSTRUCCION DE LA COLA Y EJECUTALA
        if( ColaInicio == NULL )
        {
            Fprimero->detente->Enabled = false;
            Fprimero->arranca->Enabled = false;
            Fprimero->unpaso->Enabled = false;
            Suspend();
            continue;
        }
        else
        {
            // DESPLEGA LAS TAREAS
            Fprimero->BoxT->Clear();
            ColaAp = ColaInicio;
            while( ColaAp != NULL )
            {
                Fprimero->BoxT->Items->Add(
                  AnsiString(ColaAp->papel->nombre)
                  + AnsiString(" ") +
                  AnsiString(ColaAp->estado));
                ColaAp = ColaAp->sig;
            }

            ColaAp = ColaInicio;
            // SALTA LAS HEBRAS QUE ESTAN ESPERANDO
            ColaAnt = NULL;
            while( (ColaAp != NULL) && ((ColaAp->estado == 1) || (ColaAp->estado == 2) || (ColaAp->estado == 3) || (ColaAp->estado == 5)) )
            {
                ColaAnt = ColaAp;
                ColaAp = ColaAp->sig;
            }
            if( ColaAp == NULL )
            {
                Fprimero->Box1->Items->Add("No more active threads");

                Fprimero->detente->Enabled = false;
                Fprimero->arranca->Enabled = false;
                Fprimero->unpaso->Enabled = false;
                Suspend();
                continue;
            }


            Reloj = ColaAp->tiempo;
            s_a_DMAhms(Reloj ,&d ,&m ,&a ,&ho ,&mi ,&se);
            fecha_FormateaDMAhms(d ,m ,a ,ho ,mi ,se ,tiempo_desplegado);
            Fprimero->ElReloj->Caption = tiempo_desplegado;
            strcpy(ElTiempo ,tiempo_desplegado);
            Fprimero->Label1->Caption = AnsiString(tiempo_desplegado)
                + AnsiString(" ") + AnsiString(ColaAp->papel->instruccion[ColaAp->PC].opcode);
            Fprimero->BoxT->Items->Add(ColaAp->papel->instruccion[ColaAp->PC].opcode);

            // REVISA SI HAY ALGUN PAPEL DE EMERGENCIA

  /*
            ColaAux = ColaInicio;
            ColaAntAux = NULL;
            while( ColaAux != NULL )
            {
                if( ColaAux->estado == 8 )
                {
                    ColaAp = ColaAux;
                    ColaAnt = ColaAntAux;
                    ColaAux = NULL;
                    continue;
                }
                ColaAntAux = ColaAux;
                ColaAux = ColaAux->sig;
            }

  */
  if( strcmp(ColaAp->papel->instruccion[ColaAp->PC].opcode ,"STOP") == 0 )
      ColaAntAux = ColaAux;


            haz_Instruccion(ColaAp->papel->instruccion[ColaAp->PC].opcode
              ,ColaAp->papel->instruccion[ColaAp->PC].op1
              ,ColaAp->papel->instruccion[ColaAp->PC].op2
              ,ColaAp->papel->instruccion[ColaAp->PC].op3
              ,ColaAp->papel->instruccion[ColaAp->PC].op4
              ,ColaAp->papel->instruccion[ColaAp->PC].op5);

            ColaAp->PC++;

            ColaAp->tiempo += 5; //sim_Duracion(op);
            if( (ColaAp->PC - 1) < (ColaAp->papel->u_instruccion  - 1) )
            {
                // LA HEBRA CONTINUA
                if( ColaAnt == NULL )
                {
                    ColaInicio = ColaAp->sig;
                    sim_InsertaEjecucion(ColaAp);
                }
                else
                {
                    ColaAnt->sig = ColaAp->sig;
                    sim_InsertaEjecucion(ColaAp);
                }
            }
            else
            {
                // YA TERMINO LA HEBRA, ENTONCES QUITARLA DE LA COLA
                if( strcmp(ColaAp->papel->nombre, "remove message") == 0 )
                {
                TipoPapel *papel ,*antpapel ;
                int encontrado ;

                    // REMUEVE EL PAPEL UTILIZADO PARA ELIMINAR EL MENSAJE
                    papel = Main.papel;
                    antpapel = NULL;
                    encontrado = NO;
                    while( (papel != NULL) && (encontrado == NO) )
                    {
                        if( papel == ColaAp->papel )
                            encontrado = SI;
                        else
                        {
                            antpapel = papel;
                            papel = papel->sig;
                        }
                    }
                    if( encontrado == SI )
                    {
                        if( antpapel == NULL )
                        {
                            Main.papel = papel->sig;
                            free(papel);
                        }
                        else
                        {
                            antpapel->sig = papel->sig;
                            free(papel);
                        }
                    }
                }
                if( ColaAnt == NULL )
                    ColaInicio = ColaAp->sig;
                else
                    ColaAnt->sig = ColaAp->sig;
                free(ColaAp);
            }
        }
        // PROCESA EL CONTADOR
        Fprimero->Edit1->Text = numero;
        numero = (numero + 1) % 50000;

        // ESPERA Dormir MILISEGUNDOS
        Sleep(Dormir);
        if( continuo == false )
        {
            continuo = true;
            Suspend();
        }
    }

}
//---------------------------------------------------------------------------
void __fastcall TFprimero::detenteClick(TObject *Sender)
{
    UnaThread->Suspend();
    detente->Enabled = false;
    arranca->Enabled = true;
    unpaso->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TFprimero::arrancaClick(TObject *Sender)
{
    Dormir = atoi(Tic->Text.c_str());
    UnaThread->Resume();
    detente->Enabled = true;
    arranca->Enabled = false;
    unpaso->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TFprimero::unpasoClick(TObject *Sender)
{
    Dormir = atoi(Tic->Text.c_str());
    continuo = false;
    UnaThread->Resume();
    detente->Enabled = false;
    arranca->Enabled = true;
    unpaso->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TFprimero::cerrar(TObject *Sender, TCloseAction &Action)
{
  if (UnaThread)
    UnaThread->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TFprimero::terminaClick(TObject *Sender)
{
    estadisticas();
  fclose(Resultados);
  exit(0);                               
}
//---------------------------------------------------------------------------
void __fastcall TFprimero::mostrar(TObject *Sender)
{
  // ASUME QUE LA THREAD INICIA APAGADA
  detente->Enabled = false;
  arranca->Enabled = true;
  unpaso->Enabled = true;

}
//---------------------------------------------------------------------------
void separaComando(char *linea ,TipoArgumentos *arg)
{
int i_linea ,ucomando ,i_param ,u_param ;
int sigue ;

    i_linea = 0;
    ucomando = 0;
    while( (linea[i_linea] != ' ') && (linea[i_linea] != '\0') )
    {
        arg->comando[ucomando] = linea[i_linea];
        ucomando++;
        i_linea++;
    }
    arg->comando[ucomando] = '\0';
    for( i_param = 0; i_param < 5; i_param++ )
        arg->param[i_param][0] = '\0';
    u_param = 0;
    sigue = SI;
    while( sigue == SI )
    {
        if( linea[i_linea] != '\0' )
        {
            // TOMA OPERANDO
            i_linea++;
            i_param = 0;
            while( (linea[i_linea] != ' ') && (linea[i_linea] != '\0') )
            {
                arg->param[u_param][i_param] = linea[i_linea];
                i_linea++;
                i_param++;
            }
            arg->param[u_param][i_param] = '\0';
            u_param++;
        }
        else
            sigue = NO;
    }
    arg->u_param = u_param;
}
//---------------------------------------------------------------------------
int sim_InsertaAgenteRegional(TipoAgente *agente ,char *regional)
{
TipoVRegion *ant ,*regional_nueva ,*regional_ap ;
int esta ;

    // validar que exista en la lista de variables regionales: RegionalInicio
    if( agente->regional == NULL )
    {
       regional_nueva = (TipoVRegion *) malloc(sizeof(TipoVRegion));
       strcpy(regional_nueva->nombre ,regional);
       regional_nueva->sig = NULL;
       agente->regional = regional_nueva;
       return SI;
    }
    else
    {
        regional_ap = agente->regional;
        ant = NULL;
        esta = NO;
        // VALIDA QUE NO EXISTA
        while( (regional_ap != NULL) && (esta == NO) )
        {
            if( strcmp(regional ,regional_ap->nombre) == 0 )
                esta = SI;
            ant = regional_ap;
            regional_ap = regional_ap->sig;
        }
        if( esta == NO )
        {
            regional_nueva = (TipoVRegion *) malloc(sizeof(TipoVRegion) + 1);
            strcpy(regional_nueva->nombre ,regional);
            regional_nueva->sig = NULL;
            ant->sig = regional_nueva;
            return SI;
        }
        else
            return NO;
    }
}
//---------------------------------------------------------------------------
int sim_InsertaAgenteProposito(TipoAgente *agente ,char *proposito )
{
TipoProposito *ant ,*proposito_nueva ,*proposito_ap ;
int esta ;

    if( agente->proposito == NULL )
    {
       proposito_nueva = (TipoProposito *) malloc(sizeof(TipoProposito) + 1);
       strcpy(proposito_nueva->proposito ,proposito);
       proposito_nueva->estado = 0;
       proposito_nueva->elegido = NO;
       proposito_nueva->ultimo_nivel = NO_HAY;
       proposito_nueva->plan = NULL;
       proposito_nueva->sig = NULL;
       agente->proposito = proposito_nueva;
       return SI;
    }
    else
    {
        proposito_ap = agente->proposito;
        ant = NULL;
        esta = NO;
        while( (proposito_ap != NULL) && (esta == NO) )
        {
            if( strcmp(proposito ,proposito_ap->proposito) == 0 )
                esta = SI;
            ant = proposito_ap;
            proposito_ap = proposito_ap->sig;
        }
        if( esta == NO )
        {
            proposito_nueva = (TipoProposito *) malloc(sizeof(TipoProposito) + 1);
            strcpy(proposito_nueva->proposito ,proposito);
            proposito_nueva->estado = 0;
            proposito_nueva->elegido = NO;
            proposito_nueva->ultimo_nivel = NO_HAY;
            proposito_nueva->plan = NULL;
            proposito_nueva->sig = NULL;
            ant->sig = proposito_nueva;
            return SI;
        }
        else
            return NO;
    }
}
//---------------------------------------------------------------------------
int sim_InsertaAgenteEvento(TipoAgente *agente ,char *evento )
{
TipoEvento *ant ,*evento_nueva ,*evento_ap ;
int esta ;

    if( agente->evento == NULL )
    {
       evento_nueva = (TipoEvento *) malloc(sizeof(TipoEvento) + 1);
       strcpy(evento_nueva->evento ,evento);
       evento_nueva->sig = NULL;
       agente->evento = evento_nueva;
       return SI;
    }
    else
    {
        evento_ap = agente->evento;
        ant = NULL;
        esta = NO;
        while( (evento_ap != NULL) && (esta == NO) )
        {
            if( strcmp(evento ,evento_ap->evento) == 0 )
                esta = SI;
            ant = evento_ap;
            evento_ap = evento_ap->sig;
        }
        if( esta == NO )
        {
            evento_nueva = (TipoEvento *) malloc(sizeof(TipoEvento) + 1);
            strcpy(evento_nueva->evento ,evento);
            evento_nueva->sig = NULL;
            ant->sig = evento_nueva;
            return SI;
        }
        else
            return NO;
    }
}
//---------------------------------------------------------------------------
int sim_InsertaAgenteAccion(TipoAgente *agente ,char *accion )
{
TipoAccion *ant ,*accion_nueva ,*accion_ap ;
int esta ;

    if( agente->accion == NULL )
    {
       accion_nueva = (TipoAccion *) malloc(sizeof(TipoAccion) + 1);
       strcpy(accion_nueva->accion ,accion);
       accion_nueva->sig = NULL;
       agente->accion = accion_nueva;
       return SI;
    }
    else
    {
        accion_ap = agente->accion;
        ant = NULL;
        esta = NO;
        while( (accion_ap != NULL) && (esta == NO) )
        {
            if( strcmp(accion ,accion_ap->accion) == 0 )
                esta = SI;
            ant = accion_ap;
            accion_ap = accion_ap->sig;
        }
        if( esta == NO )
        {
            accion_nueva = (TipoAccion *) malloc(sizeof(TipoAccion) + 1);
            strcpy(accion_nueva->accion ,accion);
            accion_nueva->sig = NULL;
            ant->sig = accion_nueva;
            return SI;
        }
        else
            return NO;
    }
}
//---------------------------------------------------------------------------
int sim_InsertaAgenteInicial(TipoAgente *agente ,char *inicial )
{
TipoInicial *ant ,*inicial_nueva ,*inicial_ap ;
int esta ;

    //Fconstruye->Box1->Items->Add("Insertando un papel inicial en un agente");
    if( agente->inicial == NULL )
    {
       inicial_nueva = (TipoInicial *) malloc(sizeof(TipoInicial) + 1);
       strcpy(inicial_nueva->inicial ,inicial);
       inicial_nueva->sig = NULL;
       agente->inicial = inicial_nueva;
       return SI;
    }
    else
    {
        inicial_ap = agente->inicial;
        ant = NULL;
        esta = NO;
        while( (inicial_ap != NULL) && (esta == NO) )
        {
            if( strcmp(inicial ,inicial_ap->inicial) == 0 )
                esta = SI;
            ant = inicial_ap;
            inicial_ap = inicial_ap->sig;
        }
        if( esta == NO )
        {
            inicial_nueva = (TipoInicial *) malloc(sizeof(TipoInicial) + 1);
            strcpy(inicial_nueva->inicial ,inicial);
            inicial_nueva->sig = NULL;
            ant->sig = inicial_nueva;
            return SI;
        }
        else
            return NO;
    }
}
//---------------------------------------------------------------------------
int sim_InsertaInteraccionPapel(TipoInteraccion *interaccion ,char *papel)
{
TipoPapel *ant ,*papel_ap ;
int esta ;

    if( interaccion->papel == NULL )
    {
       PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel));
       strcpy(PapelNueva->nombre ,papel);
       PapelNueva->cupo = 0;
       PapelNueva->usados = 0;
       PapelNueva->requisito = NULL;
       PapelNueva->u_local = 0;
       PapelNueva->u_instruccion = 0;
       PapelNueva->instruccion = NULL;
       PapelNueva->sig = NULL;
       interaccion->papel = PapelNueva;
       return SI;
    }
    else
    {
        papel_ap = interaccion->papel;
        ant = NULL;
        esta = NO;
        while( (papel_ap != NULL) && (esta == NO) )
        {
            if( strcmp(papel ,papel_ap->nombre) == 0 )
                esta = SI;
            ant = papel_ap;
            papel_ap = papel_ap->sig;
        }
        if( esta == NO )
        {
            PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel));
            strcpy(PapelNueva->nombre ,papel);
            PapelNueva->cupo = 0;
            PapelNueva->usados = 0;
            PapelNueva->requisito = NULL;
            PapelNueva->u_local = 0;
            PapelNueva->u_instruccion = 0;
            PapelNueva->instruccion = NULL;
            PapelNueva->sig = NULL;
            ant->sig = PapelNueva;
            return SI;
        }
        else
            return NO;
    }
}
//---------------------------------------------------------------------------
int sim_InsertaRequisito(TipoPapel *papel ,char *requisito)
{
TipoRequisito *ant ,*requisito_nueva ,*requisito_ap ;
int esta ;

    if( papel->requisito == NULL )
    {
       requisito_nueva = (TipoRequisito *) malloc(sizeof(TipoRequisito) + 1);
       strcpy(requisito_nueva->requisito ,requisito);
       requisito_nueva->sig = NULL;
       papel->requisito = requisito_nueva;
       return SI;
    }
    else
    {
        requisito_ap = papel->requisito;
        ant = NULL;
        esta = NO;
        while( (requisito_ap != NULL) && (esta == NO) )
        {
            if( strcmp(requisito ,requisito_ap->requisito) == 0 )
                esta = SI;
            ant = requisito_ap;
            requisito_ap = requisito_ap->sig;
        }
        if( esta == NO )
        {
            requisito_nueva = (TipoRequisito *) malloc(sizeof(TipoRequisito) + 1);
            strcpy(requisito_nueva->requisito ,requisito);
            requisito_nueva->sig = NULL;
            ant->sig = requisito_nueva;
            return SI;
        }
        else
            return NO;
    }
}
//---------------------------------------------------------------------------
void Construye(void)
{
FILE *arch ;
FILE *tempo ;
char linea[201];
int i ,fin ,alto ,esta ,longitud ,hay_agente ,donde ;
TipoArgumentos argumento ;
int n ;
char unnodo[100] ;

    // INICIALIZA VARIABLES
    UGlobal = 0;
    URegional = 0;
    UAgente = 0;
    UPapeles = 0;
    Primero = 1;
    // ABRE EL ARCHIVO A EJECUTAR
    arch = fopen("prog.asm","rt");
    hay_agente = NO;
    fin = NO;
    while( fin == NO )
    {
        if( fgets(linea, 200, arch) == NULL )
        {
            fin = 1;
            continue;
        }
        longitud = strlen(linea);
        if( linea[longitud - 1] == '\n' )
            linea[longitud - 1] = '\0';
        separaComando(linea ,&argumento);
        if( strcmp(argumento.comando ,"G") == 0 )
        {
            // CREA UNA VARIABLE GLOBAL
            strcpy(Global[UGlobal].nombre ,argumento.param[1]);
            Global[UGlobal].tipo = argumento.param[0][0];
            Global[UGlobal].dim1 = atoi(argumento.param[2]);
            Global[UGlobal].dim2 = atoi(argumento.param[3]);
            if( Global[UGlobal].tipo == 'P' )
                Global[UGlobal].puerto = NULL;
            UGlobal++;

            // INSERTA EN LA VENTANA VISIBLE
            for( n = 0; n < Fprimero->TreeGR->Items->Count ; n++ )
            {
                  //FRAGMENTA EL CONCEPTO EN SUS PARTES
                  strcpy(unnodo ,Fprimero->TreeGR->Items->Item[n]->Text.c_str());
                  if( strcmp(unnodo ,"GLOBAL") == 0 )
                  {
                      Fprimero->TreeGR->Items->Item[n]->Selected = true;
                      break;
                  }
            }
            Fprimero->TreeGR->Items->AddChild(Fprimero->TreeGR->Selected ,Global[UGlobal - 1].nombre);
            continue;
        }
        // CREA VARIABLE REGIONAL O ADICIONALA EN LA LISTA DE UN AGENTE
        if( strcmp(argumento.comando ,"R") == 0 )
        {
            if( hay_agente == NO )
            {
                // CREA VARIABLE REGIONAL
                strcpy(Regional[URegional].nombre ,argumento.param[1]);
                Regional[URegional].tipo = argumento.param[0][0];
                Regional[URegional].dim1 = atoi(argumento.param[2]);
                Regional[URegional].dim2 = atoi(argumento.param[3]);
                URegional++;
                // INSERTA EN LA VENTANA VISIBLE
                for( n = 0; n < Fprimero->TreeGR->Items->Count ; n++ )
                {
                      //FRAGMENTA EL CONCEPTO EN SUS PARTES
                      strcpy(unnodo ,Fprimero->TreeGR->Items->Item[n]->Text.c_str());
                      if( strcmp(unnodo ,"REGIONAL") == 0 )
                      {
                          Fprimero->TreeGR->Items->Item[n]->Selected = true;
                          break;
                      }
                }
                Fprimero->TreeGR->Items->AddChild(Fprimero->TreeGR->Selected ,Regional[URegional - 1].nombre);
            }
            else
            {
                // CREA UNA REFERENCIA A LA GLOBAL DENTRO DEL AGENTE
                sim_InsertaAgenteRegional(&Agente[UAgente - 1] ,argumento.param[0]);
                continue;
            }
        }
        // CREA AGENTE
        if( strcmp(argumento.comando ,"A") == 0 )
        {
            strcpy(Agente[UAgente].nombre ,argumento.param[0]);
            Agente[UAgente].id = 0;
            Agente[UAgente].proposito = NULL;  // LISTA DE PROPOSITOS
            Agente[UAgente].u_interna = 0;
            Agente[UAgente].regional = NULL; // LISTA DE VARIABLES REGIONALES
            Agente[UAgente].evento = NULL;
            Agente[UAgente].accion = NULL;
            Agente[UAgente].inicial = NULL;
            Agente[UAgente].hebra = NULL;
            Agente[UAgente].plan  = NULL;
            Agente[UAgente].padre = -1;
            Agente[UAgente].instancia = NULL;
            Agente[UAgente].sig = NULL;

            // DESPLEGARLO EN LA LISTA DE AGENTES
            Fprimero->TreeA->Items->Item[0]->Selected = true;
            Fprimero->TreeA->Items->AddChild(
              Fprimero->TreeA->Selected ,Agente[UAgente].nombre);

            UAgente++;
            hay_agente = SI;
            continue;
        }
        // VARIABLE INTERNA DE UN AGENTE
        if( strcmp(argumento.comando ,"I") == 0 )
        {
            strcpy(Agente[UAgente - 1].interna[ Agente[UAgente - 1].u_interna ].nombre ,argumento.param[1]);
            Agente[UAgente - 1].interna[ Agente[UAgente - 1].u_interna ].tipo = argumento.param[0][0];
            Agente[UAgente - 1].interna[ Agente[UAgente - 1].u_interna ].dim1 = atoi(argumento.param[2]);
            Agente[UAgente - 1].interna[ Agente[UAgente - 1].u_interna ].dim2 = atoi(argumento.param[3]);
            Agente[UAgente - 1].u_interna++;
            continue;
        }
        // PROPOSITO DE UN AGENTE
        if( strcmp(argumento.comando ,"p") == 0 )
        {
            sim_InsertaAgenteProposito(&Agente[UAgente - 1] ,argumento.param[0]);
            continue;
        }
        // EVENTO INESPERADO PERCIBIDO
        if( strcmp(argumento.comando ,"E") == 0 )
        {
            sim_InsertaAgenteEvento(&Agente[UAgente - 1] ,argumento.param[0]);
            continue;
        }
        // ACCIONES PARA EVENTOS INESPERADOS
        if( strcmp(argumento.comando ,"a") == 0 )
        {
            sim_InsertaAgenteAccion(&Agente[UAgente - 1] ,argumento.param[0]);
            continue;
        }
        // PAPELES CON QUE "NACE" UN AGENTE
        if( strcmp(argumento.comando ,"S") == 0 )
        {
            sim_InsertaAgenteInicial(&Agente[UAgente - 1] ,argumento.param[0]);
            continue;
        }
        // INTERACCION
        if( strcmp(argumento.comando ,"i") == 0 )
        {
            strcpy(Interaccion[UInteraccion].nombre ,argumento.param[0]);
            Interaccion[UInteraccion].papel = NULL;
            Interaccion[UInteraccion].padre = -1;
            Interaccion[UInteraccion].instancia = NULL;
            Interaccion[UInteraccion].sig = NULL;

            // DESPLEGARLO EN LA LISTA DE INTERACCIONES
            Fprimero->TreeI->Items->Item[0]->Selected = true;
            Fprimero->TreeI->Items->AddChild(Fprimero->TreeI->Selected ,Interaccion[UInteraccion].nombre);

            UInteraccion++;
            continue;
        }

        // PAPEL
        if( strcmp(argumento.comando ,"P") == 0 )
        {
            sim_InsertaInteraccionPapel(&Interaccion[UInteraccion - 1] ,argumento.param[0]);
            // CARGA EL PAPEL EN LA TABLA DE PLANES DEL PLANIFICADOR
            if( Primero == NO )
                UPapeles++;
            else
                Primero = NO;
            strcpy(Papeles[UPapeles].papel ,argumento.param[0]);
            Papeles[UPapeles].interaccion = UInteraccion - 1;
            Papeles[UPapeles].apPapel = PapelNueva;
            Papeles[UPapeles].requisito[0] = '\0';
            Papeles[UPapeles].positivo[0] = '\0';
            Papeles[UPapeles].negativo[0] = '\0';
            continue;
        }
        // PAPEL
        if( strcmp(argumento.comando ,"PARAM") == 0 )
        {
            strcat(Papeles[UPapeles].papel ," ");
            strcat(Papeles[UPapeles].papel ,argumento.param[0]);
        }
        // CUPO
        if( strcmp(argumento.comando ,"c") == 0 )
        {
            PapelNueva->cupo = atoi(argumento.param[0]);
            continue;
        }
        // REQUISITOS DEL PAPEL
        if( strcmp(argumento.comando ,"r") == 0 )
        {
            sim_InsertaRequisito(PapelNueva ,argumento.param[0]);
            // ADICIONA EL REQUISITO EN LA TABLA DE PLANES
            if( strlen(Papeles[UPapeles].requisito) > 0 )
                 strcat(Papeles[UPapeles].requisito ," ");
            strcat(Papeles[UPapeles].requisito, argumento.param[0]);
            continue;
        }
        if( strcmp(argumento.comando ,"+") == 0 )
        {
            // ADICIONA EL EFECTO POSITIVO EN LA TABLA DE PLANES
            if( strlen(Papeles[UPapeles].positivo) > 0 )
                 strcat(Papeles[UPapeles].positivo ," ");
            strcat(Papeles[UPapeles].positivo, argumento.param[0]);
            continue;
        }
        if( strcmp(argumento.comando ,"-") == 0 )
        {
            // ADICIONA EL EFECTO NEGATIVO EN LA TABLA DE PLANES
            if( strlen(Papeles[UPapeles].negativo) > 0 )
                 strcat(Papeles[UPapeles].negativo ," ");
            strcat(Papeles[UPapeles].negativo, argumento.param[0]);
            continue;
        }

        // VARIABLE LOCAL
        if( strcmp(argumento.comando ,"L") == 0 )
        {
            strcpy(PapelNueva->local[PapelNueva->u_local].nombre ,argumento.param[1]);
            PapelNueva->local[PapelNueva->u_local].tipo = argumento.param[0][0];
            PapelNueva->local[PapelNueva->u_local].dim1 = atoi(argumento.param[2]);
            PapelNueva->local[PapelNueva->u_local].dim2 = atoi(argumento.param[3]);
            PapelNueva->u_local++;
            continue;
        }

        // MAIN
        if( strcmp(argumento.comando ,"m") == 0 )
        {
            PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel));
            strcpy(PapelNueva->nombre ,"main");
            PapelNueva->cupo = 1;
            PapelNueva->usados = 0;
            PapelNueva->requisito = NULL;
            PapelNueva->u_local = 0;
            PapelNueva->u_instruccion = 0;
            PapelNueva->instruccion = NULL;
            PapelNueva->sig = NULL;

            Main.papel = PapelNueva;
            FinMain = PapelNueva;
            Main.hebra = NULL;
            continue;
        }
        // INICIO DE LAS INSTRUCCIONES DE UN PAPEL
        if( strcmp(argumento.comando ,"INICIO") == 0 )
        {
           UEtiqueta = 0;
           n = 0;
           tempo = fopen("tempo.tmp","wt");
           alto = 0;
           while( alto == 0 )
           {
               if( fgets(linea, 200, arch) == NULL )
               {
                  alto = 1;
                  fin = 1;
                  continue;
               }
               longitud = strlen(linea);
               if( linea[longitud - 1] == '\n' )
                   linea[longitud - 1] = '\0';
               if( linea[0] == ':' )
               {
                   // ES UNA ETIQUETA, GUARDARLA
                   esta = 0;
                   for( IEtiqueta = 0; IEtiqueta < UEtiqueta; IEtiqueta++)
                   {
                       if(strcmp(Etiqueta[IEtiqueta].nombre ,linea + 1) == 0 )
                           esta = 1;
                   }
                   if( esta == 0 )
                   {
                       strcpy(Etiqueta[UEtiqueta].nombre ,linea + 1);
                       Etiqueta[UEtiqueta].direccion = n;
                       UEtiqueta++;
                   }
               }
               else
               {
                   fprintf(tempo ,"%s\n" ,linea);
                   n++;
               }
               if( strncmp(linea ,"STOP" ,4) == 0 )
                   alto = 1;
           }
           fprintf( tempo, "* *\n");
           for( IEtiqueta = 0; IEtiqueta < UEtiqueta; IEtiqueta++)
               fprintf( tempo, "%s %d\n",Etiqueta[IEtiqueta].nombre ,Etiqueta[IEtiqueta].direccion);
           fclose(tempo);

           PapelNueva->u_instruccion = n;
           // SE ASIGNA ESPACIO EN MEMORIA PARA QUE EL PAPEL SEA UN ARREGLO
           PapelNueva->instruccion =
               (TipoInstruccion *)malloc(sizeof(TipoInstruccion) * (n+1));

           tempo = fopen("tempo.tmp","rt");
           alto = 0;
           i = 0;
           while( alto == 0 )
           {
               if( fgets(linea, 200, tempo) == NULL )
               {
                  alto = 1;
                  continue;
               }
               longitud = strlen(linea);
               if( linea[longitud - 1] == '\n' )
                   linea[longitud - 1] = '\0';
               separaComando(linea ,&argumento);

               if( strcmp(linea ,"* *") == 0 )
               {
                  alto = 1;
                  continue;
               }
               strcpy(PapelNueva->instruccion[i].opcode ,argumento.comando);
               strcpy(PapelNueva->instruccion[i].op1 ,argumento.param[0]);
               strcpy(PapelNueva->instruccion[i].op2 ,argumento.param[1]);
               strcpy(PapelNueva->instruccion[i].op3 ,argumento.param[2]);
               strcpy(PapelNueva->instruccion[i].op4 ,argumento.param[3]);
               strcpy(PapelNueva->instruccion[i].op5 ,argumento.param[4]);


               // SUSTITUYE LAS ETIQUETAS POR LAS POSICIONES EN EL ARREGLO
               if( (strcmp(argumento.comando ,"JMP") == 0) ||
                   (strcmp(argumento.comando ,"JEQ") == 0) )
               {
                   esta = NO;
                   for( IEtiqueta = 0; (IEtiqueta < UEtiqueta) && (esta == NO); IEtiqueta++)
                       if( strcmp(Etiqueta[IEtiqueta].nombre ,argumento.param[0]) == 0 )
                       {
                           donde = IEtiqueta;
                           esta = SI;
                       }
                   if( esta == SI )
                       sprintf(PapelNueva->instruccion[i].op1 ,"%d" ,Etiqueta[donde].direccion);
                   else
                       sprintf(PapelNueva->instruccion[i].op1 ,"%d" ,n);
               }
               i++;
           }
           fclose(tempo);
        }
    }
    fclose(arch);
    UPapeles++;
}
//---------------------------------------------------------------------------
void fecha_FormateaDMAhms(int d ,int m ,int a ,int ho ,int mi ,int se ,char *RelojFormateado)
{
char t_linea[30] ;

    sprintf(RelojFormateado ,"%d/" ,d);
    if( m < 10 )
        sprintf(t_linea ,"0%d/" ,m);
    else
        sprintf(t_linea ,"%d/" ,m);
    strcat(RelojFormateado ,t_linea);
    sprintf(t_linea ,"%d " ,a);
    strcat(RelojFormateado ,t_linea);
    sprintf(t_linea ,"%d:" ,ho);
    strcat(RelojFormateado ,t_linea);
    if( mi < 10 )
        sprintf(t_linea ,"0%d:" ,mi);
    else
        sprintf(t_linea ,"%d:" ,mi);
    strcat(RelojFormateado ,t_linea);
    if( se < 10 )
        sprintf(t_linea ,"0%d" ,se);
    else
        sprintf(t_linea ,"%d" ,se);
    strcat(RelojFormateado ,t_linea);
}
//---------------------------------------------------------------------------
void sim_InsertaEjecucion(TipoHebra *hebra)
{
TipoHebra *cola_ap ,*cola_ant ;

    if( ColaInicio == NULL )
       ColaInicio = hebra;
    else
    {
        cola_ap = ColaInicio;
        cola_ant = NULL;
        // COLOCA A LA HEBRA EN SU LUGAR SEGUN RELOJ
        while( (cola_ap != NULL) &&
               (hebra->tiempo > cola_ap->tiempo) )
        {
            cola_ant = cola_ap;
            cola_ap = cola_ap->sig;
        }
        // INSERTAR LA COLA EN EL LUGAR QUE LE TOCO
        if( cola_ap == ColaInicio )
        {
            hebra->sig = ColaInicio;
            ColaInicio = hebra;
        }
        else
        {
            cola_ant->sig = hebra;
            hebra->sig = cola_ap;
        }
    }
}
//---------------------------------------------------------------------------
void GuardaInterna(TipoAgente *agente ,char *nombre)
{
int i_interna ,esta ;

    // BUSCA EN INTERNAS
    if( agente != NULL )
    {
        if( agente->u_interna > 0 )
        {
            for( esta = NO ,i_interna = 0;
              (esta == NO) && (i_interna < agente->u_interna); i_interna++ )
                if( strcmp(agente->interna[i_interna].nombre ,nombre) == 0 )
                {
                    esta = SI;
                    sprintf(agente->interna[i_interna].valor ,"%s" ,Buffer);
                }
        }
    }
}
//---------------------------------------------------------------------------
void LeeInterna(TipoAgente *agente ,char *nombre)
{
int i_interna ,esta ;

    Buffer[0] = '\0';
    // BUSCA EN INTERNAS
    if( agente != NULL )
    {
        if( agente->u_interna > 0 )
        {
            for( esta = NO ,i_interna = 0;
              (esta == NO) && (i_interna < agente->u_interna); i_interna++ )
                if( strcmp(agente->interna[i_interna].nombre ,nombre) == 0 )
                {
                    esta = SI;
                    sprintf(Buffer, "%s", agente->interna[i_interna].valor);
                }
        }
    }
}
//---------------------------------------------------------------------------//---------------------------------------------------------------------------
typedef struct EstructuraConcepto
{
    char nombre[50][50] ;
    int ultimo;
} TipoConcepto ;

typedef struct EstructuraPalabra
{
    char nombre[50][50] ;
    int ultimo;
} TipoPalabra ;

typedef struct EstructuraCandidato
{
    char concepto[50][50] ;
    char padre[50][50] ;
    int ultimo;
} TipoCandidato ;

//---------------------------------------------------------------------------
int tomaPalabras(char *concepto, char *ontologia, TipoPalabra *palabras)
{
char nomarch[100] ;
FILE *arch ;
char linea[250] ,conceptoAux[50] ,*ap ;
char palabra[50] ,candidato[50] ;

    strcpy(nomarch ,ontologia);
    strcat(nomarch ,".dic");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
    {
        return NO_HAY;
    }
    palabras->ultimo = 0;
    for( ; fgets(linea, 255, arch) != NULL;)
    {
        if( linea[strlen(linea) - 1] == '\n' )
            linea[strlen(linea) - 1] = '\0';
        // TOMA LA PALABRA
        strncpy(palabra ,linea, 30);
        ap = palabra + 29;
        // QUITA ESPACIOS FINALES:
        for(; *ap ==' ' || *ap =='\0'; ap--)
            *ap = '\0';
        // TOMA EL CONCEPTO
        strncpy(conceptoAux ,linea + 30, 30);
        if( strcmp(conceptoAux ,concepto) == 0 )
        {
            strcpy(palabras->nombre[palabras->ultimo] ,palabra);
            palabras->ultimo++;
        }
   }
   fclose(arch);
   if( palabras->ultimo == 0 )
      return NO_HAY;
   return SI;
}
//---------------------------------------------------------------------------
int tomaConceptos(char *palabra, char *ontologia, TipoConcepto *conceptos)
{
char nomarch[100] ;
FILE *arch ;
char linea[250] ,palabraAux[50] ,*ap ;
char concepto[50] ,candidata[50] ;
int esta ;

    // LOS CONCEPTOS SE ADICIONAN EN LA TABLA DE CONCEPTOS

    strcpy(nomarch ,ontologia);
    strcat(nomarch ,".dic");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
    {
        return NO_HAY;
    }
    esta = 0;
    for( ; fgets(linea, 255, arch) != NULL;)
    {
        if( linea[strlen(linea) - 1] == '\n' )
            linea[strlen(linea) - 1] = '\0';
        // TOMA LA PALABRA
        strncpy(palabraAux ,linea, 30);
        ap = palabraAux + 29;
        // QUITA ESPACIOS FINALES:
        for(; *ap ==' ' || *ap =='\0'; ap--)
            *ap = '\0';
        // TOMA EL CONCEPTO
        strncpy(concepto ,linea + 30, 30);
        if( strcmp(palabraAux ,palabra) == 0 )
        {
            strcpy(conceptos->nombre[conceptos->ultimo] ,concepto);
            conceptos->ultimo++;
        }
   }
   fclose(arch);
   if( conceptos->ultimo == 0 )
      return NO_HAY;
   return SI;
}
//---------------------------------------------------------------------------
int tomaPadre(char *concepto, char *ontologia ,char *padre)
{
FILE *arch ;
char nomarch[100] ,nodo[200] ,conceptoAux[50] ;
int i ,esta ;

    strcpy(nomarch ,ontologia);
    strcat(nomarch ,".tree");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
    {
        padre[0] = '\0';
        return NO_HAY;
    }
    fclose(arch);
    Fprimero->Tree0->LoadFromFile(nomarch);
    // BUSCA EL CONCEPTO EN EL RBOL
    esta = NO;
    for(int inodo = 0; (esta == NO) && (inodo < Fprimero->Tree0->Items->Count); inodo++ )
    {
          //FRAGMENTA EL CONCEPTO EN SUS PARTES
          strcpy(nodo ,Fprimero->Tree0->Items->Item[inodo]->Text.c_str());
          for( i = 0; nodo[i] != ':'; i++ )
              conceptoAux[i] = nodo[i];
          conceptoAux[i] = '\0';
          // SI EL CONCEPTO ES IGUAL AL DEL ARBOL
          if( strcmp(conceptoAux ,concepto)  == 0 )
          {
             Fprimero->Tree0->Items->Item[inodo]->Selected = true;
             esta = SI;
          }
    }
    // TOMA A SU PADRE
    if( esta == SI )
    {
        Fprimero->Tree0->Selected->Parent->Selected = true;
        // LIMPIA EL PADRE
        strcpy(nodo ,Fprimero->Tree0->Selected->Text.c_str());
        for( i = 0; nodo[i] != ':'; i++ )
            padre[i] = nodo[i];
        padre[i] = '\0';
        return SI;
    }
    return NO;
}
//---------------------------------------------------------------------------
int esAncestro(char *padreCandidato ,char *ontologia ,char *concepto)
{
char padre[50] ,abuelo[50] ;

    tomaPadre(concepto ,ontologia ,padre);
    tomaPadre(padre ,ontologia ,abuelo);
    if( strcmp(padreCandidato ,padre) == 0 || strcmp(padreCandidato ,abuelo) == 0 )
        return SI;
    return NO;
}
//---------------------------------------------------------------------------
void simplifica(TipoConcepto *conceptosAux ,TipoConcepto *conceptos)
{
int iconceptoAux ,iconcepto ,esta ;

    conceptos->ultimo = 0;
    for( iconceptoAux = 0; iconceptoAux < conceptosAux->ultimo; iconceptoAux++ )
    {
        esta = NO;
        for( iconcepto = 0; iconcepto < conceptos->ultimo; iconcepto++ )
            if( strcmp(conceptosAux->nombre[iconceptoAux] ,conceptos->nombre[iconcepto]) == 0 )
                esta = SI;
        if( esta == NO )
        {
            strcpy(conceptos->nombre[conceptos->ultimo] ,conceptosAux->nombre[iconceptoAux]);
            conceptos->ultimo++;
        }
    }
}
//---------------------------------------------------------------------------
int hallar(char *conceptoA ,char *ontologiaA ,char *ontologiaB ,char *conceptoB);
//---------------------------------------------------------------------------
int comparaPropiedades(char *conceptoA ,char *ontologiaA ,char *conceptoB ,char *ontologiaB)
{
int suma ;
char propiedadA[20][40] ,valorA[20][40] ,propiedadB[20][40] ,valorB[20][40] ;
int ipropA ,upropA ,ipropB ,upropB ;
char nomarch[100] ;
FILE *arch ;
int inodo ,esta , i ,iprop ,uprop ;
char nodo[200] ,propiedades[200] ,concepto[50] ;
int r1 ,r2 ;
char equivaleProp[50] ,equivaleValor[50] ;

    suma = 0;

    // CARGA EL ARBOL A
    strcpy(nomarch ,ontologiaA);
    strcat(nomarch ,".tree");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
        return NO_HAY;
    fclose(arch);
    Fprimero->Tree0->LoadFromFile(nomarch);

    // UBICA AL CONCEPTO A
    esta = NO;
    for(int inodo = 0; (esta == NO) && (inodo < Fprimero->Tree0->Items->Count); inodo++ )
    {
          //FRAGMENTA EL CONCEPTO EN SUS PARTES
          strcpy(nodo ,Fprimero->Tree0->Items->Item[inodo]->Text.c_str());
          for( i = 0; nodo[i] != ':'; i++ )
              concepto[i] = nodo[i];
          concepto[i] = '\0';

          // SI EL CONCEPTO ES IGUAL AL DEL ARBOL
          if( strcmp(conceptoA ,concepto)  == 0 )
          {
             Fprimero->Tree0->Items->Item[inodo]->Selected = true;
             esta = SI;
          }
    }
    if( esta == NO )
        return NO_HAY;

    // TOMA LAS PROPIEDADES
    i++;
    for( uprop = 0; nodo[i] != '.'; i++, uprop++ )
        propiedades[uprop] = nodo[i];
    propiedades[uprop] = '\0';

    // SEPARA LAS PROPIEDADES EN PROPIEDAD-VALOR
    upropA = 0;
    for( iprop = 0; iprop < uprop; )
    {
        for( i = 0; (propiedades[iprop] != '-') && (iprop < uprop); iprop++ ,i++ )
        {
            propiedadA[upropA][i] = propiedades[iprop];
        }
        propiedadA[upropA][i] = '\0';
        iprop++;
        for( i = 0; (propiedades[iprop] != ',') && (iprop < uprop); iprop++ ,i++ )
        {
            valorA[upropA][i] = propiedades[iprop];
        }
        valorA[upropA][i] = '\0';
        iprop++;
        upropA++;
    }

    // CARGA EL ARBOL B
    strcpy(nomarch ,ontologiaB);
    strcat(nomarch ,".tree");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
        return NO_HAY;
    fclose(arch);
    Fprimero->Tree0->LoadFromFile(nomarch);

    //UBICA AL CONCEPTO B
    esta = NO;
    for(int inodo = 0; (esta == NO) && (inodo < Fprimero->Tree0->Items->Count); inodo++ )
    {
          //FRAGMENTA EL CONCEPTO EN SUS PARTES
          strcpy(nodo ,Fprimero->Tree0->Items->Item[inodo]->Text.c_str());
          for( i = 0; nodo[i] != ':'; i++ )
              concepto[i] = nodo[i];
          concepto[i] = '\0';

          // SI EL CONCEPTO ES IGUAL AL DEL ARBOL
          if( strcmp(conceptoB ,concepto)  == 0 )
          {
             Fprimero->Tree0->Items->Item[inodo]->Selected = true;
             esta = SI;
          }
    }
    if( esta == NO )
        return NO_HAY;

    // TOMA LAS PROPIEDADES
    i++;
    for( uprop = 0; nodo[i] != '.'; i++, uprop++ )
        propiedades[uprop] = nodo[i];
    propiedades[uprop] = '\0';

    // SEPARA LAS PROPIEDADES EN PROPIEDAD-VALOR
    upropB = 0;
    for( iprop = 0; iprop < uprop; )
    {
        for( i = 0; (propiedades[iprop] != '-') && (iprop < uprop); iprop++ ,i++ )
        {
            propiedadB[upropB][i] = propiedades[iprop];
        }
        propiedadB[upropB][i] = '\0';
        iprop++;
        for( i = 0; (propiedades[iprop] != ',') && (iprop < uprop); iprop++ ,i++ )
        {
            valorB[upropB][i] = propiedades[iprop];
        }
        valorB[upropB][i] = '\0';
        iprop++;
        upropB++;
    }

    // PARA CADA PROPIEDAD DEL CONCEPTO A
    for( ipropA = 0; ipropA < upropA; ipropA++ )
        // PARA CADA PROPIEDAD DEL CONCEPTO B
        for( ipropB = 0; ipropB < upropB; ipropB++ )
             // SI HALLAR(PROPIEDAD A, PROPIEDAD B) == si
        {
             hallar(propiedadA[ipropA] ,ontologiaA ,ontologiaB ,equivaleProp);
             r1 = strcmp(propiedadB[ipropB] ,equivaleProp) == 0 ? SI : NO;
             hallar(valorA[ipropA] ,ontologiaA ,ontologiaB ,equivaleValor);
             r2 = strcmp(valorB[ipropB] ,equivaleValor) == 0 ? SI : NO;
             if( r1 ==  SI && r2 == SI )
                 suma++;
        }
    return suma;
}
//---------------------------------------------------------------------------
int hallar(char *conceptoA ,char *ontologiaA ,char *ontologiaB ,char *conceptoB)
{
TipoPalabra palA ,palPadreA ;
TipoConcepto conceptosB ,conceptosAuxB ,conceptosPadreB ,conceptosPadreAuxB ;
char padreA[50] ,padreAuxB[50] ;
int ipal ,iB ,iPB ;
TipoCandidato candidatos ;

    if( strlen(conceptoA) < 1 )
        return NO_HAY;
    if( strcmp(conceptoA ,"ALGO") == SI )
    {
        strcpy(conceptoB ,conceptoA);
        return SI;
    }
    if( tomaPalabras(conceptoA ,ontologiaA ,&palA) == NO_HAY )
        return NO_HAY;
    if( tomaPadre(conceptoA ,ontologiaA ,padreA) == NO_HAY )
        return NO_HAY;
    if( tomaPalabras(padreA ,ontologiaA ,&palPadreA) == NO_HAY )
        return NO_HAY;
    conceptosAuxB.ultimo = 0;
    for( ipal = 0; ipal < palA.ultimo; ipal++ )
        tomaConceptos(palA.nombre[ipal] ,ontologiaB ,&conceptosAuxB);
    simplifica(&conceptosAuxB ,&conceptosB);
    conceptosPadreAuxB.ultimo = 0;
    for( ipal = 0; ipal < palPadreA.ultimo; ipal++ )
        tomaConceptos(palPadreA.nombre[ipal] ,ontologiaB ,&conceptosPadreAuxB);
    simplifica(&conceptosPadreAuxB ,&conceptosPadreB);
    if( conceptosB.ultimo > 0 && conceptosPadreB.ultimo > 0 )
    {
        candidatos.ultimo = 0;
        for( iB = 0; iB < conceptosB.ultimo; iB++ )
            for( iPB = 0; iPB < conceptosB.ultimo; iPB++ )
                if( esAncestro(conceptosPadreB.nombre[iPB] ,ontologiaB ,conceptosB.nombre[iB]) == SI )
                {
                    strcpy(candidatos.concepto[ candidatos.ultimo ] ,conceptosB.nombre[iB]);
                    strcpy(candidatos.padre[ candidatos.ultimo ] ,conceptosPadreB.nombre[iPB]);
                    candidatos.ultimo++;
                }
        if( candidatos.ultimo < 1 )
        {
        // SE DESARROLLA COMO EL CASO EN QUE SE MAPEO EL CONCEPTO PERO NO SU PADRE
        int cuantas ,cuantasLocal ,cual ;

            cual = NO_HAY;
            cuantas = 0;
            for( iB = 0; iB < conceptosB.ultimo; iB++ )
            {
                cuantasLocal = comparaPropiedades(conceptoA ,ontologiaA ,conceptosB.nombre[iB], ontologiaB);
                if( cuantasLocal > cuantas )
                {
                    cual = iB;
                    cuantas = cuantasLocal;
                }
            }
            if( cual != NO_HAY )
            {
                if( cuantas > 2 )
                {
                    strcpy(conceptoB ,conceptosB.nombre[cual]);
                    return SI;
                }
                else
                {
                    strcpy(conceptoB ,"probably ");
                    strcat(conceptoB ,candidatos.concepto[cual]);
                    return SI;
                }
            }
            return NO_HAY;
        }
        if( candidatos.ultimo == 1 )
        {
            strcpy(conceptoB ,candidatos.concepto[0]);
            return SI;
        }

        // SE SELECCIONA ALGUN CANDIDATO, EN ESTE CASO DAMOS EL PRIMERO
        strcpy(conceptoB ,candidatos.concepto[0]);
        return SI;
    }
    // MAPEO EL CONCEPTO, NO SU PADRE
    if( conceptosB.ultimo > 0 && conceptosPadreB.ultimo == 0 )
    {
    int cuantas ,cuantasLocal ,cual ;

        cual = NO_HAY;
        cuantas = 0;
        for( iB = 0; iB < conceptosB.ultimo; iB++ )
        {
            cuantasLocal = comparaPropiedades(conceptoA ,ontologiaA ,conceptosB.nombre[iB], ontologiaB);
            if( cuantasLocal > cuantas )
            {
                cual = iB;
                cuantas = cuantasLocal;
            }
        }
        if( cual != NO_HAY )
        {
            if( cuantas > 2 )
            {
                strcpy(conceptoB ,conceptosB.nombre[cual]);
                return SI;
            }
            else
            {
                strcpy(conceptoB ,"probably ");
                strcat(conceptoB ,candidatos.concepto[cual]);
                return SI;
            }
        }
        return NO_HAY;
    }
    // MAPEO SU PADRE, NO EL CONCEPTO
    if( conceptosB.ultimo == 0 && conceptosPadreB.ultimo > 0 )
    {
    int cual ,esta ,inodo ,i ;
    char nomarch[100] ,nodo[200] ,concepto[50] ;
    FILE *arch ;

    int suma ;
    char propiedadA[20][40] ,valorA[20][40] ,propiedadB[20][40] ,valorB[20][40] ;
    int ipropA ,upropA ,ipropB ,upropB ;
    int iprop ,uprop ;
    char propiedades[200] ;
    int r1 ,r2 ;
    char equivaleProp[50] ,equivaleValor[50] ;

    char elconcepto[100] ;
    int cuantos ,maximo ;

        // TOMA LAS PROPIEDADES DEL CONCEPTO
        strcpy(nomarch ,ontologiaA);
        strcat(nomarch ,".tree");
        arch = fopen(nomarch ,"rt");
        if( arch == NULL )
            return NO_HAY;
        fclose(arch);
        Fprimero->Tree0->LoadFromFile(nomarch);

        // UBICA AL CONCEPTO A
        esta = NO;
        for(int inodo = 0; (esta == NO) && (inodo < Fprimero->Tree0->Items->Count); inodo++ )
        {
            // FRAGMENTA EL CONCEPTO EN SUS PARTES
            strcpy(nodo ,Fprimero->Tree0->Items->Item[inodo]->Text.c_str());
            for( i = 0; nodo[i] != ':'; i++ )
                concepto[i] = nodo[i];
            concepto[i] = '\0';

            // SI EL CONCEPTO ES IGUAL AL DEL ARBOL
            if( strcmp(conceptoA ,concepto) == 0 )
            {
                Fprimero->Tree0->Items->Item[inodo]->Selected = true;
                esta = SI;
            }
        }
        if( esta == NO )
            return NO_HAY;

        // TOMA LAS PROPIEDADES
        i++;
        for( uprop = 0; nodo[i] != '.'; i++, uprop++ )
            propiedades[uprop] = nodo[i];
        propiedades[uprop] = '\0';

        // SEPARA LAS PROPIEDADES EN PROPIEDAD-VALOR
        upropA = 0;
        for( iprop = 0; iprop < uprop; )
        {
            for( i = 0; (propiedades[iprop] != '-') && (iprop < uprop); iprop++ ,i++ )
            {
                propiedadA[upropA][i] = propiedades[iprop];
            }
            propiedadA[upropA][i] = '\0';
            iprop++;
            for( i = 0; (propiedades[iprop] != ',') && (iprop < uprop); iprop++ ,i++ )
            {
                valorA[upropA][i] = propiedades[iprop];
            }
            valorA[upropA][i] = '\0';
            iprop++;
            upropA++;
        }


        // TOMA LAS PROPIEDADES DE LOS HIJOS DEL PADRE
        hallar(padreA ,ontologiaA ,ontologiaB ,padreAuxB);
        if( strcmp(padreAuxB ,"COSA") == 0 )
            return NO_HAY;
        cual = NO_HAY;
        for( iB = 0; (cual == NO_HAY) && (iB < conceptosPadreB.ultimo); iB++ )
        {
            if( strcmp(padreAuxB ,conceptosPadreB.nombre[iB] ) != 0 )
                continue;
            cual = iB;
        }
        if( cual == NO_HAY )
            return NO_HAY;

        // CARGA EL ARBOL B
        strcpy(nomarch ,ontologiaB);
        strcat(nomarch ,".tree");
        arch = fopen(nomarch ,"rt");
        if( arch == NULL )
            return NO_HAY;
        fclose(arch);
        Fprimero->Tree0->LoadFromFile(nomarch);

        //UBICA AL CONCEPTO B
        esta = NO;
        for(int inodo = 0; (esta == NO) && (inodo < Fprimero->Tree0->Items->Count); inodo++ )
        {
              //FRAGMENTA EL CONCEPTO EN SUS PARTES
              strcpy(nodo ,Fprimero->Tree0->Items->Item[inodo]->Text.c_str());
              for( i = 0; nodo[i] != ':'; i++ )
                  concepto[i] = nodo[i];
              concepto[i] = '\0';

              // SI EL CONCEPTO ES IGUAL AL DEL ARBOL
              if( strcmp(padreAuxB ,concepto)  == 0 )
              {
                 Fprimero->Tree0->Items->Item[inodo]->Selected = true;
                 esta = SI;
              }
        }
        if( esta == NO )
            return NO_HAY;


        maximo = 0;
        elconcepto[0] = '\0';

        TTreeNode *hijo ;
        hijo = Fprimero->Tree0->Selected->getFirstChild();
        while( hijo != NULL )
        {
            strcpy(nodo ,hijo->Text.c_str());

            for( i = 0; nodo[i] != ':'; i++ )
                concepto[i] = nodo[i];
            concepto[i] = '\0';

            // TOMA LAS PROPIEDADES EN B
            i++;
            for( uprop = 0; nodo[i] != '.'; i++, uprop++ )
                propiedades[uprop] = nodo[i];
            propiedades[uprop] = '\0';

            // SEPARA LAS PROPIEDADES EN PROPIEDAD-VALOR
            upropB = 0;
            for( iprop = 0; iprop < uprop; )
            {
                for( i = 0; (propiedades[iprop] != '-') && (iprop < uprop); iprop++ ,i++ )
                {
                    propiedadB[upropB][i] = propiedades[iprop];
                }
                propiedadB[upropB][i] = '\0';
                iprop++;
                for( i = 0; (propiedades[iprop] != ',') && (iprop < uprop); iprop++ ,i++ )
                {
                    valorB[upropB][i] = propiedades[iprop];
                }
                valorB[upropB][i] = '\0';
                iprop++;
                upropB++;
            }

            // COMPARA LAS PROPIEDADES DE A CON LAS DE B
            cuantos = 0;
            // PARA CADA PROPIEDAD DEL CONCEPTO A
            for( ipropA = 0; ipropA < upropA; ipropA++ )
                // PARA CADA PROPIEDAD DEL CONCEPTO B
                for( ipropB = 0; ipropB < upropB; ipropB++ )
                     // SI HALLAR(PROPIEDAD A, PROPIEDAD B) == si
                {
                     hallar(propiedadA[ipropA] ,ontologiaA ,ontologiaB ,equivaleProp);
                     r1 = strcmp(propiedadB[ipropB] ,equivaleProp) == 0 ? SI : NO;
                     hallar(valorA[ipropA] ,ontologiaA ,ontologiaB ,equivaleValor);
                     r2 = strcmp(valorB[ipropB] ,equivaleValor) == 0 ? SI : NO;
                     if( r1 ==  SI && r2 == SI )
                         cuantos++;
                }
            if( cuantos > maximo )
            {
                maximo = cuantos;
                strcpy(elconcepto ,concepto);
            }


            hijo = Fprimero->Tree0->Selected->GetNextChild(hijo);
        }
        if( strlen(elconcepto) > 0 )
        {
            strcpy(conceptoB ,"probably ");
            strcat(conceptoB ,elconcepto);
            return SI;
        }
        return NO_HAY;
        /*      SINO ESTA ENTONCES BUSCA ENTRE LOS HERMANOS DE padreB
                SE BUSCA ENTRE LOS NIETOS DEL padreB
                SINO ESTA ENTONCES DEVUELVE "SON_OF " + conceptoB
        */
    }
    // NO MAPEO SU PADRE, NI EL CONCEPTO
    if( conceptosB.ultimo == 0 && conceptosPadreB.ultimo == 0 )
    {
        return NO_HAY;
    }
    return NO_HAY;
}
//---------------------------------------------------------------------------
int com(char *entrada ,char *salida, TipoAgente *ag1 ,TipoAgente *ag2)
{
char concepto[50] ,ontologiaA[50] ,ontologiaB[50] ,conceptoB[50] ;
char nombre1[200] ,*ap ,nomarch[200] ;
int esta ,i_interna ;
FILE *arch ;
int u_entrada ,i_entrada ,i_concepto ;

    // BUSCA EL NOMBRE DE LA ONTOLOGIA DEL PRIMER AGENTE
    ontologiaA[0] = '\0';
    if( ag1->u_interna > 0 )
    {
        for(esta = NO ,i_interna = 0; (esta == NO) && (i_interna < ag1->u_interna); i_interna++ )
            if( strcmp(ag1->interna[i_interna].nombre ,"ontology") == 0 )
            {
                 esta = SI;
                 sprintf(Buffer ,"%s" ,ag1->interna[i_interna].valor);
            }
    }
    if( esta == SI )
        strcpy(ontologiaA ,Buffer);
    else
        strcpy(ontologiaA ,"comun");

    strcpy(nomarch ,ontologiaA);
    strcat(nomarch ,".tree");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
        return NO_HAY;
    fclose(arch);

    strcpy(nomarch ,ontologiaA);
    strcat(nomarch ,".dic");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
        return NO_HAY;
    fclose(arch);


    // BUSCA EL NOMBRE DE LA ONTOLOGIA DEL SEGUNDO AGENTE
    ontologiaB[0] = '\0';
    if( ag2->u_interna > 0 )
    {
        for(esta = NO ,i_interna = 0; (esta == NO) && (i_interna < ag2->u_interna); i_interna++ )
            if( strcmp(ag2->interna[i_interna].nombre ,"ontology") == 0 )
            {
                 esta = SI;
                 sprintf(Buffer ,"%s" ,ag2->interna[i_interna].valor);
            }
    }
    if( esta == SI )
        strcpy(ontologiaB ,Buffer);
    else
        strcpy(ontologiaB ,"comun");

    strcpy(nomarch ,ontologiaB);
    strcat(nomarch ,".tree");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
        return NO_HAY;
    fclose(arch);

    strcpy(nomarch ,ontologiaB);
    strcat(nomarch ,".dic");
    arch = fopen(nomarch ,"rt");
    if( arch == NULL )
        return NO_HAY;
    fclose(arch);


    // DIVIDE LA ENTRADA EN UNIDADES LEXICAS Y CADA UNA PASA POR COM
    salida[0] = '\0';
    u_entrada = strlen(entrada);
    for( i_entrada = 0; i_entrada < u_entrada; )
    {
        // SALTA ESPACIOS
        if( entrada[i_entrada] == ' ')
        {
            i_entrada++;
            continue;
        }
        i_concepto = 0;
        while( (entrada[i_entrada] != ' ') && (entrada[i_entrada] != '\0') )
        {
            concepto[i_concepto] = entrada[i_entrada];
            i_entrada++;
            i_concepto++;
        }
        concepto[i_concepto] = '\0';
        if( (concepto[0] >= 'A') && (concepto[0] <= 'Z') )
        {
            if( hallar(concepto ,ontologiaA ,ontologiaB ,conceptoB) == NO_HAY )
                strcat(salida ,"not_found");
            else
                strcat(salida ,conceptoB);
        }
        else
            strcat(salida ,concepto);
        strcat(salida ," ");
    }
}
//---------------------------------------------------------------------------
int buscaIncompatibles(TipoAgente *agte ,char *papel)
{
TipoIdHebra *hebras ;

    if( agte == NULL )
        return SI;
    hebras = agte->hebra;
    while( hebras != NULL )
    {
       if( strcmp( hebras->hebra->papel->nombre ,"Hola") == 0 )
       // SI LA HEBRA DE AGENTE Y EL papel ESTAN EN EL ARCHIVO DE
       // INCOMPATIBILIDAD REGRESAR NO DE OTRA FORMA REGRESAR SI
       
            return NO;
       hebras = hebras->sig;
    }
    return SI;
}
//---------------------------------------------------------------------------
void haz_Instruccion(char *op ,char *op1 ,char *op2 ,char *op3 ,char *op4 ,char *op5)
{
int cual ,esta ,i_puerto ,hay_esperando ;
TipoMensaje *mensaje_nuevo ,*mensaje_ap ,*esperando ,*atras ;
char _mensaje[300] ,_identificador[50] ,_salida[300] ;
int cardinalidad ,duracion ,_leidos ;

    if( strcmp(op ,"Pr") == 0 )
    {
        cual = atoi(op1 + 1);
        if( ColaAp->agente == NULL )
        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + AnsiString(" ") + AnsiString(Cadena[cual].cadena));
            fprintf(Resultados ,"%s %s\n", ElTiempo ,Cadena[cual].cadena);
            Fprimero->Label4->Caption = AnsiString(ElTiempo) + AnsiString(" ") + AnsiString(Cadena[cual].cadena);
        }
        else
        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + AnsiString(" ") +
                AnsiString(ColaAp->agente->nombre) + ": "
                + AnsiString(Cadena[cual].cadena));

            fprintf(Resultados ,"%s %s: %s\n", ElTiempo ,ColaAp->agente->nombre ,Cadena[cual].cadena);
            Fprimero->Label4->Caption = AnsiString(ElTiempo) + AnsiString(" ") + AnsiString(ColaAp->agente->nombre) + ": "
                + AnsiString(Cadena[cual].cadena);
        }
        return;
    }
    if( strcmp(op ,"PrId") == 0 )
    {
        LeeVar(ColaAp ,op1 ,'*');
        if( ColaAp->agente == NULL )
        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + AnsiString(Buffer));
            fprintf(Resultados ,"%s %s\n", ElTiempo ,Buffer);
        }
        else
        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo)
              + AnsiString(" ")
              + AnsiString(ColaAp->agente->nombre)
              + AnsiString(": ") + AnsiString(Buffer));
            Fprimero->Label4->Caption  = AnsiString(ElTiempo)
              + AnsiString(" ")
              + AnsiString(ColaAp->agente->nombre)
              + AnsiString(": ") + AnsiString(Buffer);
            fprintf(Resultados ,"%s %s: %s\n", ElTiempo ,ColaAp->agente->nombre ,Buffer);
        }
        return;
     }
    if( strcmp(op ,"REMMSG") == 0 )
    {
    int i_puerto ,esta ;

        // BUSCA EL PUERTO EN LAS VARIABLES GLOBALES
        i_puerto = NO_HAY;
        for(esta = NO ,IGlobal = 0; (esta == NO) && (IGlobal < UGlobal); IGlobal++ )
            if( strcmp(Global[IGlobal].nombre ,op2) == 0 )
            {
                 esta = SI;
                 i_puerto = IGlobal;
            }
        // SI NO HAY PUERTO TERMINA
        if( esta == NO )
            return;

        // BUSCA EL MENSAJE A REMOVER
        mensaje_ap = Global[i_puerto].puerto;
        atras = NULL;
        esta = NO;
        while( (mensaje_ap != NULL) && (esta == NO) )
        {
            if( mensaje_ap->marca == atoi(op1) )
            {
                esta = SI;
            }
            else
            {
                atras = mensaje_ap;
                mensaje_ap = mensaje_ap->sig;
            }
        }

        // SI NO HAY MENSAJE A REMOVER CONTINUA
        if( esta == NO )
            return;

        Fprimero->Box1->Items->Add(AnsiString(ElTiempo) +
        "    " + AnsiString(mensaje_ap->emisor->nombre) +
        " Removing message " + AnsiString(mensaje_ap->identificador) + " from "
        + AnsiString(op2));
        if( atras == NULL )
        {
            Global[i_puerto].puerto = mensaje_ap->sig;
            free(mensaje_ap);
        }
        else
        {
            atras->sig = mensaje_ap->sig;
            free(mensaje_ap);
        }
        return;
    }
    if( strcmp(op ,"COMPARE") == 0 )
    {
    char cadena1[200] ,cadena2[200] ;

        LeeVar(ColaAp ,op1 ,'*');
        strcpy(cadena1 ,Buffer);

        LeeVar(ColaAp ,op2 ,'*');
        strcpy(cadena2 ,Buffer);

        if( strcmp(cadena1 ,cadena2) == 0 )
            strcpy(Buffer ,"1");
        else
            strcpy(Buffer ,"0");
        EscribeVar(ColaAp ,op3 ,'*');

        return;
    }
    if( strcmp(op ,"EXTRACT") == 0 )
    {
    char tempor[100] ;
    int ut ,im ,um ,hallado ;

        LeeVar(ColaAp ,op1 ,'*');
        strcpy(_mensaje ,Buffer);

        LeeVar(ColaAp ,op2 ,'*');
        strcpy(_identificador ,Buffer);

        um = strlen(_mensaje);
        ut = strlen(_identificador);
        for( hallado = 0, im = 0; (im < um) && (hallado == 0); im++ )
        {
            if( strncmp(_mensaje + im ,_identificador ,ut) == 0 )
                hallado = 1;
        }

        im = im - 1 + ut;
        // SALTA ESPACIOS
        for( ; (im < um) && (_mensaje[im] == ' '); im++ )
          ;
        // TOMA EL SIMBOLO QUE VIENE A CONTINUACION
        for( ut = 0; (im < um) && (_mensaje[im] != ' '); im++, ut++ )
          tempor[ut] = _mensaje[im];
        tempor[ut] = '\0';

        strcpy(Buffer ,tempor);
        EscribeVar(ColaAp ,op3 ,'*');
        return;
    }

    if( strcmp(op ,"STRCAT") == 0 )
    {
        LeeVar(ColaAp ,op1 ,'*');
        strcpy(_mensaje ,Buffer);

        LeeVar(ColaAp ,op2 ,'*');
        strcat(_mensaje ,Buffer);

        strcpy(Buffer ,_mensaje);
        EscribeVar(ColaAp ,op1 ,'*');

        return;
    }
    if( strcmp(op ,"OUT") == 0 )
    {
        // SOLAMENTE UNA THREAD DE UN AGENTE PUEDE HACER OUT
        if( ColaAp->agente == NULL )
            return;

        // BUSCA EL PUERTO EN LAS VARIABLES GLOBALES
        i_puerto = NO_HAY;
        for(esta = NO ,IGlobal = 0; (esta == NO) && (IGlobal < UGlobal); IGlobal++ )
            if( strcmp(Global[IGlobal].nombre ,op1) == 0 )
            {
                 esta = SI;
                 i_puerto = IGlobal;
            }
        // SI NO HAY PUERTO TERMINA
        if( esta == NO )
            return;

        // IDENTIFICADOR DEL MENSAJE
        LeeVar(ColaAp ,op2 ,'*');
        strcpy(_identificador ,Buffer);

        // SI NO HAY IDENTIFICADOR TERMINA
        if( strlen(Buffer) < 1 )
            return;

        // RESUELVE EL MENSAJE QUE SE VA A ENVIAR EN BUFFER
        Buffer[0] = '\0';
        LeeVar(ColaAp ,op3 ,'*');

        // SI NO HAY MENSAJE TERMINA
        if( strlen(Buffer) < 1 )
            return;

        strcpy(_mensaje ,Buffer);

        Fprimero->Box1->Items->Add(AnsiString(ElTiempo)
          + " " + AnsiString(ColaAp->agente->nombre)
          + " out "
          + AnsiString(" ")
          + AnsiString(_identificador)
          + " "
          + AnsiString(_mensaje));

        fprintf(Resultados ,"%s %s out %s %s\n",
            ElTiempo, ColaAp->agente->nombre,
            _identificador, _mensaje);

        // TOMA LOS PARAMETROS DE DURACION DEL MENSAJE
        LeeVar(ColaAp ,op4 ,'*');
        cardinalidad = atoi(Buffer);
        LeeVar(ColaAp ,op5 ,'*');
        duracion = atoi(Buffer);

        if( cardinalidad < 1 )
            return;

        // NO SE HA LEIDO NINGUN MENSAJE DEL QUE LLEGO
        _leidos = 0;

        // BUSCA PARA VER SI EXISTE UN ACCEPT PENDIENTE
        hay_esperando = NO;
        mensaje_ap = Global[i_puerto].puerto;
        atras = NULL;
        while( (mensaje_ap != NULL) && (hay_esperando == NO) )
        {
            if( mensaje_ap->tipo == 2 )
            {
                if( strcmp(mensaje_ap->identificador ,_identificador) == 0 )
                {
                    hay_esperando = SI;
                    esperando = mensaje_ap;
                }
            }
            if( hay_esperando == NO )
            {
                atras = mensaje_ap;
                mensaje_ap = mensaje_ap->sig;
            }
        }

        // ENCONTRO UN ACCEPT PENDIENTE
        if( hay_esperando == SI )
        {
            /*
            Fprimero->Box1->Items->Add(
              AnsiString(ElTiempo)
              + " COM from "
              + AnsiString(ColaAp->agente->nombre)
              + " to " + AnsiString(esperando->receptor->nombre)
              + " message " + AnsiString(_mensaje)
              );
            */
            Fprimero->Box1->Items->Add(
              AnsiString(ElTiempo)
              + " COM from "
              + AnsiString(ColaAp->agente->nombre)
              + " to " + AnsiString(esperando->receptor->nombre));

            if( com(_mensaje ,_salida, ColaAp->agente, esperando->receptor) == NO_HAY )
                strcpy(_salida ,"");

            Fprimero->Box1->Items->Add(AnsiString(ElTiempo)
              + " " + AnsiString(esperando->receptor->nombre)
              + " accept " + AnsiString(" ")
              + AnsiString(_identificador)
              + " " + AnsiString(_salida));

            fprintf(Resultados ,"%s COM from %s %s\n", ElTiempo ,ColaAp->agente->nombre,esperando->receptor->nombre);

            fprintf(Resultados ,"%s %s accept %s %s\n", ElTiempo ,esperando->receptor->nombre,_identificador,_salida);

            strcpy(Buffer ,_salida);
            EscribeVar(ColaAp ,op3 ,'*');

            // se le da el mensaje a la hebra del accept se supone que
            // esa hebra est suspendida por lo que debe reactivarse
            // com(ColaAp->agente ,esperando->agente ,_mensaje ,_salida);

            // temporalmente
            strcpy(_salida ,_mensaje);

/*
            Fprimero->Box1->Items->Add(
              AnsiString(ElTiempo)
              + " accept from "
              + AnsiString(ColaAp->agente)
              + " to " + AnsiString(esperando->agente->nombre)
              + " message " + AnsiString(_salida)
              );
*/

            strcpy(Buffer ,_salida);

            // SE ENTREGA EL MENSAJE
            EscribeVar(esperando->hebra_esperando ,esperando->variable ,'*');

            // REACTIVA LA HEBRA SUSPENDIDA
            esperando->hebra_esperando->estado = 0;
            esperando->hebra_esperando->tiempo = Reloj;
            ColaApt = ColaInicio;
            ColaAnte = NULL;
            while( (ColaApt != NULL) && (ColaApt != esperando->hebra_esperando) )
            {
                ColaAnte = ColaApt;
                ColaApt = ColaApt->sig;
            }
            // RETIRA LA HEBRA DE LA COLA PARA VOLVER A INSERTARLA
            if( ColaApt == esperando->hebra_esperando )
            {
                if( ColaAnte == NULL )
                {
                    ColaInicio = ColaApt->sig;
                    sim_InsertaEjecucion(ColaApt);
                }
                else
                {
                    ColaAnte = ColaApt->sig;
                    sim_InsertaEjecucion(ColaApt);
                }
            }

            // SI EL MENSAJE NO PUEDE ESPERAR
            if( atras == NULL )
            {
                Global[i_puerto].puerto = esperando->sig;
                free(esperando);
            }
            else
            {
                atras->sig = esperando->sig;
                free(esperando);
            }

            // SE ENTREGO UN MENSAJE
            _leidos++;
        }

        // SE ENTREGARON TODOS LOS MENSAJES QUE HABIA QUE ENTREGAR
        if( cardinalidad == _leidos )
            return;

        // COLOCAR EL MENSAJE EN LA COLA
        if( duracion == 0 )
            return;

        // AGREGAR EL MENSAJE EN EL PUERTO
        mensaje_nuevo = (TipoMensaje *) malloc(sizeof(TipoMensaje));
        strcpy(mensaje_nuevo->identificador ,_identificador);
        strcpy(mensaje_nuevo->contenido ,_mensaje);
        mensaje_nuevo->llegada = Reloj;
        mensaje_nuevo->duracion = duracion;
        mensaje_nuevo->tipo = 1;
        mensaje_nuevo->cardinalidad = cardinalidad;
        mensaje_nuevo->lecturas = _leidos;
        mensaje_nuevo->emisor = ColaAp->agente;
        mensaje_nuevo->sig = NULL;

        mensaje_nuevo->marca = UltimaMarca;
        UltimaMarca++;

        // INSERTA EL MENSAJE EN EL PUERTO AL FINAL
        mensaje_ap = Global[i_puerto].puerto;
        atras = NULL;
        while( mensaje_ap != NULL )
        {
            atras = mensaje_ap;
            mensaje_ap = mensaje_ap->sig;
        }
        if( atras == NULL )
        {
            // COLOCARLO AL INICIO DE LA COLA
            Global[i_puerto].puerto = mensaje_nuevo;
        }
        else
        {
            atras->sig = mensaje_nuevo;
        }

        // AGREGAR UN ELIMINADOR EN LA COLA DE EJECUCION

        PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel));
        strcpy(PapelNueva->nombre ,"remove message");
        PapelNueva->cupo = 0;
        PapelNueva->usados = 0;
        PapelNueva->requisito = NULL;
        PapelNueva->u_local = 0;
        PapelNueva->u_instruccion = 2;
        PapelNueva->instruccion = NULL;
        PapelNueva->sig = NULL;

        // SE ASIGNA ESPACIO EN MEMORIA PARA QUE EL PAPEL SEA UN ARREGLO
        PapelNueva->instruccion =
          (TipoInstruccion *)malloc( sizeof (TipoInstruccion) * 2);

        strcpy(PapelNueva->instruccion[0].opcode ,"REMMSG");
char tempor[20] ;
        sprintf(tempor ,"%d",UltimaMarca - 1);
        strcpy(PapelNueva->instruccion[0].op1 ,tempor);
        strcpy(PapelNueva->instruccion[0].op2 ,op1);
        strcpy(PapelNueva->instruccion[0].op3 ,"");
        strcpy(PapelNueva->instruccion[0].op4 ,"");
        strcpy(PapelNueva->instruccion[0].op5 ,"");

        strcpy(PapelNueva->instruccion[1].opcode ,"STOP");
        strcpy(PapelNueva->instruccion[1].op1 ,"");
        strcpy(PapelNueva->instruccion[1].op2 ,"");
        strcpy(PapelNueva->instruccion[1].op3 ,"");
        strcpy(PapelNueva->instruccion[1].op4 ,"");
        strcpy(PapelNueva->instruccion[1].op5 ,"");

        // INSERTA EL PAPEL EN MAIN
        PapelNueva->sig = Main.papel;
        Main.papel = PapelNueva;

        HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra));
        HebraNueva->tiempo = mensaje_nuevo->llegada + mensaje_nuevo->duracion;
        HebraNueva->PC = 0;
        HebraNueva->estado = 0;
        HebraNueva->papel = Main.papel;
        HebraNueva->plan = NULL;
        HebraNueva->proposito = NULL;
        HebraNueva->stack = NULL;
        HebraNueva->u_local = 0;
        HebraNueva->sig = NULL;
        HebraNueva->agente = NULL;
        HebraNueva->agente_nuevo = NO;

        // ANEXA LA HEBRA A MAIN
        HebraNueva->sig = Main.hebra;
        Main.hebra = HebraNueva;

        sim_InsertaEjecucion(HebraNueva);
        return;
    }
    if( strcmp(op ,"ACCEPT") == 0 )
    {
        // SOLAMENTE UNA THREAD DE UN AGENTE PUEDE HACER ACCEPT
        if( ColaAp->agente == NULL )
            return;

        // BUSCA EL PUERTO EN LAS VARIABLES GLOBALES
        i_puerto = NO_HAY;
        for(esta = NO ,IGlobal = 0; (esta == NO) && (IGlobal < UGlobal); IGlobal++ )
            if( strcmp(Global[IGlobal].nombre ,op1) == 0 )
            {
                 esta = SI;
                 i_puerto = IGlobal;
            }

        // SE ENCUENTRA EL PUERTO ?
        if( esta == NO )
            return;

        // IDENTIFICADOR DEL MENSAJE
        LeeVar(ColaAp ,op2 ,'*');
        strcpy(_identificador ,Buffer);

        // SI NO HAY IDENTIFICADOR TERMINA
        if( strlen(Buffer) < 1 )
            return;

        // BUSCA SI HAY ESPERANDO
        hay_esperando = NO;
        mensaje_ap = Global[i_puerto].puerto;
        atras = NULL;
        while( (mensaje_ap != NULL) && (hay_esperando == NO) )
        {
            // MENSAJE DE ESPERA ?
            if( mensaje_ap->tipo == 1 )
            {
                // COINCIDEN LAS VARIABLES ?
                if( strcmp(mensaje_ap->identificador ,_identificador) == 0 )
                {
                    hay_esperando = SI;
                    esperando = mensaje_ap;
                }
            }
            if( hay_esperando == NO )
            {
                atras = mensaje_ap;
                mensaje_ap = mensaje_ap->sig;
            }
        }
        if( hay_esperando == SI)
        {
            // DAR EL MENSAJE A QUIEN LO PIDE

            strcpy(_mensaje ,mensaje_ap->contenido);
            // se le da el mensaje a la hebra del accept se supone que
            // esa hebra est suspendida por lo que debe reactivarse
            // com(esperando->agente ,ColaAp->agente ,_mensaje ,_salida);

            Fprimero->Box1->Items->Add(
              AnsiString(ElTiempo)
              + " COM from "
              + AnsiString(esperando->emisor->nombre)
              + " to "
              + AnsiString(ColaAp->agente->nombre)
              );

            if( com(_mensaje ,_salida, ColaAp->agente, esperando->emisor) == NO_HAY )
                strcpy(_salida ,"");

            Fprimero->Box1->Items->Add(AnsiString(ElTiempo)
              + " " + AnsiString(ColaAp->agente->nombre)
              + " accept " + AnsiString(" ")
              + AnsiString(_identificador)
              + " " + AnsiString(_salida));

            fprintf(Resultados ,"%s COM from %s %s\n", ElTiempo, esperando->emisor->nombre ,ColaAp->agente->nombre);

            fprintf(Resultados ,"%s %s accept %s %s\n", ElTiempo,ColaAp->agente->nombre ,_identificador,_salida);

            strcpy(Buffer ,_salida);
            EscribeVar(ColaAp ,op3 ,'*');

            esperando->lecturas++;
            if( esperando->lecturas == esperando->cardinalidad )
            {
                // BORRAR EL MENSAJE ENTREGADO
                if( atras == NULL )
                {
                    Global[IGlobal].puerto = esperando->sig;
                    free(esperando);
                }
                else
                {
                    atras->sig = esperando->sig;
                    free(esperando);
                }
            }
            return;
        }

        // COLOCAR UN AVISO DE SOLICITUD EN LA COLA DE ESPERA
        mensaje_nuevo = (TipoMensaje *) malloc(sizeof(TipoMensaje));
        mensaje_nuevo->tipo = 2;
        strcpy(mensaje_nuevo->identificador ,_identificador);
        strcpy(mensaje_nuevo->variable ,op3);
        mensaje_nuevo->receptor = ColaAp->agente;
        mensaje_nuevo->hebra_esperando = ColaAp;
        mensaje_nuevo->sig = NULL;

        // INSERTA AL FINAL DE LA COLA DE MENSAJES EL NUEVO
        mensaje_ap = Global[i_puerto].puerto;
        atras = NULL;
        while( mensaje_ap != NULL )
        {
            atras = mensaje_ap;
            mensaje_ap = mensaje_ap->sig;
        }
        if( atras == NULL )
        {
            // COLOCARLO AL INICIO DE LA COLA
            Global[i_puerto].puerto = mensaje_nuevo;
        }
        else
        {
            atras->sig = mensaje_nuevo;
        }

        // SUSPENDE LA HEBRA ACTUAL
        ColaAp->estado = 2;
        return;
    }
    if( strcmp(op ,"MOVSTR") == 0 )
    {
        if( ColaAp->agente_nuevo == SI )
        {
            sprintf(Buffer ,"%s" ,Cadena[atoi(op2 + 1)].cadena);
            GuardaInterna(ColaAp->creandose ,op1);
        }
        else
        {
            sprintf(Buffer ,"%s" ,Cadena[atoi(op2 + 1)].cadena);
            EscribeVar(ColaAp ,op1 ,'*');
        }
        return;
    }
    if( strcmp(op ,"WAIT") == 0 )
    {
        ColaAp->tiempo += atoi(op1);
        return;
    }
    if( strcmp(op ,"JEQ") == 0 )
    {
        if( ColaAp->condicion == 1 )
        {
            ColaAp->PC = atoi(op1);
            ColaAp->PC--;
        }
        return;
    }
    if( strcmp(op ,"JMP") == 0 )
    {
        ColaAp->PC = atoi(op1);
        ColaAp->PC--;
        return;
    }
    if( strcmp(op ,"SUMA") == 0 )
    {
        ColaAp->R = ColaAp->tA + ColaAp->tB;
        return;
    }
    if( strcmp(op ,"RESTA") == 0 )
    {
        ColaAp->R = ColaAp->tB - ColaAp->tA;
        return;
    }
    if( strcmp(op ,"AND") == 0 )
    {
        if( (ColaAp->tA > 0) && (ColaAp->tB > 0) )
            ColaAp->R = 1;
        else
            ColaAp->R = 0;
        return;
    }
    if( strcmp(op ,"CMP") == 0 )
    {
        if( strcmp(op1 ,"R") == 0 )
        {
            if( ColaAp->R == atof(op2) )
                ColaAp->condicion = 1;
            else
                ColaAp->condicion = 0;
        }
        return;
    }
    if( strncmp(op ,"CMP" ,3) == 0 )
    {
        if( op[3] == '<')
        {
            if( ColaAp->tA < ColaAp->tB )
                ColaAp->R = 1;
            else
                ColaAp->R = 0;
        }
        if( op[3] == '=')
        {
            if( ColaAp->tA == ColaAp->tB )
                ColaAp->R = 1;
            else
                ColaAp->R = 0;
        }
        if( op[3] == '>')
        {
            if( ColaAp->tA > ColaAp->tB )
                ColaAp->R = 1;
            else
                ColaAp->R = 0;
        }
        return;
    }
    if( strcmp(op ,"CLRSTK") == 0 )
    {
        StackLimpia = ColaAp->stack;
        while( StackLimpia != NULL )
        {
           StackActual = StackLimpia;
           StackLimpia = StackActual->sig;
           free(StackActual);
        }
        ColaAp->stack = NULL;
        return;
    }
    if( strncmp(op ,"PUSH" ,4) == 0 )
    {
        if( op[4] == 'n')
        {
            StackActual = (TipoStack *) malloc(sizeof(TipoStack) + 1);
            StackActual->valor = atof(op1);

            StackActual->sig = ColaAp->stack;
            ColaAp->stack = StackActual;
        }
        if( op[4] == 'v')
        {
            StackActual = (TipoStack *) malloc(sizeof(TipoStack));
            LeeVar(ColaAp ,op1,'*');
            StackActual->valor = atof(Buffer);
            StackActual->sig = ColaAp->stack;
            ColaAp->stack = StackActual;
        }
        if( op[4] == 's')
        {
            StackActual = (TipoStack *) malloc(sizeof(TipoStack));
            if( strcmp(op1 ,"tA") == 0 )
            {
                StackActual->valor = ColaAp->tA;
            }
            if( strcmp(op1 ,"tB") == 0 )
            {
                StackActual->valor = ColaAp->tB;
            }
            if( strcmp(op1 ,"R") == 0 )
            {
                StackActual->valor = ColaAp->R;
            }
            StackActual->sig = ColaAp->stack;
            ColaAp->stack = StackActual;
        }
        return;
    }
    if( strncmp(op ,"POP" ,3) == 0 )
    {
        if( op[3] == 'v')
        {
            if( ColaAp->stack != NULL )
            {
                if( ColaAp->agente_nuevo == SI )
                {
                    sprintf(Buffer ,"%f" ,ColaAp->stack->valor);
                    GuardaInterna(ColaAp->creandose ,op1);
                }
                else
                {
                    sprintf(Buffer ,"%f" ,ColaAp->stack->valor);
                    EscribeVar(ColaAp ,op1,'*');
                }

                // QUITA EL OPERADOR DEL STACK
                StackActual = ColaAp->stack;
                ColaAp->stack = ColaAp->stack->sig;
                free(StackActual);
            }
        }
        if( op[3] == 's')
        {
            if( ColaAp->stack != NULL )
            {
                sprintf(Buffer ,"%f " ,ColaAp->stack->valor);
                if( strcmp(op1 ,"tA") == 0 )
                {
                    ColaAp->tA = atof(Buffer);
                }
                if( strcmp(op1 ,"tB") == 0 )
                {
                    ColaAp->tB = atof(Buffer);
                }
                if( strcmp(op1 ,"R") == 0 )
                {
                    ColaAp->R = atof(Buffer);
                }

                // QUITA EL OPERADOR DEL STACK
                StackActual = ColaAp->stack;
                ColaAp->stack = ColaAp->stack->sig;
                free(StackActual);
            }
        }
        return;
    }
    if( strcmp(op ,"O") == 0 )
    {
       Fprimero->Box1->Items->Add(AnsiString(ElTiempo) +
         AnsiString(" Purpose ") +
         AnsiString(op1) + " added to " + ColaAp->creandose->nombre);
       sim_InsertaAgenteProposito(ColaAp->creandose ,op1);
    }
    if( strcmp(op ,"CREAA") == 0 )
    {
        // CREA EL AGENTE
        if( sim_InstanciaAgente(op1 ,op2) == SI )
        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo) +
                  AnsiString(" Agent ")
                + AnsiString(op2) + AnsiString(" from ") + AnsiString(op1)
                + " created");
            ColaAp->agente_nuevo = SI;
            fprintf(Resultados ,"%s Agent %s from %s created\n", ElTiempo ,op2 ,op1);
        }
        else
        {
            Fprimero->Box1->Items->Add(AnsiString("Agent creation FAIL: ")
               + AnsiString(op2));
            fprintf(Resultados ,"%s Agent creation %s fail\n", ElTiempo ,op2);
        }
        return;
    }
    if( strcmp(op ,"PLAN") == 0 )
    {
    TipoInicial *inicial_ap ;
    TipoPapel *papel ;
    int i_local ;

        ColaAp->agente_nuevo = NO;
        // AGREGAR LOS PAPELES INICIALES DEL AGENTE A LA COLA DE EJECUCION
        // Fprimero->Box1->Items->Add(AnsiString("PAPELES CON QUE NACE"));
        inicial_ap = ColaAp->creandose->inicial;
        while( inicial_ap != NULL )        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + " * "
              + AnsiString(ColaAp->creandose->nombre)
              + " starts " + AnsiString(inicial_ap->inicial));

            fprintf(Resultados ,"%s %s starts %s\n", ElTiempo ,ColaAp->creandose->nombre ,inicial_ap->inicial);
            // CARGA EL PAPEL EN main
            papel = cargaEnMain(inicial_ap->inicial);

            // ADICIONA LA HEBRA DEL PAPEL INICIAL
            if( papel != NULL )
            {
                //SE AGREGAN LOS PAPELES INICIALES EN LA COLA DE EJECUCION
                HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
                HebraNueva->tiempo = Reloj + 5;
                HebraNueva->PC = 0;
                HebraNueva->estado = 0;
                HebraNueva->papel = papel;
                HebraNueva->plan = NULL;
                HebraNueva->proposito = NULL;
                HebraNueva->stack = NULL;
                HebraNueva->u_local = papel->u_local;
                HebraNueva->agente_nuevo = NO;
                HebraNueva->agente = ColaAp->creandose;
                HebraNueva->sig = NULL;
                // SE LE CARGAN SUS VARIABLES LOCALES A LA HEBRA
                for( i_local = 0; i_local < papel->u_local; i_local++ )
                {
                    strcpy(HebraNueva->local[i_local].nombre ,papel->local[i_local].nombre);
                    HebraNueva->local[i_local].tipo = papel->local[i_local].tipo;
                    HebraNueva->local[i_local].dim1 = papel->local[i_local].dim1;
                    HebraNueva->local[i_local].dim2 = papel->local[i_local].dim2;
                }

                 // SE LE AGREGA UN REFERENCIA A LA HEBRA
                IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
                IdHebraNueva->hebra = HebraNueva;
                IdHebraNueva->sig = ColaAp->creandose->hebra;
                ColaAp->creandose->hebra = IdHebraNueva;

                // INSERTA LA HEBRA EN LA COLA DE EJECUCION
                sim_InsertaEjecucion(HebraNueva);
            }

            // TOMA EL SIGUIENTE PAPEL INICIAL
            inicial_ap = inicial_ap->sig;
        }

        // REALIZA LA PLANEACIN Y ADICIONA LOS PAPELES DEL PLAN DEL AGENTE
        Fprimero->Box1->Items->Add(AnsiString(ElTiempo) +
          AnsiString(" Plan for ") + AnsiString(ColaAp->creandose->nombre ));

        fprintf(Resultados ,"%s Plan for %s\n", ElTiempo ,ColaAp->creandose->nombre);

        sim_Planifica(ColaAp->creandose);
        return;
    }
    if( strcmp(op ,"CREAI") == 0 )
    {
        // CREA UNA INTERACCION
        if( sim_InstanciaInteraccion(op1 ,op2) == SI )
        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo)
                + AnsiString(" Interaction ")
                + AnsiString(op2) + AnsiString(" from ") + AnsiString(op1)
                + " created");
            fprintf(Resultados ,"%s Interaction %s from %s created\n", ElTiempo ,op2 ,op1);
        }
        else
        {
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo)
                + AnsiString("FAIL trying to create an Interaction ")
                + AnsiString(op2) + AnsiString(" from ") + AnsiString(op1));
            fprintf(Resultados ,"%s FAIL trying to create an Interaction %s from %s\n", ElTiempo ,op2 ,op1);
        }
        return;
    }
    if( strcmp(op ,"IMEI") == 0 )
    {
        Fprimero->Box1->Items->Add(AnsiString(ElTiempo) +
        " ***** " + AnsiString(ColaAp->papel->nombre));

        fprintf(Resultados ,"%s ***** %s\n", ElTiempo ,ColaAp->papel->nombre);
        // INVOCA AL MICROPLANIFICADOR
        MicroPlanificador(ColaAp->papel->nombre ,Reloj); // MEI:
        return;
    }
    if( strcmp(op ,"FMEI") == 0 )
    {
        // rutina en C que termina el evento inesperado
        Fprimero->Box1->Items->Add(AnsiString(ElTiempo) +
          " *end* " + AnsiString(ColaAp->papel->nombre));
        fprintf(Resultados ,"%s *end* %s\n", ElTiempo ,ColaAp->papel->nombre);
        // Fprimero->Box1->Items->Add("END OF EMERGENCY");
        FinEvento(ColaAp->papel->nombre ,Reloj); // MEI:
        return;
    }
    if( strcmp(op ,"GOAL") == 0 )
    {
    char alcanzo[50] ;
    TipoProposito *prop ;

        LeeVar(ColaAp ,op1 ,'*');
        strcpy(alcanzo ,Buffer);
        Fprimero->Box1->Items->Add(AnsiString(ElTiempo) +
          " " + AnsiString(ColaAp->agente->nombre)
          + " reached " + alcanzo );

        fprintf(Resultados ,"%s %s reached %s\n", ElTiempo ,ColaAp->agente->nombre,alcanzo);

        // UBICAR LOS PROPOSITOS DEL AGENTE
        prop = ColaAp->agente->proposito;
        while( prop != NULL )
        {
            if( strcmp(alcanzo, prop->proposito) == 0 )
                prop->estado = 1; // alcanzado
            prop = prop->sig;
        }

        // BUSCA EN LOS PROPOSITOS DEL AGENTE ACTUAL EL PROPOSITO alcanzo Y MARCALO
        // COMO ALCANZADO
        return;
    }
    if( strcmp(op ,"STOP") == 0 )
    {
        if( ColaAp->plan == NULL )
            return;
//        Fprimero->Box1->Items->Add("REVISO EL PLAN PARA ASIGNAR OTRO PAPEL");

TipoPlan *applan ;
int nivelminimo ;

        ColaAp->plan->estado = 2;
        applan = ColaAp->plan;
        nivelminimo = NO_HAY;
        while( applan != NULL )
        {
            if( applan->estado == 0 )
            {
                if( nivelminimo == NO_HAY )
                    nivelminimo = applan->nivel;
                else
                    if( nivelminimo > applan->nivel )
                        nivelminimo = applan->nivel;
            }
            applan = applan->sig;
        }
        if( nivelminimo == NO_HAY )
        {
            return;
        }
        applan = ColaAp->plan;
        while( applan != NULL ) // PARA CADA PROPOSITO
        {
            if( applan->nivel != nivelminimo )
            {
                applan = applan->sig;
                continue;
            }

            if( buscaIncompatibles(ColaAp->agente ,applan->papel->nombre) == NO )
            {
                applan = applan->sig;
                continue;
            }
            if( applan->papel->usados >= applan->papel->cupo )
            {
                Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + " ## "
                  + AnsiString(ColaAp->agente->nombre)
                  + " not available space " + AnsiString(applan->papel->nombre));
                applan = applan->sig;
                continue;
            }

            applan->papel->usados++;

            // REVISAR LOS REQUISITOS DEL PAPEL A INICIAR long > 0


            // buscar la compatibilidad
            // sino es compatible entonces brincar este papel
            Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + " * "
              + AnsiString(ColaAp->agente->nombre)
              + " starts " + AnsiString(applan->papel->nombre)
              + " from " + AnsiString(Interaccion[applan->interaccion].nombre) );
            fprintf(Resultados ,"%s starts %s from %s\n", ElTiempo ,applan->papel->nombre ,Interaccion[applan->interaccion].nombre);

            // ADICIONA EL PAPEL EN LA LISTA DE EJECUCION
            HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
            HebraNueva->tiempo = Reloj + 1;
            HebraNueva->PC = 0;
            HebraNueva->estado = 0;
            HebraNueva->papel = applan->papel;
            HebraNueva->plan = applan;
            HebraNueva->proposito = NULL;
            HebraNueva->stack = NULL;
            HebraNueva->u_local = applan->papel->u_local;
            HebraNueva->agente_nuevo = NO;
            HebraNueva->agente = ColaAp->agente;
            HebraNueva->sig = NULL;

            // SE LE CARGAN SUS VARIABLES LOCALES A LA HEBRA
            for( int i_local = 0; i_local < applan->papel->u_local; i_local++ )
            {
                strcpy(HebraNueva->local[i_local].nombre ,applan->papel->local[i_local].nombre);
                HebraNueva->local[i_local].tipo = applan->papel->local[i_local].tipo;
                HebraNueva->local[i_local].dim1 = applan->papel->local[i_local].dim1;
                HebraNueva->local[i_local].dim2 = applan->papel->local[i_local].dim2;
            }

             // SE LE AGREGA UN REFERENCIA A LA HEBRA
            IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
            IdHebraNueva->hebra = HebraNueva;
            IdHebraNueva->sig = ColaAp->agente->hebra;
            ColaAp->agente->hebra = IdHebraNueva;

            // INSERTA LA HEBRA EN LA COLA DE EJECUCION
            sim_InsertaEjecucion(HebraNueva);

            applan = applan->sig;
        }

    }
}
//---------------------------------------------------------------------------
int sim_InstanciaAgente(char *agente ,char *instancia)
{
int buscado ;
TipoProposito *prop_ap ;
TipoEvento *evento_ap ;
TipoAccion *accion_ap ;
TipoInicial *inicial_ap ;
TipoInterna *interna_ap ;
TipoVRegion *regional_ap ;
TipoVRegion *regional_nueva ;
TipoPapel *solicitado ,*papel ;
int esta ,hay ;
int i_interna ,i_local ,n;
char unnodo[100] ;


    for( esta = NO ,IAgente = 0; (IAgente < UAgente) && (esta == NO); IAgente++ )
    {
        if( strcmp(agente ,Agente[IAgente].nombre) == 0 )
        {
            buscado = IAgente;
            esta = SI;
        }
    }
    if( esta == NO )
    {
        return NO;
    }

    // CREA LA INSTANCIA DEL AGENTE BUSCADO
    AgenteNueva = (TipoAgente *) malloc(sizeof(TipoAgente));
    strcpy(AgenteNueva->nombre ,instancia);
    AgenteNueva->hebra = NULL;
    AgenteNueva->id = 0;
    ColaAp->creandose = AgenteNueva;

    // NumeroAgente;   NumeroAgente++;

//Fprimero->Box1->Items->Add(AnsiString("PROPOSITOS"));
    // SE COPIAN LOS PROPOSITOS DEL AGENTE BASE
    AgenteNueva->proposito = NULL;
    prop_ap = Agente[buscado].proposito;
    while( prop_ap != NULL )
    {
//Fprimero->Box1->Items->Add(AnsiString(prop_ap->proposito));
        sim_InsertaAgenteProposito(AgenteNueva ,prop_ap->proposito);
        prop_ap = prop_ap->sig;
    }

//Fprimero->Box1->Items->Add(AnsiString("EVENTOS QUE PERCIBE"));
    // SE COPIAN LOS EVENTOS INESPERADOS QUE PERCIBE
    AgenteNueva->evento = NULL;
    evento_ap = Agente[buscado].evento;
    while( evento_ap != NULL )
    {
//Fprimero->Box1->Items->Add(AnsiString(evento_ap->evento));
        sim_InsertaAgenteEvento(AgenteNueva ,evento_ap->evento);
        evento_ap = evento_ap->sig;
    }

//Fprimero->Box1->Items->Add(AnsiString("RESPUESTAS A EVENTOS"));
    // SE COPIAN LAS ACCIONES PARA LOS EVENTOS INESPERADOS
    AgenteNueva->accion = NULL;
    accion_ap = Agente[buscado].accion;
    while( accion_ap != NULL )
    {
//Fprimero->Box1->Items->Add(AnsiString(accion_ap->accion));
        sim_InsertaAgenteAccion(AgenteNueva ,accion_ap->accion);
        accion_ap = accion_ap->sig;
    }


    // SE COPIAN LOS PAPELES INICIALES
    AgenteNueva->inicial = NULL;
    inicial_ap = Agente[buscado].inicial;
    while( inicial_ap != NULL )
    {
//Fprimero->Box1->Items->Add(AnsiString(inicial_ap->inicial));
        sim_InsertaAgenteInicial(AgenteNueva ,inicial_ap->inicial);

        /*
        // CARGA EL PAPEL EN main
        papel = cargaEnMain(inicial_ap->inicial);

        // ADICIONA LA HEBRA DEL PAPEL INICIAL
        if( papel != NULL )
        {
            //SE AGREGAN LOS PAPELES INICIALES EN LA COLA DE EJECUCION
            HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
            HebraNueva->tiempo = Reloj + 5;
            HebraNueva->PC = 0;
            HebraNueva->estado = 0;
            HebraNueva->papel = papel;
            HebraNueva->proposito = NULL;
            HebraNueva->stack = NULL;
            HebraNueva->u_local = papel->u_local;
            HebraNueva->agente_nuevo = NO;
            HebraNueva->agente = AgenteNueva;
            HebraNueva->sig = NULL;
            // SE LE CARGAN SUS VARIABLES LOCALES A LA HEBRA
            for( i_local = 0; i_local < papel->u_local; i_local++ )
            {
                strcpy(HebraNueva->local[i_local].nombre ,papel->local[i_local].nombre);
                HebraNueva->local[i_local].tipo = papel->local[i_local].tipo;
                HebraNueva->local[i_local].dim1 = papel->local[i_local].dim1;
                HebraNueva->local[i_local].dim2 = papel->local[i_local].dim2;
            }

             // SE LE AGREGA UN REFERENCIA A LA HEBRA
            IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
            IdHebraNueva->hebra = HebraNueva;
            IdHebraNueva->sig = AgenteNueva->hebra;
            AgenteNueva->hebra = IdHebraNueva;

            // INSERTA LA HEBRA EN LA COLA DE EJECUCION
            sim_InsertaEjecucion(HebraNueva);

        }
        */

        // TOMA EL SIGUIENTE PAPEL INICIAL
        inicial_ap = inicial_ap->sig;
    }

//Fprimero->Box1->Items->Add(AnsiString("VARIABLES INTERNAS"));
        for( i_interna = 0; i_interna < Agente[buscado].u_interna; i_interna++ )
        {
//Fprimero->Box1->Items->Add(AnsiString(Agente[buscado].interna[i_interna].nombre));
            strcpy(AgenteNueva->interna[i_interna].nombre ,Agente[buscado].interna[i_interna].nombre);
            AgenteNueva->interna[i_interna].tipo = Agente[buscado].interna[i_interna].tipo;
            AgenteNueva->interna[i_interna].dim1 = Agente[buscado].interna[i_interna].dim1;
            AgenteNueva->interna[i_interna].dim2 = Agente[buscado].interna[i_interna].dim2;
            AgenteNueva->interna[i_interna].valor[0] = '\0';
        }
        AgenteNueva->u_interna = Agente[buscado].u_interna;

//Fprimero->Box1->Items->Add(AnsiString("VARIABLES REGIONALES QUE PERCIBE"));
    // COPIA LAS VARIABLES REGIONALES AL AGENTE NUEVO
    AgenteNueva->regional = NULL;
    regional_ap = Agente[buscado].regional;
    while( regional_ap != NULL )
    {
       regional_nueva = (TipoVRegion *)malloc(sizeof(TipoVRegion));
//Fprimero->Box1->Items->Add(AnsiString(regional_ap->nombre));
       strcpy(regional_nueva->nombre ,regional_ap->nombre);
       regional_nueva->sig = AgenteNueva->regional;
       AgenteNueva->regional = regional_nueva;
       regional_ap = regional_ap->sig;
    }
    AgenteNueva->instancia = NULL;

    AgenteNueva->padre = buscado; // PADRE DEL AGENTE ACTUAL

    // ANEXAR LA INSTANCIA NUEVA AL AGENTE PATRON
    AgenteNueva->sig = Agente[buscado].instancia;
    Agente[buscado].instancia = AgenteNueva;

    // INSERTA EN LA VENTANA VISIBLE
    for( n = 0; n < Fprimero->TreeA->Items->Count ; n++ )
    {
          //FRAGMENTA EL CONCEPTO EN SUS PARTES
          strcpy(unnodo ,Fprimero->TreeA->Items->Item[n]->Text.c_str());
          if( strcmp(unnodo ,agente) == 0 )
          {
              Fprimero->TreeA->Items->Item[n]->Selected = true;
              break;
          }
    }
    Fprimero->TreeA->Items->AddChild(Fprimero->TreeA->Selected
      ,AnsiString(instancia) + AnsiString(" ") //  [0 of 0]") 
    );
    return SI;
}
//---------------------------------------------------------------------------
TipoPapel *cargaEnMain(char *papel_deseado)
{
TipoPapel *solicitado ;
int hay ;

// VARIABLES PARA CARGAR EL CONTENIDO DEL PAPEL
char nom_arch_carga[100] ;
TipoArgumentos argumento ;
char linea[201];
int i ,n ,ix ,fin ,alto ,esta ,longitud ,donde ,ant_u_cadena ;
FILE *arch ;
FILE *tempo ;

    // UBICAR DE LA LISTA DE PAPELES AUXILIARES EL SOLICITADO
    solicitado = Main.papel;
    hay = NO;
    while( (solicitado != NULL) && (hay == NO) )
    {
        if( strcmp(papel_deseado ,solicitado->nombre) == 0 )
        {
            hay = SI;
            return solicitado;
        }
        else
            solicitado = solicitado->sig;
    }
    if( hay == NO )
    {
        ant_u_cadena = UCadena;

        // ABRE EL ARCHIVO A CARGAR
        strcpy(nom_arch_carga ,papel_deseado);
        strcat(nom_arch_carga ,".cod");
        arch = fopen(nom_arch_carga ,"rt");
        if( arch == NULL )
        {
            fclose(arch);
            return NULL;
        }
        PapelNueva = NULL;
        fin = NO;
        while( fin == NO )
        {
            if( fgets(linea, 200, arch) == NULL )
            {
                fin = 1;
                continue;
            }
            longitud = strlen(linea);
            if( linea[longitud - 1] == '\n' )
                linea[longitud - 1] = '\0';
            separaComando(linea ,&argumento);

            // CADENA
            if( strcmp(argumento.comando ,"l$") == 0 )
            {
                Cadena[UCadena].cadena = (char *)malloc(strlen(linea + 3) + 1);
                strcpy(Cadena[UCadena].cadena ,linea + 3);
                UCadena++;
                continue;
            }
            // PAPEL
            if( strcmp(argumento.comando ,"P") == 0 )
            {
                PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel));
                strcpy(PapelNueva->nombre ,papel_deseado);
                PapelNueva->cupo = NO_HAY;
                PapelNueva->usados = NO_HAY;
                PapelNueva->requisito = NULL;
                PapelNueva->u_local = 0;
                PapelNueva->u_instruccion = 0;
                PapelNueva->instruccion = NULL;

                // PEGARLO EN LA LISTA DE MAIN
                PapelNueva->sig = Main.papel;
                Main.papel = PapelNueva;
                continue;
            }
            // REQUISITOS DEL PAPEL
            if( strcmp(argumento.comando ,"r") == 0 )
            {
                sim_InsertaRequisito(PapelNueva ,argumento.param[0]);
                continue;
            }
            // VARIABLE LOCAL
            if( strcmp(argumento.comando ,"L") == 0 )
            {
                strcpy(PapelNueva->local[PapelNueva->u_local].nombre ,argumento.param[1]);
                PapelNueva->local[PapelNueva->u_local].tipo = argumento.param[0][0];
                PapelNueva->local[PapelNueva->u_local].dim1 = atoi(argumento.param[2]);
                PapelNueva->local[PapelNueva->u_local].dim2 = atoi(argumento.param[3]);
                PapelNueva->u_local++;
                continue;
            }

            // INICIO DE LAS INSTRUCCIONES DE UN PAPEL
            if( strcmp(argumento.comando ,"INICIO") == 0 )
            {
               UEtiqueta = 0;
               n = 0;
               tempo = fopen("tempo.tmp","wt");
               alto = 0;
               while( alto == 0 )
               {
                   if( fgets(linea, 200, arch) == NULL )
                   {
                      alto = 1;
                      fin = 1;
                      continue;
                   }
                   longitud = strlen(linea);
                   if( linea[longitud - 1] == '\n' )
                       linea[longitud - 1] = '\0';
                   if( linea[0] == ':' )
                   {
                       // ES UNA ETIQUETA, GUARDARLA
                       esta = 0;
                       for( IEtiqueta = 0; IEtiqueta < UEtiqueta; IEtiqueta++)
                       {
                           if(strcmp(Etiqueta[IEtiqueta].nombre ,linea + 1) == 0 )
                               esta = 1;
                       }
                       if( esta == 0 )
                       {
                           strcpy(Etiqueta[UEtiqueta].nombre ,linea + 1);
                           Etiqueta[UEtiqueta].direccion = n;
                           UEtiqueta++;
                       }
                   }
                   else
                   {
                       fprintf(tempo ,"%s\n" ,linea);
                       n++;
                   }
                   if( strncmp(linea ,"STOP" ,4) == 0 )
                       alto = 1;
               }
               fprintf( tempo, "* *\n");
               for( IEtiqueta = 0; IEtiqueta < UEtiqueta; IEtiqueta++)
                   fprintf( tempo, "%s %d\n",Etiqueta[IEtiqueta].nombre ,Etiqueta[IEtiqueta].direccion);
               fclose(tempo);

               PapelNueva->u_instruccion = n;
               // SE ASIGNA ESPACIO EN MEMORIA PARA QUE EL PAPEL SEA UN ARREGLO
               PapelNueva->instruccion =
                   (TipoInstruccion *)malloc(sizeof(TipoInstruccion) * (n+1));

               tempo = fopen("tempo.tmp","rt");
               alto = 0;
               i = 0;
               while( alto == 0 )
               {
                   if( fgets(linea, 200, tempo) == NULL )
                   {
                      alto = 1;
                      continue;
                   }
                   longitud = strlen(linea);
                   if( linea[longitud - 1] == '\n' )
                       linea[longitud - 1] = '\0';
                   separaComando(linea ,&argumento);

                   if( strcmp(linea ,"* *") == 0 )
                   {
                      alto = 1;
                      continue;
                   }

                   // AJUSTAR LOS PARAMETROS EN CASO QUE SEAN CADENAS (inician con $)
                   for( ix = 0; ix < 3; ix++ )
                       if( argumento.param[ix][0] == '$' )
                           sprintf(argumento.param[ix] ,"$%d" ,atoi(argumento.param[ix] + 1) + ant_u_cadena);

                   strcpy(PapelNueva->instruccion[i].opcode ,argumento.comando);
                   strcpy(PapelNueva->instruccion[i].op1 ,argumento.param[0]);
                   strcpy(PapelNueva->instruccion[i].op2 ,argumento.param[1]);
                   strcpy(PapelNueva->instruccion[i].op3 ,argumento.param[2]);
                   strcpy(PapelNueva->instruccion[i].op4 ,argumento.param[3]);
                   strcpy(PapelNueva->instruccion[i].op5 ,argumento.param[4]);


                   // SUSTITUYE LAS ETIQUETAS POR LAS POSICIONES EN EL ARREGLO
                   if( (strcmp(argumento.comando ,"JMP") == 0) ||
                       (strcmp(argumento.comando ,"JEQ") == 0) )
                   {
                       esta = NO;
                       for( IEtiqueta = 0; (IEtiqueta < UEtiqueta) && (esta == NO); IEtiqueta++)
                           if( strcmp(Etiqueta[IEtiqueta].nombre ,argumento.param[0]) == 0 )
                           {
                               donde = IEtiqueta;
                               esta = SI;
                           }
                       if( esta == SI )
                           sprintf(PapelNueva->instruccion[i].op1 ,"%d" ,Etiqueta[donde].direccion);
                       else
                           sprintf(PapelNueva->instruccion[i].op1 ,"%d" ,n);
                   }
                   i++;
               }
               fclose(tempo);
            }
        }
        return PapelNueva;
    }
}
//---------------------------------------------------------------------------
int sim_InstanciaInteraccion(char *interaccion ,char *instancia)
{
int buscada ;
int esta ;
int n;
char unnodo[100] ;


    for( esta = NO, IInteraccion = 0; (IInteraccion < UInteraccion) && (esta == NO); IInteraccion++ )
    {
        if( strcmp(interaccion ,Interaccion[IInteraccion].nombre) == 0 )
        {
            esta = SI;
            buscada = IInteraccion;
        }
    }
    if( esta == SI )
    {
        InteraccionNueva = (TipoInteraccion *) malloc(sizeof(TipoInteraccion));
        strcpy(InteraccionNueva->nombre ,instancia);
        InteraccionNueva->papel = NULL;
        InteraccionNueva->instancia = NULL;
        InteraccionNueva->padre = buscada;

        //COPIAR LOS PAPELES
        PapelAp = Interaccion[buscada].papel;
        while( PapelAp != NULL )
        {
            PapelNueva = (TipoPapel *) malloc(sizeof(TipoPapel));
            strcpy(PapelNueva->nombre ,PapelAp->nombre);
            PapelNueva->cupo = PapelAp->cupo;
            PapelNueva->usados = 0;
            PapelNueva->requisito = NULL;
            PapelNueva->u_local = 0;
            PapelNueva->u_instruccion = 0;
            PapelNueva->instruccion = NULL;
            PapelNueva->sig = InteraccionNueva->papel;
            PapelNueva->contenido = PapelAp;
            InteraccionNueva->papel = PapelNueva;

            // TOMA EL SIGUIENTE PAPEL
            PapelAp = PapelAp->sig;
        }
        // ANEXAR LA INSTANCIA NUEVA A LA INTERACCION PROPIETARIA
        InteraccionNueva->sig = Interaccion[buscada].instancia;
        Interaccion[buscada].instancia = InteraccionNueva;

        // INSERTA EN LA VENTANA VISIBLE
        for( n = 0; n < Fprimero->TreeI->Items->Count ; n++ )
        {
              //FRAGMENTA EL CONCEPTO EN SUS PARTES
              strcpy(unnodo ,Fprimero->TreeI->Items->Item[n]->Text.c_str());
              if( strcmp(unnodo ,interaccion) == 0 )
              {
                  Fprimero->TreeI->Items->Item[n]->Selected = true;
                  break;
              }
        }
        Fprimero->TreeI->Items->AddChild(Fprimero->TreeI->Selected ,instancia);
        return SI;
    }
    return NO;
}
//---------------------------------------------------------------------------
int LeeVar(TipoHebra *hebra ,char *nombre ,char ambito)
{
TipoGlobal *global_ap ;
int i_local ;
int i_interna ;
TipoRegional *regional_ap ;
TipoVRegion *esta_regional ;
int esta ,la_percibe ;

    Buffer[0] = '\0';
    // BUSCA EN LOCALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'L') )
    {
        if( hebra->u_local > 0 )
        {
            for(esta = NO ,i_local = 0; (esta == NO) && (i_local < hebra->u_local); i_local++ )
                if( strcmp(hebra->local[i_local].nombre ,nombre) == 0 )
                {
                     esta = SI;
                     sprintf(Buffer ,"%s",hebra->local[i_local].valor);
                }
        }
    }
    if( esta == SI )
        return esta;
    // BUSCA EN INTERNAS
    if( hebra->agente != NULL )
    {
        if( (ambito == '*') || (ambito == 'I') )
        {
            if( hebra->agente->u_interna > 0 )
            {
                for(esta = NO ,i_interna = 0; (esta == NO) && (i_interna < hebra->agente->u_interna); i_interna++ )
                    if( strcmp(hebra->agente->interna[i_interna].nombre ,nombre) == 0 )
                    {
                         esta = SI;
                         sprintf(Buffer ,"%s" ,hebra->agente->interna[i_interna].valor);
                    }
            }
        }
    }
    if( esta == SI )
        return esta;
    // BUSCA EN REGIONALES
    if( hebra->agente != NULL )
    {
        if( (ambito == '*') || (ambito == 'R') )
        {
            if( hebra->agente->regional != NULL )
            {
                // VER SI PERCIBE LA VARIABLE REGIONAL
                esta_regional = hebra->agente->regional;
                la_percibe = NO;
                while( (la_percibe == NO) && (esta_regional != NULL ) )
                {
                    if( strcmp(esta_regional->nombre ,nombre) == 0 )
                        la_percibe = SI;
                    else
                        esta_regional = esta_regional->sig;
                }
                if( la_percibe == SI )
                {
                    for(esta = NO ,IRegional = 0; (esta == NO) && (IRegional < URegional); IRegional++ )
                        if( strcmp(Regional[IRegional].nombre ,nombre) == 0 )
                        {
                             esta = SI;
                             sprintf(Buffer ,"%s" ,Regional[IRegional].valor);
                        }
                }
            }
        }
    }
    if( esta == SI )
        return esta;
    // BUSCA EN GLOBALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'G') )
    {
        for(esta = NO ,IGlobal = 0; (esta == NO) && (IGlobal < UGlobal); IGlobal++ )
            if( strcmp(Global[IGlobal].nombre ,nombre) == 0 )
            {
                 esta = SI;
                 sprintf(Buffer ,"%s" ,Global[IGlobal].valor);
            }
    }
    return esta;
}
//---------------------------------------------------------------------------
int EscribeVar(TipoHebra *hebra ,char *nombre ,char ambito)
{
TipoGlobal *global_ap ;
int i_local ,i_interna ;
TipoVRegion *esta_regional ;
int esta ,la_percibe ;

    // BUSCA EN LOCALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'L') )
    {
        if( hebra->u_local > 0 )
        {
            for(esta = NO ,i_local = 0; (esta == NO) && (i_local < hebra->u_local); i_local++ )
                if( strcmp(hebra->local[i_local].nombre ,nombre) == 0 )
                {
                     esta = SI;
                     sprintf(hebra->local[i_local].valor ,"%s" ,Buffer);
                }
        }
        if( esta == SI )
            return esta;
    }
    // BUSCA EN INTERNAS
    if( hebra->agente != NULL )
    {
        if( (ambito == '*') || (ambito == 'I') )
        {
            if( hebra->agente->u_interna > 0 )
            {
                for(esta = NO ,i_interna = 0; (esta == NO) && (i_interna < hebra->agente->u_interna); i_interna++ )
                    if( strcmp(hebra->agente->interna[i_interna].nombre ,nombre) == 0 )
                    {
                         esta = SI;
                         sprintf(hebra->agente->interna[i_interna].valor ,"%s" ,Buffer);
                    }
            }
        }
    }
    if( esta == SI )
        return esta;
    // BUSCA EN REGIONALES
    if( hebra->agente != NULL )
    {
        if( (ambito == '*') || (ambito == 'R') )
        {
            if( hebra->agente->regional != NULL )
            {
                // VER SI PERCIBE LA VARIABLE REGIONAL
                esta_regional = hebra->agente->regional;
                la_percibe = NO;
                while( (la_percibe == NO) && (esta_regional != NULL ) )
                {
                    if( strcmp(esta_regional->nombre ,nombre) == 0 )
                        la_percibe = SI;
                    else
                        esta_regional = esta_regional->sig;
                }
                if( la_percibe == SI )
                {
                    for(esta = NO ,IRegional = 0; (esta == NO) && (IRegional < URegional); IRegional++ )
                        if( strcmp(Regional[IRegional].nombre ,nombre) == 0 )
                        {
                             esta = SI;
                             sprintf(Regional[IRegional].valor ,"%s" ,Buffer);
                        }
                }
            }
        }
    }
    if( esta == SI )
        return esta;
    // BUSCA EN GLOBALES
    esta = NO;
    if( (ambito == '*') || (ambito == 'G') )
    {
        for(esta = NO ,IGlobal = 0; (esta == NO) && (IGlobal < UGlobal); IGlobal++ )
            if( strcmp(Global[IGlobal].nombre ,nombre) == 0 )
            {
                 esta = SI;
                 sprintf(Global[IGlobal].valor ,"%s" ,Buffer);
            }
    }
    return esta;
}
//---------------------------------------------------------------------------
void separaVarVal(char *linea, TipoVarVal *varval)
{
int i_linea ;
int sigue ;
char var_val[100] ;
int u_var_val ,i_var_val ,j_var_val;

    i_linea = 0;
    varval->ultimo = 0;
    sigue = SI;
    while( sigue == SI )
    {
        if( linea[i_linea] == '\0' )
        {
              sigue = NO;
              continue;
        }

        // TOMA VARIABLE_VALOR
        u_var_val = 0;
        while( (linea[i_linea] != ' ') && (linea[i_linea] != '\0') )
        {
            var_val[u_var_val] = linea[i_linea];
            i_linea++;
            u_var_val++;
        }
        varval->variable[varval->ultimo][0] = '\0';
        varval->valor[varval->ultimo][0] = '\0';

        // TOMA VARIABLE
        for( i_var_val = 0; (i_var_val < u_var_val) &&
          (var_val[i_var_val] != '_'); i_var_val++  )
        {
            varval->variable[varval->ultimo][i_var_val] = var_val[i_var_val];
            varval->variable[varval->ultimo][i_var_val + 1] = '\0';
        }
        i_var_val++;

        // TOMA VALOR
        for( j_var_val = 0; (i_var_val < u_var_val) &&
          (var_val[i_var_val] != '_'); i_var_val++, j_var_val++  )
        {
            varval->valor[varval->ultimo][j_var_val] = var_val[i_var_val];
            varval->valor[varval->ultimo][j_var_val + 1] = '\0';
        }
        varval->ultimo++;
        i_linea++;
    }
}
//---------------------------------------------------------------------------
/*
void separaValores(char *linea, TipoValores *valores)
{
int i_linea ;
int sigue ;
char var_val[100] ;
int i_pos ;

    i_linea = 0;
    valores->ultimo = 0;
    sigue = SI;
    while( sigue == SI )
    {
        if( linea[i_linea] == '\0' )
        {
              sigue = NO;
              continue;
        }

        // TOMA VALOR
        i_pos = 0;
        while( (linea[i_linea] != ' ') && (linea[i_linea] != '\0') )
        {
            valores->valor[valores->ultimo][i_pos] = linea[i_linea];
            i_pos++;
            i_linea++;
        }
        valores->valor[valores->ultimo][i_pos] = '\0';

        if( linea[i_linea] == ' ' )
            i_linea++; // PASA AL SIGUIENTE SIMBOLO

        valores->ultimo++; // PASA AL SIGUIENTE VALOR
    }
}
*/
//---------------------------------------------------------------------------
void __fastcall TFprimero::Timer1Timer(TObject *Sender)
{
SYSTEMTIME tiempo ;
int tallatiempo ;
String tiempofmt ;

    GetLocalTime(&tiempo) ;
    tiempofmt.SetLength(64) ;
    tallatiempo = GetTimeFormat(LOCALE_USER_DEFAULT, 0, &tiempo, NULL,
    tiempofmt.c_str() ,tiempofmt.Length());
    tiempofmt.SetLength(tallatiempo) ;
    StatusBar1->Panels->Items[1]->Text = tiempofmt ;
    StatusBar1->Panels->Items[2]->Text = DateToStr(Date());
}


//---------------------------------------------------------------------------
void sim_Planifica(TipoAgente *agente)
{
TipoProposito *propAp;
int nivel_maximo ;
int existe_plan ;
TipoArgumentos parametros ;
int uno, dos, ireq ,iva ,jva ,iv ,cual ;
int UVariable ;
int nvar ;

typedef struct EstructuraVariable
{
    char nombre[50];
    int n ;
    int inicio ;
    int fin ;
} TipoVariable ;

TipoVariable Variable[100] ;

typedef struct EstructuraUnifica
{
    char variable[MAXIMOS] ;
    char valor[MAXIMOS] ;
} TipoUnifica ;

TipoUnifica Unifica[MAXIMOS] ;
int UUnifica, IUnifica ;
int unifico ,esta;

typedef struct EstructuraPropaga
{
    int situacion ;
    int u_papel ;
    int papel[MAXIMOS] ;
} TipoPropaga ;

TipoPropaga Propaga[MAXIMOS] ;
int UPropaga ,IPropaga ,JPropaga;

typedef struct EstructuraPlanFinal
{
    int nivel ;
    int papel ;
} TipoPlanFinal ;

TipoPlanFinal PlanFinal[100] ;
int UPlanFinal ,IPlanFinal ;



    Fprimero->Box2->Clear();
    // CARGA PAPELES A PARTIR DEL SISTEMA DESCRITO predicado_valor
    USituacion = 0;
    for( IPapeles = 0; IPapeles < UPapeles; IPapeles++ )
    {
        // TOMA UN REQUISITO
        separaVarVal(Papeles[IPapeles].requisito, &vReq);
        for( ireq = 0; ireq < vReq.ultimo; ireq++ )
        {
        int existe ;

            // BUSCA SI EL PREDICADO YA EXISTE, SI EXISTE NO DUPLICARLO
            existe = NO;
            for( int isit = 0; (isit < USituacion) && (existe == NO); isit++ )
            {
                if( strcmp(vReq.variable[ireq] ,Situacion[isit].predicado) == 0)
                    existe = SI;
            }
            if( existe == NO )
            {
                strcpy(Situacion[USituacion].predicado ,vReq.variable[ireq]);
                USituacion++;
            }
        }
    }
    // TOMAR EL VALOR DE CADA VARIABLE DE LA SITUACION EN LAS VARIABLES DEL AGENTE
    for( ISituacion = 0; ISituacion < USituacion; ISituacion++ )
    {
        LeeInterna(agente ,Situacion[ISituacion].predicado);
        strcpy(Situacion[ISituacion].valor ,Buffer);
    }

int isitnueva ;
    // COMPACTA LAS VARIABLES CUYO VALOR ES NULO
    for( isitnueva = -1, ISituacion = 0; ISituacion < USituacion; ISituacion++ )
    {
        LeeInterna(agente ,Situacion[ISituacion].predicado);
        strcpy(Situacion[ISituacion].valor ,Buffer);
        if( strlen(Buffer) > 1 )
        {
            isitnueva++;
            strcpy( Situacion[isitnueva].predicado, Situacion[ISituacion].predicado);
            strcpy( Situacion[isitnueva].valor, Situacion[ISituacion].valor);
        }
    }
    USituacion = isitnueva + 1;

    USituacionK = USituacion;

    // MARCA COMO NO ALCANZADOS LOS PROPOSITOS DEL AGENTE
    propAp = agente->proposito;
    while( propAp != NULL )
    {
        propAp->estado = NO;
        propAp->elegido = NO;
        propAp = propAp->sig;
    }
    // GENERANDO EL PLAN PARA CADA PROPOSITO POR ALCANZAR
    propAp = agente->proposito;
    while( propAp != NULL )
    {
        // ESTA ALCANZADO EL PROPSITO?
        if( propAp->elegido == SI )
        {
            propAp = propAp->sig;
            continue;
        }
        Fprimero->Box1->Items->Add
           ("        " + AnsiString(propAp->proposito));
        fprintf(Resultados ,"        %s\n", propAp->proposito);
        
        // VALORES INICIALES DEL ARBOL DE DESARROLLO
        UNivel = 0;
        Nivel[0].situacion_ini = 0;
        Nivel[0].situacion_fin = NO_HAY;
        Nivel[0].arbol_ini = NO_HAY;
        Nivel[0].arbol_fin = NO_HAY;

        nivel_maximo = atoi(Fprimero->Edit2->Text.c_str());
        existe_plan = NO;
        UArbol = 0;
        USituacion = USituacionK;
        for( int nivel = 0; (nivel < nivel_maximo) && (existe_plan == NO);
          nivel++ )
        {
            Nivel[nivel].situacion_fin = USituacion;
            Nivel[nivel + 1].situacion_ini = 0; //USituacion;
            Nivel[nivel].arbol_ini = UArbol;
            Nivel[nivel].arbol_fin = NO_HAY;

/* ----- */
            for( int isitu = Nivel[nivel].situacion_ini;
              isitu < Nivel[nivel].situacion_fin; isitu++ )
                Fprimero->Box2->Items->Add("   " +
                  AnsiString(isitu) + " " +
                  AnsiString(Situacion[isitu].predicado)
                    + " " + AnsiString(Situacion[isitu].valor));
/* ----- */


            // GENERA LAS ACCIONES POSIBLES
            for( IPapeles = 0; IPapeles < UPapeles; IPapeles++ )
            {
                // TOMA LOS ARGUMENTOS DEL PAPEL
                separaComando(Papeles[IPapeles].papel ,&parametros);

                // TOMA LOS REQUISITOS
                separaVarVal(Papeles[IPapeles].requisito, &vReq);

                // TOMA LOS VALORES DE LOS ARGUMENTOS DEL PAPEL
                UValor = 0;
                UVariable = 0;
                for( ireq = 0; ireq < vReq.ultimo; ireq++ )
                {
                    strcpy(Variable[UVariable].nombre ,vReq.variable[ireq]);
                    Variable[UVariable].n = 0;
                    Variable[UVariable].inicio = NO_HAY;
                    Variable[UVariable].fin = NO_HAY;
                    // PARA CADA SITUACION
                    for( ISituacion = Nivel[nivel].situacion_ini;
                        ISituacion < Nivel[nivel].situacion_fin; ISituacion++ )
                    {
                        if( strcmp(Situacion[ISituacion].predicado,
                          vReq.variable[ireq]) == 0 )
                        {
                            // EL VALOR EXISTE?
                            if( strlen(Situacion[ISituacion].valor) < 1 )
                                continue;
                            // AGREGARLO EN LA LISTA DE VALORES
                            Valor[UValor] = ISituacion;
                            if( Variable[UVariable].n == 0 )
                                Variable[UVariable].inicio = UValor;
                            Variable[UVariable].fin = UValor;
                            Variable[UVariable].n++;
                            UValor++;
                        }
                    }
                    if( Variable[UVariable].n == 0 )
                    {
                        //Fprimero->Box1->Items->Add("*");
                        continue;
                        // Buscar un valor en las internas del agente
                        // si se encuentra se aade sino se salta este papel
                    }
                    UVariable++; // PASA A LA SIGUIENTE VARIABLE
                }
                UVector = 0;
                if( vReq.ultimo < 2 ) // HAY MENOS DE 2 VARIABLES ?
                {
                    // COPIA LOS VALORES DE LA VARIABLE A VECTOR
                    Vector[UVector].u_valor = 0;
                    for( iva = Variable[0].inicio; iva <= Variable[0].fin;
                      iva++)
                    {
                        Vector[UVector].valor[ Vector[UVector].u_valor ]
                          = Valor[iva];
                        Vector[UVector].u_valor++;
                    }
                    UVector++;
                }
                else
                {
                    uno = 0;
                    dos = 1;
                    Vector[UVector].u_valor = 0;
                    // PARA CADA VALOR DE LA VARIABLE uno
                    for( iva = Variable[uno].inicio; iva <= Variable[uno].fin;
                      iva++)
                    {
                        // PARA CADA VALOR DE LA VARIABLE dos
                        for( jva = Variable[dos].inicio;
                          jva <= Variable[dos].fin; jva++)
                        {
                            Vector[UVector].valor[0] = Valor[iva];
                            Vector[UVector].valor[1] = Valor[jva];
                            Vector[UVector].u_valor = 2;
                            UVector++;
                        }
                    }
                    for( nvar = 2; nvar < vReq.ultimo; nvar++ )
                    {
                        // COPIA VECTOR A ENTRADA
                        UEntrada = UVector;
                        for( IEntrada = 0; IEntrada < UEntrada; IEntrada++ )
                        {
                            for( iv = 0; iv < Vector[IEntrada].u_valor; iv++ )
                                Entrada[IEntrada].valor[iv] =
                                  Vector[IEntrada].valor[iv];
                            Entrada[IEntrada].u_valor =
                              Vector[IEntrada].u_valor;
                        }

                        UVector = 0;
                        // PARA CADA VALOR DE LA VARIABLE uno
                        for( iva = 0; iva < UEntrada; iva++)
                        {
                            // PARA CADA VALOR DE LA VARIABLE nvar
                            for( jva = Variable[nvar].inicio; jva <= Variable[nvar].fin; jva++)
                            {
                                // COPIA LOS VALORES DE ENTRADA A VECTOR
                                for( iv = 0; iv < Entrada[iva].u_valor; iv++ )
                                    Vector[UVector].valor[iv] =
                                      Entrada[iva].valor[iv];
                                Vector[UVector].valor[iv] = Valor[jva];
                                Vector[UVector].u_valor = iv + 1;
                                UVector++;
                            }
                        }
                    }
                }

                // REVISAR LA UNIFICACION DE CADA RENGLON DE PRODUCTO CARTESIANO
                for( IVector = 0; IVector < UVector; IVector++ )
                {
                    // SUPONE QUE UNIFICA A MENOS QUE SE DEMUESTRE LO CONTRARIO
                    unifico = SI;
                    UUnifica = 0; // INICIALIZA LA TABLA DE UNIFICACIONES
                    for( ireq = 0; (ireq < vReq.ultimo) && (unifico == SI);
                      ireq++ )
                    {
                        esta = NO;
                        // REVISA LA TABLA DE UNIFICACIONES
                        for( IUnifica = 0; IUnifica < UUnifica; IUnifica++ )
                        {
                            if( strcmp(Unifica[IUnifica].variable
                              ,vReq.valor[ireq]) == 0 )
                            {
                                esta = SI;
                                if( strcmp(Unifica[IUnifica].valor
                                  ,Situacion[Vector[IVector].valor[ireq]].valor)
                                   != 0 )
                                    unifico = NO;
                            }
                        }
                        if( esta == NO )
                        {
                            strcpy(Unifica[UUnifica].variable
                              ,vReq.valor[ireq]);
                            strcpy(Unifica[UUnifica].valor
                              ,Situacion[Vector[IVector].valor[ireq]].valor);
                            UUnifica++;
                        }
                    }
                    if( unifico == NO )
                    {
                        continue; // NO SE PUDO APLICAR EL OPERADOR
                    }

                    // SE COLOCAN LOS REQUISITOS
                    Arbol[UArbol].u_requisito = 0;
                    for( iv = 0; iv < Vector[IVector].u_valor; iv++ )
                    {
                        Arbol[UArbol].requisito[Arbol[UArbol].u_requisito] =
                            Vector[IVector].valor[iv];
                        Arbol[UArbol].u_requisito++;
                    }

                    // TOMA EL NOMBRE DEL PAPEL
                    strcpy(Arbol[UArbol].accion, parametros.comando);

                    // TOMAR EL PAPEL Y LA INTERACCION A LA QUE PERTENECE
                    Arbol[UArbol].interaccion = Papeles[IPapeles].interaccion;
                    Arbol[UArbol].papel = Papeles[IPapeles].apPapel;

                    // SE GENERAN LOS EFECTOS POSITIVOS

                    // TOMA LOS EFECTOS POSITIVOS
                    Arbol[UArbol].u_positivo = 0;
                    separaVarVal(Papeles[IPapeles].positivo, &vPos);
                    for( int ipos = 0; ipos < vPos.ultimo; ipos++ )
                    {
                        esta = NO;
                        for( IUnifica = 0;
                          (IUnifica < UUnifica) && (esta == NO); IUnifica++ )
                        {
                            if( strcmp(Unifica[IUnifica].variable ,
                                vPos.valor[ipos]) == 0 )
                            {
                                strcpy(vPos.valor[ipos],
                                  Unifica[IUnifica].valor);
                                esta = SI;
                            }
                        }
                        if( esta == SI )
                        {
                            cual = NO_HAY;
                            for( ISituacion = 0;
                              (ISituacion < USituacion) && (cual == NO_HAY);
                              ISituacion++ )
                            {
                                if( (strcmp(Situacion[ISituacion].predicado,
                                  vPos.variable[ipos]) == 0) &&
                                  (strcmp(Situacion[ISituacion].valor,
                                  vPos.valor[ipos]) == 0) )
                                {
                                    cual = ISituacion;
                                }
                            }
                            if( cual == NO_HAY )
                            {
                                strcpy(Situacion[USituacion].predicado,
                                  vPos.variable[ipos]);
                                strcpy(Situacion[USituacion].valor,
                                  vPos.valor[ipos]);
                                cual = USituacion;
                                USituacion++;
                            }
                            Arbol[UArbol].positivo[Arbol[UArbol].u_positivo] =
                              cual;
                            Arbol[UArbol].u_positivo++;
                        }
                    }
                    // SE GENERAN LOS EFECTOS NEGATIVOS

                    // TOMA LOS EFECTOS NEGATIVOS
                    Arbol[UArbol].u_negativo = 0;
                    separaVarVal(Papeles[IPapeles].negativo, &vNeg);
                    for( int ipos = 0; ipos < vNeg.ultimo; ipos++ )
                    {
                        esta = NO;
                        for( IUnifica = 0;
                          (IUnifica < UUnifica) && (esta == NO); IUnifica++ )
                        {
                            if( strcmp(Unifica[IUnifica].variable ,
                                vNeg.valor[ipos]) == 0 )
                            {
                                strcpy(vNeg.valor[ipos],
                                  Unifica[IUnifica].valor);
                                esta = SI;
                            }
                        }
                        if( esta == SI )
                        {
                            cual = NO_HAY;
                            for( ISituacion = 0;
                              (ISituacion < USituacion) && (cual == NO_HAY);
                              ISituacion++ )
                            {
                                if( (strcmp(Situacion[ISituacion].predicado,
                                  vNeg.variable[ipos]) == 0) &&
                                  (strcmp(Situacion[ISituacion].valor,
                                  vNeg.valor[ipos]) == 0) )
                                {
                                    cual = ISituacion;
                                }
                            }
                            if( cual == NO_HAY )
                            {
                                strcpy(Situacion[USituacion].predicado,
                                  vNeg.variable[ipos]);
                                strcpy(Situacion[USituacion].valor,
                                  vNeg.valor[ipos]);
                                cual = USituacion;
                                USituacion++;
                            }
                            Arbol[UArbol].negativo[Arbol[UArbol].u_negativo] =
                              cual;
                            Arbol[UArbol].u_negativo++;
                        }
                    } // ipos
                  //  VALIDAR QUE NINGUN PREDICADO POSITIVO APAREZCA EN NEGATIVOS
    int estar ;
                    estar = NO;
                    for( int i = 0; (i < Arbol[UArbol].u_positivo) && (estar == NO); i++ )
                    {
                        for( int j = 0; (j < Arbol[UArbol].u_negativo) && (estar == NO); j++ )
                        {
                            if( Arbol[UArbol].positivo[i] ==
                              Arbol[UArbol].negativo[j] )
                            {
                                estar = SI;
                            }
                        }
                    }
                    if( estar == NO )
                         UArbol++;
                } // IVector (producto cartesiano)
            } // IPapeles

int primeros ;

            Nivel[nivel].arbol_fin = UArbol - 1;
            primeros = UArbol - 1;


            // REVISA LAS RELACIONES DE EXCLUSION
            Exclusion[nivel].u_papel = 0;
            Exclusion[nivel].u_predicado = 0;

            // INTERFERENCIA:
            // Si Requisito[IPapel] igual Negativo[JPapel] EXCLUSION I J Papel
            for( IPapeles = Nivel[nivel].arbol_ini;
              IPapeles <= Nivel[nivel].arbol_fin; IPapeles++ )
            {
                for( JPapeles = IPapeles + 1;
                  JPapeles <= Nivel[nivel].arbol_fin; JPapeles++ )
                {
                    esta = NO;
                    for( int i = 0; (i < Arbol[IPapeles].u_requisito) && (esta == NO); i++ )
                    {
                        for( int j = 0; (j < Arbol[JPapeles].u_negativo) && (esta == NO); j++ )
                        {
                            if( Arbol[IPapeles].requisito[i] ==
                              Arbol[JPapeles].negativo[j] )
                            {
                                esta = SI;
                            }
                        }
                    }
                    if( esta == SI )
                    {
                        Exclusion[nivel].papel[ Exclusion[nivel].u_papel ].A = IPapeles;
                        Exclusion[nivel].papel[ Exclusion[nivel].u_papel ].B = JPapeles;
                        Exclusion[nivel].u_papel++;
                    }
                }
            }

            // NECESIDADES COMPETITIVAS:
            // Si Requisito[IPapel] era exclusivo Requisito[JPapel] en nivel - 1
            if( nivel > 0 )
            {
                for( IPapeles = Nivel[nivel].arbol_ini;
                  IPapeles < Nivel[nivel].arbol_fin; IPapeles++ )
                {
                    for( JPapeles = IPapeles + 1;
                      JPapeles < Nivel[nivel].arbol_fin; JPapeles++ )
                    {
                        esta = NO; // SUPONE QUE NO ERAN EXCLUSIVOS
                        for( int i = 0; (i < Arbol[IPapeles].u_requisito) && (esta == NO); i++ )
                        {
                            for( int j = 0; (j < Arbol[JPapeles].u_requisito) && (esta == NO); j++ )
                            {
                                for( int iexc = 0; iexc < Exclusion[nivel].u_predicado; iexc++ )
                                    if( ((Exclusion[nivel].predicado[ iexc ].uno == Arbol[IPapeles].requisito[i]) &&
                                    (Exclusion[nivel].predicado[ iexc ].dos == Arbol[IPapeles].requisito[j])) ||
                                    ((Exclusion[nivel].predicado[ iexc ].dos == Arbol[IPapeles].requisito[i]) &&
                                    (Exclusion[nivel].predicado[ iexc ].uno == Arbol[IPapeles].requisito[j])) )
                                    esta = SI;
                            }
                        }
                        if( esta == SI )
                        {
                            Exclusion[nivel].papel[ Exclusion[nivel].u_papel ].A = IPapeles;
                            Exclusion[nivel].papel[ Exclusion[nivel].u_papel ].B = JPapeles;
                            Exclusion[nivel].u_papel++;
                        }
                    }
                }

            } // if nivel

            // PROPAGACION:
            // CONSTRUIR LA TABLA PROPAGA CON LOS EFECTOS POSITIVOS
            UPropaga = 0;
            Propaga[UPropaga].u_papel = 0;
            for( IPapeles = Nivel[nivel].arbol_ini;
                  IPapeles < Nivel[nivel].arbol_fin; IPapeles++ )
            {
                for( int i = 0; i < Arbol[IPapeles].u_positivo; i++ )
                {
                    esta = NO;
                    for( IPropaga = 0; (IPropaga < UPropaga) && (esta == NO); IPropaga++ )
                    {
                        if( Propaga[IPropaga].situacion == Papeles[IPapeles].positivo[i] )
                        {
                            Propaga[UPropaga].papel[ Propaga[UPropaga].u_papel ] = IPapeles;
                            Propaga[UPropaga].u_papel++;
                            esta = SI;
                        }
                    }
                    if( esta == NO )
                    {
                        Propaga[UPropaga].situacion = Arbol[IPapeles].positivo[i];
                        Propaga[UPropaga].papel[ Propaga[UPropaga].u_papel ] = IPapeles;
                        Propaga[UPropaga].u_papel++;
                        UPropaga++;
                        Propaga[UPropaga].u_papel = 0;
                    }
                }
            }
            for( IPropaga = 0; IPropaga < UPropaga; IPropaga++ )
            {
                for( JPropaga = IPropaga + 1; JPropaga < UPropaga; JPropaga++ )
                {
                    esta = SI; // SUPONE QUE SI HAY EXCLUSION
                    for( int ipapel = 0; (ipapel < Propaga[IPropaga].u_papel) && (esta == SI); ipapel++ )
                    {
                        for( int jpapel = 0; (jpapel < Propaga[JPropaga].u_papel) && (esta == SI); jpapel++ )
                        {
                            for( int i = 0; (i < Exclusion[nivel].u_papel) && (esta == SI); i++ )
                            {
                                if( (Exclusion[nivel].papel[i].A == Propaga[IPropaga].papel[ipapel] &&
                                    Exclusion[nivel].papel[i].B == Propaga[IPropaga].papel[jpapel]) ||
                                    (Exclusion[nivel].papel[i].B == Propaga[IPropaga].papel[ipapel] &&
                                    Exclusion[nivel].papel[i].A == Propaga[IPropaga].papel[jpapel]) )
                                    esta = SI;
                                else
                                    esta = NO;
                            }
                        }
                    }
                    if( esta == SI )
                    {
                        Exclusion[nivel].predicado[ Exclusion[nivel].u_predicado ].uno
                          = Propaga[IPropaga].situacion;
                        Exclusion[nivel].predicado[ Exclusion[nivel].u_predicado ].dos
                          = Propaga[JPropaga].situacion;
                        Exclusion[nivel].u_predicado++;
                    }
                }
            }

            // PROPAGA LA SITUACION
            for( ISituacion = Nivel[nivel].situacion_ini;
                        ISituacion < Nivel[nivel].situacion_fin; ISituacion++ )
            {
                Arbol[UArbol].requisito[ 0 ] = ISituacion;
                Arbol[UArbol].u_requisito = 1;
                strcpy(Arbol[UArbol].accion ,"nula");
                Arbol[UArbol].positivo[ 0 ] = ISituacion;
                Arbol[UArbol].u_positivo = 1;
                Arbol[UArbol].u_negativo = 0;
                UArbol++;
            }

            Nivel[nivel].arbol_fin = UArbol - 1;
            Nivel[nivel].situacion_fin = USituacion;

char predProp[25] ,valorProp[50] ;
int u_pos ,i_prop;
int indice_proposito ;

            u_pos = 0;
            for( i_prop = 0; (propAp->proposito[i_prop] != '_') &&
              (i_prop < strlen(propAp->proposito)); i_prop++ ,u_pos++ )
                predProp[u_pos] = propAp->proposito[i_prop];
            predProp[u_pos] = '\0';
            if( propAp->proposito[i_prop] == '_' )
                i_prop++;
            u_pos = 0;
            for( ; (propAp->proposito[i_prop] != '\0') &&
              (i_prop < strlen(propAp->proposito)); i_prop++ ,u_pos++ )
                valorProp[u_pos] = propAp->proposito[i_prop];
            valorProp[u_pos] = '\0';

            // BUSCO EL INDICE EN LA SITUACION ACTUAL DEL PROPOSITO A ENCONTRAR
            indice_proposito = NO_HAY;
            for( ISituacion = Nivel[nivel].situacion_ini;
              (ISituacion < Nivel[nivel].situacion_fin) &&
              (indice_proposito == NO_HAY); ISituacion++ )
           {
                if( (strcmp(Situacion[ISituacion].predicado ,predProp) == 0) &&
                  (strcmp(Situacion[ISituacion].valor ,valorProp) == 0) )
                    indice_proposito = ISituacion;
            }
            existe_plan = NO;
/* ----- */
// DESPLEGA EL ARBOL DE PLANEACION
// nivel requisitos  PAPEL    positivos   negativos
char saliendo[200] ,pedacito[50] ;

       Fprimero->Box2->Items->Add(AnsiString(indice_proposito));
       Fprimero->Box2->Items->Add(
         AnsiString("nivel  requisitos   PAPEL   positivos negativos"));
       for( int ia = Nivel[nivel].arbol_ini; ia <= Nivel[nivel].arbol_fin; ia++ )
       {
           saliendo[0] = '\0';
           sprintf(pedacito ,"%d: ",nivel);
           strcat(saliendo ,pedacito);
           for( int ir  = 0; ir < Arbol[ia].u_requisito; ir++ )
           {
               sprintf(pedacito ,"%d ", Arbol[ia].requisito[ ir ]);
               strcat(saliendo ,pedacito);
           }
           strcat(saliendo ,Arbol[ia].accion);
           strcat(saliendo ," + ");
           for( int ip  = 0; ip < Arbol[ia].u_positivo; ip++ )
           {
               sprintf(pedacito ,"%d ", Arbol[ia].positivo[ ip ]);
               strcat(saliendo ,pedacito);
           }
           strcat(saliendo ," - ");
           for( int in  = 0; in < Arbol[ia].u_negativo; in++ )
           {
               sprintf(pedacito ,"%d ",  Arbol[ia].negativo[ in ]);
               strcat(saliendo ,pedacito);
           }
           Fprimero->Box2->Items->Add(saliendo);
       }

 char zale[200] ,cacho[50] ;
            sprintf(zale ,"Exclusiones ");
            for( int i = 0; i < Exclusion[nivel].u_papel; i++ )
            {
                sprintf(cacho ,"%d-%d ",Exclusion[nivel].papel[i]);
                strcat(zale ,cacho);
            }
            Fprimero->Box2->Items->Add(AnsiString(zale));
/* ----- */

            if( indice_proposito == NO_HAY ) // PUEDE EXISTIR UN PLAN???
                continue;

int SolAnterior ,papel_hayado ;
            // CREA EL ARBOL DE PLANEACION
            uSol = 0;
            SolAnterior = NO_HAY;
            Sol[uSol].nivel = nivel;
            Sol[uSol].liga_or = NO_HAY;
            Sol[uSol].upapel = 0;
            Sol[uSol].apunta = NO_HAY; // APUNTA A QUIEN RESUELVE SUS REQUISITOS
            for( int ia = Nivel[nivel].arbol_ini; ia <= Nivel[nivel].arbol_fin; ia++ )
            {
                papel_hayado = NO;
                for( int ip = 0; (ip < Arbol[ia].u_positivo) && (papel_hayado == NO); ip++ )
                {
                    if( indice_proposito == Arbol[ia].positivo[ip] )
                    {
                        if( strcmp("nula" ,Arbol[ia].accion) == 0 )
                            continue;
                        Sol[uSol].upapel = 1;
                        Sol[uSol].nivel = nivel;
                        Sol[uSol].papel[ 0 ] = ia;
                        Sol[uSol].apunta = NO_HAY;
                        Sol[uSol].liga_or = NO_HAY;
                        if( SolAnterior != NO_HAY )
                            Sol[SolAnterior].liga_or = uSol;
                        papel_hayado = SI;
                        SolAnterior = uSol;
                        uSol++;
                    }
                }
            }
            if( uSol > 0 )
            {
            int u_sol ;

                u_sol = uSol;
                for( int i_sol = 0; i_sol < u_sol; i_sol++ )
                    GeneraArbol(i_sol);
                existe_plan = HayPlan(nivel);
            }
int pexistente ;
            UPlanFinal = 0;
            if( existe_plan == SI )
            {
                for(int isol = 0; isol < uSol; isol++ )
                {
                    for( int ip = 0; ip < Sol[isol].upapel; ip++ )
                    {
                        pexistente = NO;
                        if( strcmp( Arbol[ Sol[isol].papel[ip] ].accion, "nula")
                          != 0 )
                        {
                            for( IPlanFinal = 0; (IPlanFinal < UPlanFinal) &&
                              (pexistente == NO); IPlanFinal++ )
                            {
                                if( (Sol[isol].papel[ip] ==
                                  PlanFinal[IPlanFinal].papel) &&
                                  (Sol[isol].nivel ==
                                  PlanFinal[IPlanFinal].nivel) )
                                    pexistente = SI;
                            }
                            if( pexistente == NO )
                            {
                                PlanFinal[UPlanFinal].papel =
                                  Sol[isol].papel[ip];
                                PlanFinal[UPlanFinal].nivel = Sol[isol].nivel;
                                UPlanFinal++;
                            }
                        }
                    }
                }

TipoPlan *planNuevo ,*apPlan ,*antPlan ;
                for( IPlanFinal = 0; IPlanFinal < UPlanFinal; IPlanFinal++ )
                {
                    Fprimero->Box1->Items->Add("              " +
                      AnsiString( PlanFinal[IPlanFinal].nivel) + " " +
                      AnsiString( Arbol[ PlanFinal[IPlanFinal].papel ].accion) +
                      " from " +
                      AnsiString(Interaccion[ Arbol[ PlanFinal[IPlanFinal].papel ].interaccion ].nombre)
                      );

                    fprintf(Resultados ,"              %d %s from %s\n",PlanFinal[IPlanFinal].nivel
                        ,Arbol[ PlanFinal[IPlanFinal].papel ].accion
                        ,Interaccion[ Arbol[ PlanFinal[IPlanFinal].papel ].interaccion ].nombre
                        );


                    planNuevo = (TipoPlan *) malloc(sizeof(TipoPlan));
                    planNuevo->nivel = PlanFinal[IPlanFinal].nivel;
                    planNuevo->papel = Arbol[ PlanFinal[IPlanFinal].papel ].papel;
                    planNuevo->interaccion = Arbol[ PlanFinal[IPlanFinal].papel ].interaccion;
                    planNuevo->estado = 0;
                    strcpy(planNuevo->nombrepapel
                      ,Arbol[ PlanFinal[IPlanFinal].papel ].accion);
                    planNuevo->proposito = propAp;
                    // ADICIONARLE AL PROPOSITO EL PLAN DEL AGENTE
                    planNuevo->sig = propAp->plan;
                    propAp->plan = planNuevo;
                }
            }
        } // nivel
        if( existe_plan == NO )
        {
            Fprimero->Box1->Items->Add("                Plan not found");
            fprintf(Resultados ,"                Plan not found\n");
        }
        propAp->elegido = SI; // NO IMPORTA SI SE ALCANZA O NO, YA SE ELIGIO
        propAp = propAp->sig;
    } // while propAp

typedef struct EstructuraIncompatible
{
    char papel1[MAX_PALABRA * 2] ;
    char papel2[MAX_PALABRA * 2] ;
} TipoIncompatible ;

TipoIncompatible Incompatible[100] ;
int UIncompatible ,IIncompatible ;

TipoProposito *approp;
TipoPlan *applan ;
int nivelminimo ;

    // GENERAR UNA LISTA DE PAPELES EN EJECUCION DEL AGENTE
    // generar la lista para determinar compatibilidad
    UIncompatible = 0;

    approp = agente->proposito;
    while( approp != NULL ) // PARA CADA PROPOSITO
    {
        applan = approp->plan;
        nivelminimo = NO_HAY;
        while( applan != NULL )
        {
            if( applan->estado == 0 )
            {
                if( nivelminimo == NO_HAY )
                    nivelminimo = applan->nivel;
                else
                    if( nivelminimo > applan->nivel )
                        nivelminimo = applan->nivel;
            }
            applan = applan->sig;
        }
        if( nivelminimo == NO_HAY )
        {
            approp = approp->sig;
            continue;
        }
        applan = approp->plan;
        while( applan != NULL ) // PARA CADA PROPOSITO
        {
            if( applan->nivel != nivelminimo )
            {
                applan = applan->sig;
                continue;
            }

            // buscar la compatibilidad
            // sino es compatible entonces brincar este papel
            if( buscaIncompatibles(agente ,applan->papel->nombre) == NO )
            {
                applan = applan->sig;
                continue;
            }

            if( applan->papel->usados >= applan->papel->cupo )
            {
                Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + " ## "
                  + AnsiString(agente->nombre)
                  + " not available space " + AnsiString(applan->papel->nombre));
                applan = applan->sig;
                continue;
            }

            // REVISAR LOS REQUISITOS DEL PAPEL A INICIAR  long > 0


            Fprimero->Box1->Items->Add(AnsiString(ElTiempo) + " * "
              + AnsiString(agente->nombre)
              + " starts " + AnsiString(applan->papel->nombre)
              + " from " + AnsiString(Interaccion[applan->interaccion].nombre) );

            applan->papel->usados++;

            fprintf(Resultados ,"%s %s starts %s from %s\n", ElTiempo
              ,agente->nombre ,applan->papel->nombre
              ,Interaccion[applan->interaccion].nombre);


            // ADICIONA EL PAPEL EN LA LISTA DE EJECUCION
            HebraNueva = (TipoHebra *) malloc(sizeof(TipoHebra) + 1);
            HebraNueva->tiempo = Reloj + 1;
            HebraNueva->PC = 0;
            HebraNueva->estado = 0;
            HebraNueva->papel = applan->papel;
            HebraNueva->plan = applan;
            HebraNueva->proposito = NULL;
            HebraNueva->stack = NULL;
            HebraNueva->u_local = applan->papel->u_local;
            HebraNueva->agente_nuevo = NO;
            HebraNueva->agente = agente;
            HebraNueva->sig = NULL;

            // SE LE CARGAN SUS VARIABLES LOCALES A LA HEBRA
            for( int i_local = 0; i_local < applan->papel->u_local; i_local++ )
            {
                strcpy(HebraNueva->local[i_local].nombre ,applan->papel->local[i_local].nombre);
                HebraNueva->local[i_local].tipo = applan->papel->local[i_local].tipo;
                HebraNueva->local[i_local].dim1 = applan->papel->local[i_local].dim1;
                HebraNueva->local[i_local].dim2 = applan->papel->local[i_local].dim2;
            }

             // SE LE AGREGA UN REFERENCIA A LA HEBRA
            IdHebraNueva = (TipoIdHebra *) malloc(sizeof(TipoIdHebra) + 1);
            IdHebraNueva->hebra = HebraNueva;
            IdHebraNueva->sig = agente->hebra;
            agente->hebra = IdHebraNueva;

            // INSERTA LA HEBRA EN LA COLA DE EJECUCION
            sim_InsertaEjecucion(HebraNueva);

            // PASA AL SIGUIENTE PAPEL
            applan->estado = 1;
            applan = applan->sig;
        }
        approp = approp->sig;
    }
}
//---------------------------------------------------------------------------
void GeneraArbol(int iSol)
{
int requisito[20] ;
int u_requisito ,i_requisito ,estareq ;
int nivelactual ;
int nodo ,nodoanterior ;
// PRODUCTO CARTESIANO
int uno ,dos ,iv ;
int se_resuelve ,estan_todos ,situacionesta ;

    // CONCATENA LOS REQUISITOS DE LOS PAPELES DEL NODO EN ANALISIS
    nivelactual = Sol[iSol].nivel - 1;
    u_requisito = 0;
    for( int ipapel = 0; ipapel < Sol[iSol].upapel; ipapel++ )
    {
        for( int ireq = 0; ireq < Arbol[ Sol[iSol].papel[ipapel] ].u_requisito; ireq++ )
        {
            requisito[u_requisito] =
              Arbol[ Sol[iSol].papel[ipapel] ].requisito[ireq];
            u_requisito++;
        }
    }
    if( u_requisito == 0 )
        return;
    if( nivelactual == -1 )
    {
        estan_todos = SI;
        for( i_requisito = 0; (i_requisito < u_requisito) && (estan_todos == SI); i_requisito++ )
        {
            situacionesta = NO;
            for( int is = Nivel[0].situacion_ini;
              is <= Nivel[0].situacion_fin; is++ )
            {
                if( requisito[i_requisito] == is )
                    situacionesta = SI;

            }
            if( situacionesta == NO )
                estan_todos = NO;
        }
        if( estan_todos == NO )
            Sol[iSol].upapel = 0;
        return;
    }

    // TOMA LOS PAPELES QUE ALCANZAN LOS REQUISITOS EN ESTE NIVEL
    uDes = 0;
    nodo = uDes;
    nodoanterior = NO_HAY;
    se_resuelve = SI;
    for( i_requisito = 0; (i_requisito < u_requisito) && (se_resuelve == SI); i_requisito++ )
    {
        Des[nodo].nivel = nivelactual;
        Des[nodo].upapel = 0;
        Des[nodo].liga_and = NO_HAY;
        if( nodoanterior != NO_HAY )
            Des[nodo].liga_and = nodoanterior;
        se_resuelve = NO;
        // COLOCAR EN EL NODO OR LOS PAPELES QUE LOGRAN EL PROPOSITO
        for( int ia = Nivel[nivelactual].arbol_ini;
          ia <= Nivel[nivelactual].arbol_fin; ia++ )
        {
            estareq = NO;
            for( int ip = 0; (ip < Arbol[ia].u_positivo) && (estareq == NO); ip++ )
                if( requisito[i_requisito] == Arbol[ia].positivo[ip] )
                    estareq = SI;
            if( estareq == SI )
            {
                Des[ nodo ].papel[ Des[ nodo ].upapel ] = ia;
                Des[ nodo ].upapel++;
                se_resuelve = SI;
            }
        }
        if( Des[nodo].upapel > 0 )
        {
            nodoanterior = nodo;
            uDes++;
            nodo = uDes;
        }
    }

    if( se_resuelve == NO ) // ALGUN REQUISITO LE FALTAN PAPELES ?
        return;
    if( uDes < 1 )
        return;

    // GENERA EL PRODUCTO CARTESIANO CON LOS PAPELES DE LOS NODOS

//    Fprimero->Box1->Items->Add("Generando el producto cartesiano de papeles");

    UVector = 0;
    if( uDes < 2 ) // HAY MENOS DE 2 GRUPOS DE AND ?
    {
        // COPIA LOS PAPELES A VECTOR
        Vector[UVector].u_valor = 0;
        for( int ip = 0; ip < Des[0].upapel; ip++)
        {
            Vector[UVector].valor[ Vector[UVector].u_valor ] = Des[0].papel[ip];
            Vector[UVector].u_valor++;
        }
        UVector++;
    }
    else
    {
        uno = 0;
        dos = 1;
        Vector[UVector].u_valor = 0;
        // PARA CADA PAPEL DEL NODO uno
        for( int ip = 0; ip < Des[uno].upapel; ip++)
        {
            // PARA CADA PAPEL DEL NODO dos
            for( int jp = 0; jp < Des[dos].upapel; jp++)
            {
                Vector[UVector].valor[0] = Des[uno].papel[ip];
                Vector[UVector].valor[1] = Des[dos].papel[jp];
                Vector[UVector].u_valor = 2;
                UVector++;
            }
        }
        for( int nvar = 2; nvar < uDes; nvar++ )
        {
            // COPIA VECTOR A ENTRADA
            UEntrada = UVector;
            for( IEntrada = 0; IEntrada < UEntrada; IEntrada++ )
            {
                for( int iv = 0; iv < Vector[IEntrada].u_valor; iv++ )
                    Entrada[IEntrada].valor[iv] = Vector[IEntrada].valor[iv];
                Entrada[IEntrada].u_valor = Vector[IEntrada].u_valor;
            }

            UVector = 0;
            // PARA CADA PAPEL DEL NODO uno
            for( int ip = 0; ip < UEntrada; ip++)
            {
                // PARA CADA VALOR DE LA VARIABLE nvar
                for( int jp = 0; jp < Des[nvar].upapel; jp++)
                {
                    // COPIA LOS VALORES DE ENTRADA A VECTOR
                    for( iv = 0; iv < Entrada[ip].u_valor; iv++ )
                        Vector[UVector].valor[iv] = Entrada[ip].valor[iv];
                    Vector[UVector].valor[iv] = Des[nvar].papel[jp];
                    // ADICIONA EL ELEMENTO DEL NODO nvar
                    Vector[UVector].u_valor = iv + 1;
                    UVector++;
                }
            }
        }
    }

int compatibles ,primerSol ,solAnterior;

    // REVISA LA CCOMPATIBILIDAD ENTRE PAPELES DEL MISMO VECTOR
    primerSol = NO_HAY;
    solAnterior = NO_HAY;
    for( IVector = 0; IVector < UVector; IVector++ )
    {
        if( Vector[IVector].u_valor < 2 )
            continue;
        compatibles = SI;
        for( int iprim  = 0; (iprim < Vector[IVector].u_valor) && (compatibles == SI );
          iprim++ )
            for( int jprim  = iprim + 1; (jprim < Vector[IVector].u_valor) && (compatibles == SI );
              jprim++ )
            {
                for( int iexc = 0; (iexc < Exclusion[ nivelactual ].u_papel) && (compatibles == SI); iexc++ )
                {
                    if( ((Vector[IVector].valor[iprim] == Exclusion[ nivelactual ].papel[iexc].A)
                      && (Vector[IVector].valor[jprim] == Exclusion[ nivelactual ].papel[iexc].B)) ||
                      ((Vector[IVector].valor[jprim] == Exclusion[ nivelactual ].papel[iexc].A)
                      && (Vector[IVector].valor[iprim] == Exclusion[ nivelactual ].papel[iexc].B)) )
                        compatibles = NO;
                }
            }
        if( compatibles == SI )
        {
        int ivalor ;
            // GENERA UN NODO Sol
            for( ivalor = 0; ivalor < Vector[IVector].u_valor; ivalor++ )
                Sol[uSol].papel[ ivalor ] = Vector[IVector].valor[ivalor];
            Sol[uSol].nivel = nivelactual;
            Sol[uSol].liga_or = NO_HAY;
            Sol[uSol].upapel = ivalor;
            Sol[uSol].apunta = NO_HAY; // APUNTA A QUIEN RESUELVE SUS REQUISITOS
            if( solAnterior != NO_HAY )
                Sol[solAnterior].liga_or = uSol;
            solAnterior = uSol;
            if( primerSol == NO_HAY )
            {
                primerSol = uSol;
                Sol[iSol].apunta = uSol;
            }
            uSol++;
        }
    }
    if( primerSol != NO_HAY )
        for( int isol = primerSol; isol < uSol; isol++ )
            GeneraArbol(isol);
}
//---------------------------------------------------------------------------
int HayPlan(int nivel)
{
int hay_nodo ;

    for( int inivel = 0; inivel <= nivel; inivel++ )
    {
        hay_nodo = NO;
        for( int isol = 0; (isol < uSol) && (hay_nodo == NO); isol++ )
        {
            if( Sol[isol].nivel == inivel )
                hay_nodo = SI;

        }
        if( hay_nodo == NO )
           return NO;
    }
    return SI;
}
//---------------------------------------------------------------------------

void __fastcall TFprimero::Button2Click(TObject *Sender)
{
  if (OpenDialog2->Execute())
  { // User clicked on OK.
    String nom_arch = OpenDialog2->FileName ;
    Tree1->LoadFromFile(nom_arch);
   // Label3->Caption = nom_arch;
  }

}
//---------------------------------------------------------------------------

void __fastcall TFprimero::Button1Click(TObject *Sender)
{
FILE *amei ;
char FmtReloj[50] ;


  if (OpenDialog3->Execute())
  {
    String nom_arch = OpenDialog3->FileName ;
    CargaEventosInesperados(nom_arch.c_str());

  }
}
//---------------------------------------------------------------------------


