//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "traduce.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFtraduce *Ftraduce;
// 71
//---------------------------------------------------------------------------
extern char NomArch[250] ;
//---------------------------------------------------------------------------
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <dos.h>
#include <string.h>
//---------------------------------------------------------------------------
// CONSTANTES DE LAS ESTRUCTURAS DE DATOS DEL ANALISIS LEXICO SINTACTICO
#define MAX_TIPO  30
#define MAX_ORACION  512
#define MAX_SIMBOLO  20
#define MAX_PALABRA 30
//---------------------------------------------------------------------------
// ELEMENTOS DE LA GRAMATICA
#define ES_TERMINAL  1
#define ES_VARIABLE  2
#define ES_SEMANTICA  3
//---------------------------------------------------------------------------
// CONSTANTES LOGICAS
#define SI  1
#define NO  0
#define NO_HAY  -1
// -----------------------------------------------------------------------
// ESTRUCTURAS PARA EL ANALIZADOR LEXICO/SINTACTICO
typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;                         // PALABRA
    char tipo[MAX_TIPO+1] ;                  // CATEGORIA GRAMATICAL
} TipoLexico ;

typedef struct
{
    char vari[MAX_TIPO+1];                                 // AXIOMA
    char des[25][MAX_TIPO+1];                          // PRODUCCION
} TipoGram;                 // TIPO DE LAS PRODUCCIONES GRAMATICALES

typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;
    char tipo[MAX_TIPO+1];                     // TIPO DE LA PALABRA
} TipoCanonica;              // TIPO DE LA ORACION DIVIDIDA EN SIMBOLOS

typedef struct
{
    int nivel;                            // NIVEL DE INTERPRETACION
    int accion;                              // NUMERO DE ACCION
    int param_1;                                       // PARAMETROS
    int param_2;
    int param_3;
} TipoAccion;

typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;                         // PALABRA
} TipoId ;

typedef struct
{
    char *cadena ;
} TipoCadena ;


typedef struct
{
    char simbolo[MAX_SIMBOLO+1] ;                         // PALABRA
} TipoNum ;


// -----------------------------------------------------------------------
// NOMBRES DE ARCHIVO:
extern char NomArchLex[] = "lia.lex" ;
extern char NomArchGram[] = "lia.grm" ;

// LINEA PARA PROCESAR REGISTROS
char Linea[MAX_ORACION + 1]
    ,*ALinea ;
char Palabra[MAX_PALABRA] ;
int IPalabra ,UPalabra ;

// LEXICO:
TipoLexico Lexico[50] ;
int ULexico ,ILexico ;

// GRAMATICA:
TipoGram gram[200] ;
int UGram ;

// ORACION:
char Oracion[MAX_ORACION + 1] ;
int IOracion ,UOracion ;

// ORACION CANONICA
int ICanonica, UCanonica ;

// TABLA DE ACCIONES DE INTERPRETACION:
TipoAccion Accion[2000] ;
int UAccion ,IAccion ;

TipoId Id[300] ;
int UId ,IId ;

char Valor[100][20] ;
int IValor, UValor ;
char ElArea[200] ;

FILE *canonico ,*texto ;

TipoCadena Cadena[200] ;
int UCadena ,ICadena ;

int CuentaWhile ;
int Pila[500] ;
int Tope ;

int CuentaIf ;
int PilaIf[500] ;
int TopeIf ;

TipoNum Numero[500] ;
int UNumero ,INumero ;

int PilaCond[500] ;
int TopeCond ;

char opers[6][8] = {{"C>"},{"C<"},{"C=="},{"C>="},{"C<="},{"C!="}};
int Lineas ;


//---------------------------------------------------------------------
//    PROTOTIPOS
void sim_CargaLexico( void );
void sim_CargaGramatica( void );
int sim_AnalisisLexico( char *nom_arch );
int sim_AnalisisSintactico( void );
int sim_Cumple( char *vari, int nivel );
int sim_AnalisisSemantico( void );
int sim_Rutina( char *num_rut, int nivel, int i_canonica );
//---------------------------------------------------------------------------
__fastcall TFtraduce::TFtraduce(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void sim_CargaLexico( void )
{
FILE *archivo ;

    // ABRE EL archivo DE LEXICO
    if( ( archivo = fopen( NomArchLex, "rt" ) ) == NULL )
    {
        sprintf(ElArea ,"**** Falta %s con palabras reservadas" ,NomArchLex );
        Ftraduce->Box1->Items->Add(ElArea);
        return;
    }
    // LEE EL REGISTRO DE CADA SIMBOLO LEXICO
    for(ULexico=0; fgets(Linea, MAX_ORACION, archivo) != NULL;)
    {
        // TOMA LA PALABRA
        strncpy( Lexico[ULexico].simbolo, Linea, MAX_SIMBOLO );
        ALinea = Lexico[ULexico].simbolo + MAX_SIMBOLO;
        // QUITA ESPACIOS FINALES:
        for(; *ALinea==' ' || *ALinea=='\0'; ALinea--)
            *ALinea = '\0';
        // TOMA EL TIPO
        strncpy(Lexico[ULexico].tipo ,Linea + MAX_SIMBOLO ,MAX_TIPO);
        ALinea = Lexico[ULexico].tipo + MAX_TIPO;
        // AVANZA A LA SIGUIENTE UNIDAD LEXICA
        ULexico++;
    }
    fclose( archivo );
}
//---------------------------------------------------------------------
void sim_CargaGramatica( void )
{
int cuenta, pasar, ides;
FILE *archivo ;

    // ABRE EL archivo DE GRAMATICA
    if( (archivo = fopen(NomArchGram ,"rt")) == NULL )
    {
        sprintf(ElArea ,"**** Falta el archivo de gramtica %s" ,NomArchGram);
        Ftraduce->Box1->Items->Add(ElArea);
    }
    // LEE CADA PRODUCCION DE LA GRAMATICA
    for( UGram=0; fgets(Linea ,MAX_ORACION ,archivo) != NULL; )
    {
        // SI ES COMENTARIO, SALTARLO:
        if( *Linea == ';' )
            continue;
        // QUITA EL  FINAL:
        if( Linea[strlen(Linea) - 1] == '\n' )
            Linea[strlen(Linea) - 1] = '\0';
        // APUNTA AL INICIO DE LA LINEA LEIDA:
        ALinea = Linea;
        // SALTA ESPACIOS:
        for( ; *ALinea == ' '; ALinea++ )
            ;
        // TOMA UN SIMBOLO
        for( cuenta = 0; *(ALinea + cuenta) != ' ' &&
            *(ALinea + cuenta) != '\0'; cuenta++ )
            ;
        pasar = ( cuenta > MAX_TIPO ) ? MAX_TIPO : cuenta;
        strncpy(gram[UGram].vari ,ALinea ,pasar);
        gram[ UGram ].vari[ pasar ] = '\0';
        ALinea += cuenta;
        // SALTA ESPACIOS:
        for( ; *ALinea == ' '; ALinea++ )
            ;
        // SALTA LA FLECHA:
        for(;*ALinea!=' ' && *ALinea != '\0';ALinea++)
            ;
        // SALTA ESPACIOS:
        for( ; *ALinea == ' '; ALinea++ )
            ;
        // TOMA LOS COMPONENTES DE LA PRODUCCION:
        for( ides = 0; *ALinea; )
        {
            // SALTA ESPACIOS:
            for( ; *ALinea == ' '; ALinea++ )
                ;
            // TOMA SIMBOLO:
            for( cuenta = 0; *(ALinea + cuenta) != ' ' &&
             *(ALinea + cuenta) != '\0'; cuenta++ )
                ;
            if( cuenta > 0 )
            {
                pasar = ( cuenta > MAX_TIPO ) ? MAX_TIPO : cuenta;
                strncpy(gram[UGram].des[ides], ALinea, pasar);
                gram[UGram].des[ides][pasar] = '\0';
                ides++;
                ALinea += cuenta;
            }
        }
        // MARCA EL FIN DE LA PRODUCCION CON \0
        gram[UGram].des[ides][0] = '\0';
        UGram++;
    }

    fclose(archivo);
}
//---------------------------------------------------------------------
int BuscaLexico(char *palabra)
{
int esta ;

    esta = NO_HAY;
    for( ILexico = 0; (ILexico < ULexico) && (esta == NO_HAY); ILexico++ )
    {
        if( strcmp(Lexico[ILexico].simbolo ,palabra) == 0 )
            esta = ILexico;
    }
    return esta;
}

//---------------------------------------------------------------------
int sim_SimboloDefinido(char *palabra)
{
int esta ;

    esta = NO_HAY;
    for( IId = 0; (IId < UId) && (esta == NO_HAY); IId++ )
    {
        if( strcmp(Id[IId].simbolo ,palabra) == 0 )
            esta = IId;
    }
    if( esta == NO_HAY )
    {
        esta = UId;
        strcpy(Id[esta].simbolo ,palabra);
        UId++;
    }
    return esta;
}
void sim_GuardaCanonica(char *simbolo ,char *tipo)
{
TipoCanonica canonica;
int i , u ;

    u = sizeof(TipoCanonica);
    for( i = 0; i < u; i++ )
        ((char *)&canonica)[i] = '\0';
    strcpy(canonica.simbolo ,simbolo);
    strcpy(canonica.tipo ,tipo);
    fseek(canonico ,UCanonica * sizeof(TipoCanonica) ,SEEK_SET);
    fwrite((char *)&canonica ,sizeof(TipoCanonica) ,1 ,canonico);
    UCanonica++;
    fprintf(texto ,"%s (%s)\n",canonica.simbolo ,canonica.tipo);

}

//---------------------------------------------------------------------
int sim_SeparaSimbolos(char *oracion)
{
char numero[30] ,simbolo[5] ;
char palabra[50] ;
int ip ,up ;
char constante[250] ;
int ic ,uc ;
int i_num ,i_oracion ,u_oracion ,cual ;
int bien ;


    bien = SI;
    u_oracion = strlen(oracion);
    for( i_oracion = 0; i_oracion < u_oracion; )
    {
        // SALTA ESPACIOS
        if( oracion[i_oracion] == ' ')
        {
            i_oracion++;
            continue;
        }
        // ES NUMERO, HORA O FECHA
        if( isdigit(oracion[i_oracion]) )
        {
            // ES HORA
            if( oracion[i_oracion + 2] == ':' )
            {
                if( oracion[i_oracion + 5] == ':' )
                {
                    strncpy(numero ,oracion + i_oracion ,8);
                    numero[8] = '\0';
                    i_oracion += strlen(numero);
                    sim_GuardaCanonica(numero ,"hora");
                    continue;
                }
            }
            else
            {
                for( i_num = 0; isdigit(oracion[i_oracion]); i_oracion++, i_num++ )
                {
                    numero[i_num] = oracion[i_oracion];
                    numero[i_num + 1] = '\0';
                }
                if( oracion[i_oracion] == '.' )
                {
                    numero[i_num] = oracion[i_oracion];
                    numero[i_num + 1 ] = '\0';
                    i_num++;
                    i_oracion++;
                    for( ; isdigit(oracion[i_oracion]); i_oracion++, i_num++ )
                    {
                        numero[i_num] = oracion[i_oracion];
                        numero[i_num + 1] = '\0';
                    }
                }
                // GUARDA EL NUMERO
                sim_GuardaCanonica(numero ,"numero");
                continue;
            }
        }
        // ES CONSTANTE CADENA
        if( oracion[i_oracion] == '\"' )
        {
            i_oracion++;
            for( uc = 0; (oracion[i_oracion] != '\"') && (oracion[i_oracion] != '\0');
                 i_oracion++ )
            {
                constante[uc++] = oracion[i_oracion];
                constante[uc] = '\0';
            }
            i_oracion++;
            Cadena[UCadena].cadena = (char *)malloc(strlen(constante) + 1);
            strcpy(Cadena[UCadena].cadena ,constante);
            sprintf(palabra ,"%d", UCadena);
            UCadena++;
            sim_GuardaCanonica(palabra ,"cadena");
            continue;
        }
        // ES PALABRA RESERVADA O IDENTIFICADOR
        if( (oracion[i_oracion] >= 'A') && (oracion[i_oracion] <= 'Z')
            || (oracion[i_oracion] >= 'a') && (oracion[i_oracion] <= 'z')
            )
        {
            for( up = 0; ((oracion[i_oracion] >= 'A') && (oracion[i_oracion] <= 'Z'))
                      || ((oracion[i_oracion] >= 'a') && (oracion[i_oracion] <= 'z'))
                      || (isdigit(oracion[i_oracion]))
                      || (oracion[i_oracion] == '_');
                i_oracion++ )
            {
                 palabra[up++] = oracion[i_oracion];
                 palabra[up] = '\0';
            }
            // DETERMINA SI ES PALABRA RESERVADA
            cual = BuscaLexico(palabra);
            if( cual != NO_HAY )
            {
                if( strcmp(palabra ,"true") == 0 )
                    sim_GuardaCanonica("1" ,"numero");
                else
                    if( strcmp(palabra ,"false") == 0 )
                        sim_GuardaCanonica("0" ,"numero");
                    else
                        sim_GuardaCanonica(palabra ,palabra);
                continue;
            }
            else
            // DETERMINA SI ES IDENTIFICADOR CONOCIDO Y SINO DARLO DE ALTA
            //if( cual == NO_HAY )
            {
                cual = sim_SimboloDefinido(palabra);
                sprintf(palabra ,"%d", cual);
                sim_GuardaCanonica(palabra ,"id");
                continue;
            }
            continue;
        }
        if( (oracion[i_oracion] == '&') && (oracion[i_oracion + 1] == '&') )
        {
            simbolo[0] = oracion[i_oracion];
            simbolo[1] = oracion[i_oracion + 1];
            simbolo[2] = '\0';
            i_oracion+=2;
            sim_GuardaCanonica(simbolo ,(AnsiString("s") + AnsiString(simbolo)).c_str());
            continue;
        }

        if( (oracion[i_oracion] == '|') && (oracion[i_oracion + 1] == '|') )
        {
            simbolo[0] = oracion[i_oracion];
            simbolo[1] = oracion[i_oracion + 1];
            simbolo[2] = '\0';
            i_oracion+=2;
            sim_GuardaCanonica(simbolo ,(AnsiString("s") + AnsiString(simbolo)).c_str());
            continue;
        }
        if( (oracion[i_oracion] == ':') && (oracion[i_oracion + 1] == '=') )
        {
            simbolo[0] = oracion[i_oracion];
            simbolo[1] = oracion[i_oracion + 1];
            simbolo[2] = '\0';
            i_oracion+=2;
            sim_GuardaCanonica(simbolo ,(AnsiString("s") + AnsiString(simbolo)).c_str());
            continue;
        }

        // ES SIMBOLO {} [] + * -  / = == >= <= != . '

        switch(oracion[i_oracion])
        {
        case '+': case '*': case '-': case '/':
        case '.': case '\'': case '{': case '}': case ',':
        case '[': case ']': case ';': case '(': case ')':
            simbolo[0] = oracion[i_oracion];
            simbolo[1] = '\0';
            i_oracion++;
            sim_GuardaCanonica(simbolo ,(AnsiString("s") + AnsiString(simbolo)).c_str());
            continue;
            break;
        }
        if( (oracion[i_oracion] == '=') || (oracion[i_oracion] == '>') || (oracion[i_oracion] == '<') || (oracion[i_oracion] == '!') )
        {
             if( oracion[i_oracion + 1] == '=' )
             {
                 simbolo[0] = oracion[i_oracion];
                 simbolo[1] = oracion[i_oracion + 1];
                 simbolo[2] = '\0';
                 i_oracion+=2;
             }
             else
             {
                 simbolo[0] = oracion[i_oracion];
                 simbolo[1] = '\0';
                 i_oracion++;
             }
             sim_GuardaCanonica(simbolo ,(AnsiString("s") + AnsiString(simbolo)).c_str());
             continue;
        }
        else
        {
            simbolo[0] = oracion[i_oracion];
            simbolo[1] = '\0';
            i_oracion++;
            bien = NO;
            Ftraduce->Box1->Items->Add(AnsiString("ERROR simbolo desconocido ") + AnsiString(simbolo));
        }
    }
    return bien;
}
//---------------------------------------------------------------------
// DIVIDE EL ARCHIVO EN TOKENS Y LO ALMACENA EN CANONICA
int sim_AnalisisLexico(char *nom_arch)
{
FILE *archivo;
int resultado ;
int u, i ;


                                       // ABRE EL archivo A INTERPRETAR
    if( (archivo = fopen(nom_arch ,"rt")) == NULL )
        return NO_HAY;
    if( (canonico = fopen("canonico.tmp" ,"wb")) == NULL )
    {
        sprintf(ElArea ,"**** hay alguna falla en el disco");
        Ftraduce->Box1->Items->Add(ElArea);
    }

    if( (texto = fopen("canonico.joc" ,"wt")) == NULL )
    {
        sprintf(ElArea ,"**** hay alguna falla en el disco");
        Ftraduce->Box1->Items->Add(ElArea);
    }


    UCadena = 0;
    UCanonica = 0;                      // INICIALIZA TABLA DE SIMBOLOS
    resultado = SI;
    UId = 0;
    UValor = 0;
    Lineas = 0;
    for( ; (fgets(Linea ,MAX_ORACION ,archivo) != NULL) && (resultado == SI); )
    {
        Lineas++;
        Ftraduce->Edit1->Text = Lineas;
        Ftraduce->Edit1->Refresh();

        if( Linea[strlen(Linea) - 1] == '\n' )     // QUITA EL  FINAL
            Linea[strlen(Linea) - 1] = '\0';
        u = strlen(Linea);
        for( i = 0; i < u; i++ )
        {
            if( (Linea[i] == '\/') && (Linea[i + 1] == '\/') )
            {
                Linea[i] = '\0';
                break;
            }
        }
        //Ftraduce->Box1->Items->Add(Linea);
        if( sim_SeparaSimbolos(Linea) == NO )
            resultado = NO;
    }
    fclose(archivo);
    fclose(canonico);
    fclose(texto);
    return resultado;
}

//---------------------------------------------------------------------
int sim_AnalisisSintactico( void )
{

    if( (canonico = fopen("canonico.tmp" ,"rb")) == NULL )
    {
        sprintf(ElArea ,"**** hay alguna falla en el disco");
        Ftraduce->Box1->Items->Add(ElArea);
    }
    Tope = 0;
    TopeIf = 0;
    CuentaWhile = 0;
    CuentaIf = 0;

    ICanonica = 0;
    UAccion = 0;
//   if( (sim_Cumple("INICIO", 1) == SI) && (ICanonica == UCanonica) )
   if( sim_Cumple("INICIO", 1) == SI )
   {
       fclose(canonico);
       return SI;
   }
   else
   {
       fclose(canonico);
       return NO;
   }




}

//---------------------------------------------------------------------
int sim_QueEs( char simbolo_inicial )
{
    if( islower(simbolo_inicial) )
        return ES_TERMINAL;
    if( isupper(simbolo_inicial) )
        return ES_VARIABLE;
    if( isdigit(simbolo_inicial) )
        return ES_SEMANTICA;
    return NO;
}
void sim_LeeCanonica(int cual ,TipoCanonica *canonica)
{
    fseek(canonico ,cual * sizeof(TipoCanonica) ,SEEK_SET);
    fread((char *)canonica ,sizeof(TipoCanonica) ,1 ,canonico);
}
//---------------------------------------------------------------------
int sim_Terminal( char *tipo_simb )
{
TipoCanonica canonica ;

    sim_LeeCanonica(ICanonica ,&canonica);

    if( ICanonica < UCanonica )
    {
        if( strcmp(canonica.tipo ,tipo_simb) == 0 )
        {
            ICanonica++;
            return SI;
        }
    }
    return NO;
}
//---------------------------------------------------------------------
// BUSCA LA PRODUCCION QUE INICIA CON VARIABLE
int sim_BuscaProduccion(char *variable, int i_gram)
{
int existe;

    for( existe = NO; !existe && i_gram < UGram; i_gram++ )
        if( strcmp(gram[i_gram].vari ,variable) == 0 )
            return i_gram;
    return NO_HAY;
}

//---------------------------------------------------------------------
void sim_Restablece( int nivel )
{
    while( (UAccion > 0) && (Accion[UAccion - 1].nivel >= nivel) )
        UAccion--;
}

//---------------------------------------------------------------------
int sim_Cumple( char *vari, int nivel )
{
char *simb_act;                                    // SIMBOLO EN PROCESO
int resul ,fin;                        // INDICADORES DE RESULTADO Y FIN
long i_canonica_ant;    // APUNTADOR A LA ENTRADA CUANDO INICIA EL NIVEL
int i_gram;
double pct ;
double xyz ;

    if( (i_gram = sim_BuscaProduccion(vari ,0)) == NO_HAY )
        return NO;

    i_canonica_ant = ICanonica;
    simb_act = (char *)gram[i_gram].des;
    for( resul = SI, fin = NO; !fin && (*simb_act != ' ') && (*simb_act != '\0'); )
    {
       switch( sim_QueEs(*simb_act) )
        {
        case ES_TERMINAL:
            resul = sim_Terminal(simb_act);
            break;
        case ES_VARIABLE:
            resul = sim_Cumple(simb_act ,nivel + 1);
            if( resul == SI )          // ACCION PARA BLOQUEAR RETROCESO
            {
                Accion[UAccion].nivel = nivel;
                Accion[UAccion].accion = 0;
                UAccion++;
            }
            break;
        case ES_SEMANTICA:
            resul = sim_Rutina(simb_act ,nivel ,ICanonica - 1);
            break;
        default:
            fin = SI;
            resul = NO;
            break;    // SIMBOLO ERRONEO
        }
        if( fin == SI )
            break;
        if( resul == NO )
        {
            sim_Restablece(nivel);    // RESTABLECE Y BUSCA ALTERNATIVA
            i_gram = sim_BuscaProduccion(vari, i_gram + 1);
            if( i_gram == NO_HAY )     // SI NO HAY OPCION, TERMINA MAL
            {
                fin = SI;
            }
            else
            {                    // SI HAY, VUELVE A EMPEZAR LA REVISION
                simb_act = (char *)gram[i_gram].des;
                ICanonica = i_canonica_ant;
                resul = SI;
            }
        }
        else
            simb_act += (MAX_TIPO + 1);   // AVANZA AL SIGUIENTE SIMBOLO
    }
    if( resul == NO )
        sim_Restablece(nivel);

    pct = (double)ICanonica / (double)UCanonica * (double)100;
    if( ((int)pct % 10) == 0 )
    {
        Ftraduce->Edit2->Text = (int)pct;
        Ftraduce->Edit2->Refresh();
    }

    return resul;
}
//---------------------------------------------------------------------
// GENERACION DE CODIGO DE ACUERDO CON LAS INSTRUCCIONES
int sim_AnalisisSemantico( void )
{
FILE *sale ;
char ambito ,tipo ;
int ultimo_while ;
int asignar ,indice ;
char resultado[100] ;

    sale = fopen("prog.asm" ,"wt");
    if( sale == NULL )
    {
        return NO;
    }
    for( IAccion = 0; IAccion < UAccion; IAccion++ )
    {
        switch( Accion[IAccion].accion )
        {
        // VARIABLES GLOBALES
        case 1: ambito = 'G'; break;

        //VARIABLES REGIONALES
        case 49: ambito = 'R'; break;  // DECLARACION GLOBAL

        // LISTA DE VARIABLES
        case 2: tipo = 'E'; break;
        case 3: tipo = 'A'; break;
        case 4: tipo = 'F'; break;
        case 13: tipo = 'P'; break;
        case 5: fprintf(sale ,"%c %c %s %d %d\n" ,ambito ,tipo,
            Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2
            ,Accion[IAccion].param_3);
            break;
        case 6: fprintf(sale ,"%c %c %s %d 0\n" ,ambito ,tipo,
            Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2);
            break;
        case 7: fprintf(sale ,"%c %c %s 0 0\n"  ,ambito ,tipo,
            Id[Accion[IAccion].param_1].simbolo);
            break;

        // COMPONENTES DE UN AGENTE
        case 11: fprintf(sale ,"A %s\n" , Id[Accion[IAccion].param_1].simbolo);
            break;
        case 8: ambito = 'R'; break;  // REGIONAL
        case 9: ambito = 'I'; break;  // INTERNA
        case 10: fprintf(sale ,"P %s\n" , Id[Accion[IAccion].param_1].simbolo);
            break;  // PROPOSITO
        case 71: fprintf(sale ,"INICIO\n"); break; // METODO: INICIO
        case 27: fprintf(sale ,"STOP\n"); break; // METODO: FINAL

        // MAIN
        case 15: fprintf(sale ,"m main\n"); break;

        // METODO
        case 12: fprintf(sale ,"M %s\n" , Id[Accion[IAccion].param_1].simbolo);
            break;
        case 19: fprintf(sale ,"Rq %s\n" , Id[Accion[IAccion].param_1].simbolo);
            break;

        // VARIABLES LOCALES
        case 14: ambito = 'L'; break;

        // INSTRUCCIONES DE UN METODO
        // IF-THEN-ELSE

        // IF-THEN
        case 44:
            fprintf(sale ,"CMP R 0\nJEQ finif%d\n",Accion[IAccion].param_1);
            break;
        case 45:
            fprintf(sale ,":finif%d\n",Accion[IAccion].param_1);
            break;

        // OPTIONAL
        case 26: fprintf(sale ,"opt: "); break;

        // PRINT CADENA
        case 22: fprintf(sale ,"Pr $%d\n" ,Accion[IAccion].param_1); break;

        // PRINT VARIABLE


        // AGENT CREATE
        case 20: fprintf(sale ,"CREAA %s %s\n"
            ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo); break;

        // INTERACTION CREATE
        case 21: fprintf(sale ,"CREAI %s %s\n"
            ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo); break;
        case 16: fprintf(sale ,"i %s\n" , Id[Accion[IAccion].param_1].simbolo);
            break;
        case 17: fprintf(sale ,"Ro %s\n" , Id[Accion[IAccion].param_1].simbolo);
            break;
        case 18: fprintf(sale ,"c %d\n" , Accion[IAccion].param_1); break;



        // ADD PURPOSE

        // WHILE
        case 42: fprintf(sale ,"CLRSTK\n"); break; // LIMPIA EL STACK
        case 23: // inicio while
            fprintf(sale ,":whi%d\n",Accion[IAccion].param_1);
            ultimo_while = Accion[IAccion].param_1; break;
        case 24: // fin while
            fprintf(sale ,"JMP whi%d\n:finw%d\n"
            ,Accion[IAccion].param_1,Accion[IAccion].param_1); break;
        case 31: fprintf(sale ,"POPs R\nCMP R 0\nJEQ finw%d\n", ultimo_while);
            break;

        // OUT
        case 25: fprintf(sale ,"out\n"); break;

        // ACCEPT
        case 66:
            fprintf(sale ,"ACCEPT\nMOV %s VARIABLE\nMOV %s RESULTADO\n"
            ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo); break;

        // WAIT
        case 48:
            fprintf(sale ,"WAIT %d\n",Accion[IAccion].param_1);
            break;

        // GOAL

        // EXPRESION ARITMETICA
        case 37: fprintf(sale ,"POPs tA\nPOPs tB\nSUMA tA tB\nPUSHs R\n");
            break;
        case 38: fprintf(sale ,"POPs tA\nPOPs tB\nRESTA tA tB\nPUSHs R\n");
            break;
        case 39: fprintf(sale ,"POPs tA\nPOPs tB\nMULT tA tB\nPUSHs R\n");
            break;
        case 40: fprintf(sale ,"POPs tA\nPOPs tB\nDIV tA tB\nPUSHs R\n");
            break;
        case 33: fprintf(sale ,"PUSHn %d\n",Accion[IAccion].param_1); break;
        case 72: fprintf(sale ,"PUSHvij %s %s %s\n"
            ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo
            ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 73: fprintf(sale ,"PUSHvi %s %s\n"
            ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 74: fprintf(sale ,"PUSHv %s\n"
            ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 75: sprintf(resultado ,"POPvb %s %s %s\n"
            ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo
            ,Id[Accion[IAccion].param_3].simbolo);
            break;
        case 76: sprintf(resultado ,"POPvu %s %s\n"
            ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 77: sprintf(resultado ,"POPv %s\n"
            ,Id[Accion[IAccion].param_1].simbolo);
            break;
        case 79: // FIN DE EXPRESION ARITMETICA
            fprintf(sale ,"%s" ,resultado); break;


        // EXPRESION ALFABETICA
        case 80: fprintf(sale ,"MOVviS %s %d $%d\n"
            ,Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2
            ,Accion[IAccion].param_3); break;



        // EXPRESION LOGICA
        case 82: // OR
            fprintf(sale ,"POPs tA\nPOPs tB\nOR tA tB\nPUSHs R\n");
            break;
        case 83: // AND
            fprintf(sale ,"POPs tA\nPOPs tB\nAND tA tB\nPUSHs R\n");
            break;
        case 84: // OPERADOR RELACIONAL
            fprintf(sale ,"POPs tA\nPOPs tB\n%s tA tB\nPUSHs R\n" ,
                opers[Accion[IAccion].param_1 - 1]);
            break;





        // *************************************
        case 28:
            fprintf(sale ,"< %s %s\n",Id[Accion[IAccion].param_1].simbolo,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 29:
            fprintf(sale ,"> %s %s\n",Id[Accion[IAccion].param_1].simbolo,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 69:
            fprintf(sale ,"== %s %s\n",Id[Accion[IAccion].param_1].simbolo,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 70:
            fprintf(sale ,"!= %s %s\n",Id[Accion[IAccion].param_1].simbolo,Id[Accion[IAccion].param_2].simbolo);
            break;
        case 67:
            fprintf(sale ,"> %s %d\n",Id[Accion[IAccion].param_1].simbolo,Accion[IAccion].param_2);
            break;
        case 30: fprintf(sale ,"== %s 1\n",Id[Accion[IAccion].param_1].simbolo); break;
        case 68: fprintf(sale ,"== %s 0\n",Id[Accion[IAccion].param_1].simbolo); break;
        case 32: asignar = Accion[IAccion].param_1; break;
        case 52: asignar = Accion[IAccion].param_1;
                indice = Accion[IAccion].param_2;
                break;

        case 36: fprintf(sale ,"PUSH %s\n",Id[Accion[IAccion].param_1].simbolo); break;
        case 41: fprintf(sale ,"POP %s\n" ,Id[asignar].simbolo); break;

        case 43: fprintf(sale ,"MOV %s %s\n" ,Id[Accion[IAccion].param_2].simbolo ,Cadena[ Accion[IAccion].param_1 ].cadena); break;
        case 46:
            fprintf(sale ,"CLRSTK\nPUSH 1\nPOP %s\n",Id[Accion[IAccion].param_1].simbolo);
            break;
        case 47:
            fprintf(sale ,"CLRSTK\nPUSH 0\nPOP %s\n",Id[Accion[IAccion].param_1].simbolo);
            break;
        case 50:
            fprintf(sale ,"MOV@C %s %d ",Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2); break;
        case 51:
            fprintf(sale ,"%s\n" ,Cadena[ Accion[IAccion].param_1 ].cadena); break;
        case 53:
            fprintf(sale ,"POP@ %s %d\n" ,Id[asignar].simbolo ,indice); break;
        case 54:
            fprintf(sale ,"MOV_@ %s " ,Id[Accion[IAccion].param_1].simbolo); break;
        case 55:
            fprintf(sale ,"%s %s\n" ,Id[Accion[IAccion].param_1].simbolo ,Id[Accion[IAccion].param_2].simbolo); break;
        case 56:
            fprintf(sale ,"MOV_@ PUERTO %s %d\n" ,Id[Accion[IAccion].param_2].simbolo ,Accion[IAccion].param_1); break;
        case 57:
            fprintf(sale ,"MOV_@ PUERTO %s %s\n" ,Id[Accion[IAccion].param_2].simbolo ,Id[Accion[IAccion].param_1].simbolo); break;
        case 58:
            fprintf(sale ,"MOV PUERTO %s\n" ,Id[Accion[IAccion].param_1].simbolo); break;
        case 59:
            fprintf(sale ,"MOV EMISOR %s\n" ,Id[Accion[IAccion].param_1].simbolo); break;
        case 60:
            fprintf(sale ,"MOV EMISOR self\n"); break;
        case 61:
            fprintf(sale ,"MOV VARIABLE %s\n" ,Cadena[Accion[IAccion].param_1].cadena); break;
        case 62:
            fprintf(sale ,"MOV VALOR %s\n" ,Id[Accion[IAccion].param_1].simbolo); break;
        case 63:
            fprintf(sale ,"MOV VALOR 1\n"); break;
        case 64:
            fprintf(sale ,"MOV VALOR 0\n"); break;
        case 65:
            fprintf(sale ,"MOV TIEMPO %s\n" ,Id[Accion[IAccion].param_1].simbolo); break;

        case 78: sprintf(resultado ,"POPvU %s %d\n"
            ,Id[Accion[IAccion].param_1].simbolo ,Accion[IAccion].param_2);
            break;

        case 81:
            fprintf(sale ,"APROP %s %s\n" ,Id[Accion[IAccion].param_1].simbolo
            ,Id[Accion[IAccion].param_2].simbolo); break;


       }
    }
    fclose(sale);
}
//---------------------------------------------------------------------
int sim_Rutina( char *num_rut, int nivel, int i_canonica )
{
TipoCanonica canonica ;
int cualw ,cualif ;
char perror[200] ;


    if( atoi(num_rut) > 999 )
    {
    sprintf(perror ,"Error %d" ,atoi(num_rut));
    Ftraduce->Box1->Items->Add(perror);
    return SI;
    }

    Accion[UAccion].nivel = nivel;
    Accion[UAccion].accion = atoi(num_rut);
    switch( atoi(num_rut) )
    {
    // GLOBAL
    case 1:
        break;

    // REGIONAL
    case 49:
        break;

    // LISTA DE VARIABLES
    case 2: case 3: case 4: case 13:
        break;

    case 5: // LISTA DE VARIABLES: TOMA VARIABLE CON DOS INIDICES
    case 72:
    case 75:
    case 80: // EXPRESION CADENA MUEVE v[i] = cadena
        sim_LeeCanonica(ICanonica - 7 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 5 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 2 ,&canonica);
        Accion[UAccion].param_3 = atoi(canonica.simbolo);
        break;


    case 6: // LISTA DE VARIBLES: TOMA VARIABLE CON UN INDICE
    case 73:
    case 76:
    case 78:
        sim_LeeCanonica(ICanonica - 4 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 2 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        break;

    case 7: // LISTA DE VARIABLES: TOMA VARIABLE ATOMICA
    case 11: // AGENTE: NOMBRE
    case 10: // PROPOSITO
    case 12: // PAPEL AGENTE
    case 16: // INTERACCION
    case 17: // PAPEL INTERACCION
    case 19: // REQUISITO
    case 18: // CUPO
    case 22: // INSTRUCCION: PRINT
    case 36:
    case 61:
    case 62:
    case 65:
    case 74:
    case 77:
        sim_LeeCanonica(ICanonica - 1 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;

    case 8: // REGIONAL
    case 9:  // AGENTE INTERNA
    case 14: // INTERACCION LOCAL
    case 15: // MAIN
    case 25:
    case 26:
    case 27: // METODO: FIN (STOP)
    case 31: // INSTRUCCION WHILE CMP
    case 37: // INSTRUCCION SUMA
    case 38: // INSTRUCCION RESTA
    case 39: // INSTRUCCION DIVIDE
    case 40:
    case 42: // INSTRUCCION EXPRESION ARITMETICA
    case 53:
    case 60:
    case 71: // METODO: INICIO
    case 79: // INSTRUCCION FIN DE EXPRESION ARITMETICA
    case 82: // EXPRESION LOGICA: OR
    case 83: // EXPRESION LOGICA: AND
        break;


    // WHILE
    case 23: // while inicio
        Pila[Tope] = CuentaWhile;
        Tope++;
        CuentaWhile++;
        Accion[UAccion].param_1 = CuentaWhile - 1;
        break;
    case 24: // while fin
        Tope--;
        cualw = Pila[Tope];
        Accion[UAccion].param_1 = cualw;
        break;
    case 91: // while topecond
        TopeCond = 0;
        break;

    // EXPRESION LOGICA
    case 84:  // OPERADOR RELACIONAL
        TopeCond--;
        Accion[UAccion].param_1 = PilaCond[TopeCond];
        break;
    case 85:  PilaCond[TopeCond] = 1; TopeCond++; break;
    case 86:  PilaCond[TopeCond] = 2; TopeCond++; break;
    case 87:  PilaCond[TopeCond] = 3; TopeCond++; break;
    case 88:  PilaCond[TopeCond] = 4; TopeCond++; break;
    case 89:  PilaCond[TopeCond] = 5; TopeCond++; break;
    case 90:  PilaCond[TopeCond] = 6; TopeCond++; break;


    // INSTRUCCION IF
    case 44:
        PilaIf[TopeIf] = CuentaIf;
        TopeIf++;
        CuentaIf++;
        Accion[UAccion].param_1 = CuentaIf - 1;
        break;
    case 45:
        TopeIf--;
        cualif = PilaIf[TopeIf];
        Accion[UAccion].param_1 = cualif;
        break;


    case 30:
    case 48: // INSTRUCCION: WAIT
    case 68:
        sim_LeeCanonica(ICanonica - 3 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;

    case 20: // AGENTE CREA
    case 21: // INTERACCION CREA
    case 81: // AGENTE ADICIONA PROPOSITO
        sim_LeeCanonica(ICanonica - 3 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 5 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;

    case 33:  // EXPRESION ARITMETICA: NUMERO
    case 51:
    case 58:
    case 59:
        sim_LeeCanonica(ICanonica - 1 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;

// *****************************************

    case 28: case 29: case 55: case 66: case 67: case 69: case 70:
        sim_LeeCanonica(ICanonica - 1 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 3 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;
    case 46: case 47:
        sim_LeeCanonica(ICanonica - 4 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;


    case 32: case 54:
        sim_LeeCanonica(ICanonica - 2 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;
    case 43: case 56: case 57:
        sim_LeeCanonica(ICanonica - 4 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 2 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;
    case 50:
        sim_LeeCanonica(ICanonica - 3 ,&canonica);
        Accion[UAccion].param_2 = atoi(canonica.simbolo);
        sim_LeeCanonica(ICanonica - 5 ,&canonica);
        Accion[UAccion].param_1 = atoi(canonica.simbolo);
        break;


    case 200: Ftraduce->Box1->Items->Add("EL ERROR DE SINTAXIS"); break;
    }
    UAccion++;
    return SI;
}
//---------------------------------------------------------------------

void __fastcall TFtraduce::ACEPTARClick(TObject *Sender)
{
    Ftraduce -> Close();
}
//---------------------------------------------------------------------------


void __fastcall TFtraduce::inicio(TObject *Sender)
{
    Ftraduce->Refresh();
    Edit1->Text = "";
    UId = 0;
    Box1->Clear();
    Box1->Items->Add("Inicio la traduccin");
    Box1->Refresh();

    sim_CargaLexico();
    Box1->Items->Add("Palabras reservadas... bien");
    Box1->Refresh();

    sim_CargaGramatica();
    Box1->Items->Add("Gramtica... bien");
    Box1->Refresh();
    switch( sim_AnalisisLexico(NomArch) )
    {
    case NO:
         Ftraduce->Box1->Items->Add("**** Hay simbolos desconocidos");
         return;
    case NO_HAY:
         Ftraduce->Box1->Items->Add("**** No existe el archivo");
         return;
    }
    Box1->Items->Add("Traducido... bien");
    Box1->Refresh();
    // AHORA APLICA EL ANALISIS SINTACTICO
    switch( sim_AnalisisSintactico() )
    {
    case NO:
         Ftraduce->Box1->Items->Add("**** Error de sintaxis");
         return;
    }
    Box1->Items->Add("Sintaxis correcta");
    Box1->Refresh();
    sim_AnalisisSemantico();
}
//---------------------------------------------------------------------------

